#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>

using namespace std;

void solveE() {
	set<int32_t> sorted;
	vector<vector<int32_t>> data;
	map<int32_t, pair<int32_t, int32_t>> pos;
	int32_t n, t;
	cin >> n;
	data.resize(n);
	int32_t i = 0;
	for (auto& v : data) {
		cin >> t;
		int32_t j = 0;
		v.resize(t);
		for (auto& u : v) {
			cin >> u;
			sorted.insert(u);
			pos[u] = { i, j };
			j++;
		}
		i++;
	}

	i = 0;
	for (auto v : sorted) {
		auto p = pos[v];
		data[p.first][p.second] = i;
		i++;
	}

	int32_t s = 0, u = n;
	for (auto &v : data) {
		int32_t i = 0;
		while (i < v.size() - 1) {
			i++;
			while (i < v.size() && v[i - 1] + 1 == v[i]) {
				i++;
			}
			if (i != v.size()) {
				s++;
				u++;
			}
		}
	}
	cout << s << ' ' << u - 1;
}

void solveF() {
	int32_t n, a, e;
	cin >> n >> a >> e;
	int32_t i = 0;
	int32_t d = 0;
	vector<pair<int32_t,int32_t>> ret;
	while (i < n - 1 && (a != 0 || e != 0)) {
		if (a > e) {
			a--;
			ret.push_back({ 1, 0 });
		}
		else {
			e--;
			ret.push_back({ 0, 1 });
		}
		i++;
	}
	if (a == e && a != 0) {
		if (ret.size() > 0) {
			if (ret.back().first > 0) {
				ret.back().first++;
				a--;
			}
			else {
				ret.back().second++;
				e--;
			}
		}
	}
	while (i < n)
	{
		if (a == e) {
			d++;
		}
		ret.push_back({ a, e });
		a = 0;
		e = 0;
		i++;
	}
	cout << d << '\n';
	for (auto v : ret) cout << v.first << ':' << v.second << '\n';
}

void solveK() {
	int32_t n, k;
	cin >> n >> k;
	if (n == k || n == 1) {
		cout << "NO\n";
		return;
	}
	cout << "YES\n";
	if (k == 1) {
		cout << n << '\n';
		for (int32_t i = 1; i < n; i++) {
			cout << i << ' ' << i + 1 << '\n';
		}
		cout << 1 << ' ' << n << '\n';
		return;
	}

	bool ok = false;
	if (k % 2 == 1) {
		ok = true;
		n--;
		k--;
	}

	vector<set<int32_t>> ret(n+1);
	int32_t s = 0;
	int32_t i = 0;
	while (s < k) {
		for (int32_t j = 1; j < n - i; j++) {
			ret[n - i].insert(j);
		}

		for (int32_t j = n; j > n - i; j--) {
			//for (int32_t u = 1; u < i + 1; u++) {
				ret[j].erase(i + 1);
			//}
		}
		s += 2;
		i += 1;
	}
/*
		for (int64_t i = 1; i <= n; ++i) {
			ret[i].insert(1 + (i) % n);
		}


	for (int64_t i = n; i > n - k + 1; --i) {
		for (int64_t j = 0; j < n - i + 1; ++j)
			ret[i].insert((i + 2 + j) % n);
	}*/

	if (ok) {
		ret.push_back({});
		for (int32_t j = 0; j < i + 1; j++) {
			ret.back().insert(n - j);
		}
		n++;
	}
	int32_t acc = 0;
	for (int32_t i = 1; i <= n; i++) {
		for (auto v : ret[i]) {
			acc++;
		}
	}
	cout << acc << '\n';
	for (int32_t i = 1; i <= n; i++) {
		for (auto v : ret[i]) {
			cout << i << ' ' << v << '\n';
		}
	}

	//vector<int32_t> edges(n + 1);

	//for (int32_t i = 1; i <= n; i++) {
	//	for (auto v : ret[i]) {
	//		edges[i]++;
	//		edges[v]++;
	//	}
	//}
	//set<int32_t> qwe;
	//for (auto v : edges) qwe.insert(v);

	//cout << qwe.size() - 1;
}

void solveA() {
	int64_t t;
	cin >> t;
	while (t--) {
		int64_t n;
		cin >> n;
		vector<int64_t> a(n);
		vector<int64_t> q(n, -1);
		vector < int64_t> p(n);
		vector<int64_t> inv_a(n);

		for (int64_t i = 0; i < n; ++i) {
			cin >> a[i];
			a[i]--;
			inv_a[a[i]] = i;
		}		

		if (n < 3) {
			cout << "Impossible" << endl;
			continue;
		}
			

		for(int64_t i = 0; i < n; ++i)
			p[q[i]] = inv_a[i];

		for (int64_t i = 0; i < n; ++i)
			if (a[p[q[i]]] != i || p[i] == i || q[i] == i) {
				cout << "BAD";

				cout << "a: " << endl;
				for (const auto& x : a)
					cout << x << " ";
				cout << endl;

				cout << "p: " << endl;
				for (const auto& x : p)
					cout << x << " ";
				cout << endl;

				cout << "q: " << endl;
				for (const auto& x : q)
					cout << x << " ";
				cout << endl;

					exit(0);
			}

		cout << "Possible" << endl;
		for (const auto& x : p)
			cout << x + 1 << " ";
		cout << endl;
		for (const auto& x : q)
			cout << x + 1 << " ";
		cout << endl;
		p.clear();
		q.clear();
		a.clear();
		inv_a.clear();
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solveK();

	return 0;
}
