#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
using namespace std;
typedef long long ll;
#define d_c(type, name) type name; cin >> name
#define d_cl(name) d_c(ll, name)

enum class Status
{
    NOT_FOUND,
    FATHER,
    CLOSER,
    SAME_DISTANCE,
    WIN
};

int main() {
    set<pair<ll, ll>> printed;
    auto print = [&](ll const& a, ll const& b) -> string
    {
        cout << a << ' ' << b << endl;
        printed.insert({a, b});
        string s;
        cin >> s;
        if(s[s.size() - 1] == '!')
            return "!";
        return s;
    };
    map<string, Status> mp;
    mp["!"] = Status::WIN;
    string res = print(1, 1);
    if(res[res.size() - 1] == '!')
        return 0;
    mp[res] = Status::NOT_FOUND;
    mp[print(1, 1)] = Status::SAME_DISTANCE;
    res = print(0, 0);
    if(mp.find(res) != mp.end())
    {
        vector<pair<ll, ll>> vars{{0, 1}, {1, 0}};
        ll i = 0;
        while(res[res.size() - 1] != '!')
        {
            res = print(vars[i].first, vars[i].second);
            i++;
        }
        return 0;
    }
    mp[res] = Status::FATHER;
    const ll MX = 1000000;
    ll xl = 0, yl = 0, xr = MX, yr = MX;
    bool first = true;
    while(xr - xl > 1 || yr - yl > 1)
    {
        if(!first) {
            res = print(xl, yl);
        }
        else
            first = false;
        if(res.back() == '!')
        {
            return 0;
        }
        res = print(xr, yl);
        if(mp.find(res) == mp.end())
            mp[res] = Status::CLOSER;
        ll mx = (xl + xr) / 2;
        ll old_xr = xr;
        switch (mp[res]) {
            case Status::SAME_DISTANCE:
                xl = xr = mx;
                break;
            case Status::WIN:
                return 0;
            case Status::CLOSER:
                xl = mx + 1 - ((xl + xr) % 2);
                break;
            case Status::FATHER:
                xr = mx - 1 + ((xl + xr) % 2);
                break;
        }
        ll my = (yl + yr) / 2;
        res = print(old_xr, yr);
        if(mp.find(res) == mp.end())
            mp[res] = Status::CLOSER;
        switch (mp[res]) {
            case Status::SAME_DISTANCE:
                yl = yr = my;
                break;
            case Status::WIN:
                return 0;
            case Status::CLOSER:
                yl = my + 1 - ((yl + yr) % 2);
                break;
            case Status::FATHER:
                yr = my - 1 + ((yl + yr) % 2);
                break;
        }
    }
    for(ll x = xl; x <= xr; x++)
        for(ll y = yl; y <= yr; y++)
        {
            if(printed.find({x, y}) != printed.end())
                continue;
            res = print(x, y);
            if(mp[res] == Status::WIN)
            {
                return 0;
            }
        }
    return 0;
}
