#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair

#define f first
#define s second

#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()

#define left asdasda
#define right weqweqe

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int N = (int) 1e3 + 123;
const int MOD = (int) 1e9 + 7;

const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, -1, 0, 1};

int n, m;
char grid[N][N];

vector<int> g[N * N];
vector<int> grev[N * N];

int used[N * N];
int match[N * N];
bool skip[N * N];
int timer;
int for_right[N * N];
int for_left[N * N];

vi left, right;
vi ps, qs;

int p, q;

bool dfs(int v) {
    if (used[v] == timer) return false;
    used[v] = timer;
    for (auto to : g[v]) {
        if (skip[to]) continue;
        if (for_right[to] == -1 || dfs(for_right[to])) {
            for_right[to] = v;
            for_left[v] = to;
            return true;
        }
    }
    return false;
}

int calc(int v) {
    // v is on right
    used[v] = timer;
    int now = 1;
    for (auto u : grev[v]) {
        if (used[for_left[u]] != timer)
            now += calc(for_left[u]);
    }
    return now;
}

void fast_kuhn() {
    memset(for_right, -1, sizeof for_right);
    memset(for_left, -1, sizeof for_left);
    p = q = 0;
    ps.clear();
    qs.clear();

    random_shuffle(all(left));

    for (int v : left) {
        if (skip[v]) continue;
        random_shuffle(all(g[v]));
        for (int to : g[v]) {
            if (skip[to]) continue;
            if (for_right[to] == -1) {
                for_right[to] = v;
                for_left[v] = to;
                break;
            }
        }
    }

    for (int run = 1; run; ) {
        run = 0;
        ++timer;
        for (int v : left) {
            if (skip[v]) continue;
            if (for_left[v] == -1 && dfs(v))
                run = 1;
        }
    }
    for (int v : left) {
        if (skip[v]) continue;
        if (for_left[v] == -1) {
            p++;
            ps.pb(v);
        } else {
            //cout << v << ' ' << for_left[v] << endl;
        }
    }
    for (int v : right) {
        if (skip[v]) continue;
        if (for_right[v] == -1) {
            ++q;
            qs.pb(v);
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> grid[i][j];
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (grid[i][j] == '#') {
                skip[i * m + j] = true;
                continue;
            }
            if ((i + j) % 2) {
                right.pb(i * m + j);
                continue;
            }
            left.pb(i * m + j);
            for (int dir = 0; dir < 4; dir++) {
                int ii = i + dx[dir];
                int jj = j + dy[dir];
                if (ii >= 0 && jj >= 0 && ii < n && jj < m && grid[ii][jj] != '#') {
                    g[i * m + j].pb(ii * m + jj);
                    grev[ii * m + jj].pb(i * m + j);
                }
            }
        }
    }

    fast_kuhn();

    int v = sz(left) + sz(right);
    if ((v & 1) || p + q > 2) {
        // all
        cout << min(1000000LL, v * 1ll * (v - 1) / 2);
        return 0;
    }

    if (p == 0 && q == 0) {
        ll total = sz(left) * 1ll * (sz(left) - 1) / 2;
        total += sz(right) * 1ll * (sz(right) - 1) / 2;
        for (auto v : left) {
            ++timer;
            int bad = calc(for_left[v]);
            int cnt = sz(right);
            total += cnt - bad;
            if (total >= 1000000)
                break;
        }
        cout << min(total, 1000000ll);
        return 0;
    }

    if (p == 0 || q == 2) {
        ll total = v * 1ll * (v - 1) / 2;

        vector<int> candidates;
        for (auto x : grev[qs[0]]) {
            candidates.pb(for_left[x]);
        }
        for (auto x : grev[qs[1]]) {
            candidates.pb(for_left[x]);
        }
        candidates.pb(qs[0]);
        candidates.pb(qs[1]);

        sort(all(candidates));
        candidates.resize(unique(all(candidates)) - candidates.begin());

        for (auto x : candidates) {
            for (auto y : candidates) {
                if (x < y) {
                    skip[x] = true;
                    skip[y] = true;
                    fast_kuhn();

                    if (p == 0 && q == 0)
                        total--;
                    skip[x] = false;
                    skip[y] = false;
                }
            }
        }
        cout << total << "\n";
        return 0;
    }

    if (p == 2 || q == 0) {
        ll total = v * 1ll * (v - 1) / 2;

        vector<int> candidates;
        for (auto x : g[ps[0]]) {
            candidates.pb(for_right[x]);
        }
        for (auto x : g[ps[1]]) {
            candidates.pb(for_right[x]);
        }
        candidates.pb(ps[0]);
        candidates.pb(ps[1]);

        sort(all(candidates));
        candidates.resize(unique(all(candidates)) - candidates.begin());

        for (auto x : candidates) {
            for (auto y : candidates) {
                if (x < y) {
                    skip[x] = true;
                    skip[y] = true;
                    fast_kuhn();
                    if (p == 0 && q == 0)
                        total--;
                    skip[x] = false;
                    skip[y] = false;
                }
            }
        }
        cout << total << "\n";
        return 0;
    }

    if (p == 1 && q == 1) {
        ll total = v * 1ll * (v - 1) / 2;

        vector<int> candidates;
        for (auto x : g[ps[0]]) {
            candidates.pb(for_right[x]);
        }
        for (auto x : grev[qs[0]]) {
            candidates.pb(for_left[x]);
        }
        candidates.pb(ps[0]);
        candidates.pb(qs[0]);

        sort(all(candidates));
        candidates.resize(unique(all(candidates)) - candidates.begin());

        for (auto x : candidates) {
            for (auto y : candidates) {
                if (x < y) {
                    skip[x] = true;
                    skip[y] = true;
                    fast_kuhn();
                    if (p == 0 && q == 0)
                        total--;
                    skip[x] = false;
                    skip[y] = false;
                }
            }
        }
        cout << total << "\n";
        return 0;
    }

    assert(false);

    return 0;
}