#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#pragma GCC optimize("O3")

int const N = 5983;
int const D = 20005;

char mat[N + 1][D];

ll powers[11];

int const BASE = int(1e9);

using bigint = vector<int>;

void multiply(bigint& a, int x) {
	int sz = int(a.size());
	int carry = 0;
	for (int i = 0; i < sz; ++i) {
		ll nw = ll(a[i]) * x + carry;
		a[i] = nw % BASE;
		carry = nw / BASE;
	}
	if (carry > 0) {
		a.push_back(carry);
	}
}

int bestd = -1;
int bestc = 100000000;

void precalc() {
	powers[0] = 1;
	for (int i = 1; i <= 10; ++i) {
		powers[i] = powers[i - 1] * 10;
	}

	bigint fact{1};
	for (int i = 1; i <= N; ++i) {
		int sz = fact.size();
		for (int j = 0; j < D; ++j) {
			int at = j / 9;
			if (at >= sz) {
				mat[i][j] = '0';
			} else {
				int adiv = fact[at] / powers[j % 9];
				int dig = adiv % 10;
				mat[i][j] = '0' + dig;
				if (at == sz - 1 && adiv == 0) {
					mat[i][j] = '0';
				}
			}
		}
		multiply(fact, i + 1);
	}
	
	for (int d = 0; d < 20000; ++d) {
		int maxCnt = 0;
		int cnt[10]{};
		for (int i = 1; i <= N; ++i) {
			++cnt[mat[i][d] - '0'];
		}
		for (int j = 0; j < 10; ++j) {
			maxCnt = max(maxCnt, cnt[j]);
		}
		if (maxCnt < bestc) {
			bestc = maxCnt;
			bestd = d;
		}
	}
}

void solveTest(int guessed) {
	vector<int> options(N);
	iota(options.begin(), options.end(), 1);
	bool was = false;
	int iter = 0;
	while (options.size() > 1) {
		assert(++iter <= 10);
		int bestopt = 10000000;
		int whoOpt = -1;
		if (!was) {
			bestopt = bestc;
			whoOpt = bestd;
		} else {
			for (int d = 0; d < 2000; ++d) {
				int cnt[10]{};
				for (int i : options) {
					++cnt[mat[i][d] - '0'];
				}
				int macnt = 0;
				for (int i = 0; i < 10; ++i) {
					macnt = max(macnt, cnt[i]);
				}
				if (macnt < bestopt) {
					bestopt = macnt;
					whoOpt = d;
				}
			}
		}
		was = true;
		// cout << "? " << whoOpt << endl;
		int resp = mat[guessed][whoOpt] - '0';
		// int resp; cin >> resp;
		vector<int> noptions;
		for (int i : options) {
			if (mat[i][whoOpt] - '0' == resp) {
				noptions.push_back(i);
			}
		}
		options = move(noptions);
	}
	assert(options.size() == 1);
	// cout << "! " << options[0] << endl;
	string resp;
	// cin >> resp;
	if (options[0] == guessed) {
		resp = "YES";
	} else {
		resp = "NO";
	}
	assert(resp == "YES");
}

int main() {
	precalc();

	int t;
	for (int i = 0; i < 100; ++i) {
		solveTest(5982 - i);
	}

	cerr << (1.0 * clock() / CLOCKS_PER_SEC) << '\n';
	return 0;
}