#include <bits/stdc++.h>

// using namespace std;

#define debug(x) std::cerr << (#x) << "\t" << (x) << std::endl;

using ll = long long;

std::mt19937_64 rnd(238);

const int N = 1010;
const int K = 110;

int a[K][N];
int position[K][N];
ll values[N];
ll prefHash[K][N];
int par[N];

ll getHash(int k, int l, int r) {
	if (l > r) {
		return 0;
	}

	ll res = prefHash[k][r];
	if (l != 0) {
		res ^= prefHash[k][l - 1];
	}
	return res;
}

int calc(std::vector<std::pair<int, int>> segments) {
	auto[l, r] = segments[0];
	int realRootId = -1;
	
	if (l == r) {
		// debug("HUY");
		return a[0][l];
		// return segments[0].first;
	}

	for (int rootPosition = l + 1; rootPosition <= r - 1; ++rootPosition) {
		// debug(rootPosition);

		ll h1 = getHash(0, l, rootPosition - 1);
		ll h2 = getHash(0, rootPosition + 1, r);
		if (h1 > h2) {
			std::swap(h1, h2);
		}
		int rootId = a[0][rootPosition];
		bool good = true;

		for (int i = 1; i < (int)segments.size(); ++i) {
			auto[curL, curR] = segments[i];
			int curRootPosition = position[i][rootId];

			if (curRootPosition < curL || curRootPosition > curR) {
				good = false;
				break;
			}

			ll curh1 = getHash(i, curL, curRootPosition - 1);
			ll curh2 = getHash(i, curRootPosition + 1, curR);
			if (curh1 > curh2) {
				std::swap(curh1, curh2);
			}

			if (h1 != curh1 || h2 != curh2) {
				good = false;
				break;
			}
		}

		if (!good) {
			continue;
		}

		realRootId = rootId;
	}

	assert(realRootId != -1);
	// debug(realRootId);

	int rootPosition = position[0][realRootId];
	ll h1 = getHash(0, l, rootPosition - 1);
	ll h2 = getHash(0, rootPosition + 1, r);
	if (h1 > h2) {
		std::swap(h1, h2);
	}

	std::vector<std::pair<int, int>> newSegments1, newSegments2;
	for (int i = 0; i < (int)segments.size(); ++i) {
		auto[l, r] = segments[i];
		int curPosition = position[i][realRootId];
		
		ll curh1 = getHash(i, l, curPosition - 1);
		ll curh2 = getHash(i, curPosition + 1, r);
		if (curh1 > curh2) {
			if (l <= curPosition - 1) {
				newSegments1.emplace_back(l, curPosition - 1);
			}
			if (curPosition + 1 <= r) {
				newSegments2.emplace_back(curPosition + 1, r);
			}
		} else {
			if (l <= curPosition - 1) {
				newSegments2.emplace_back(l, curPosition - 1);
			}
			if (curPosition + 1 <= r) {
				newSegments1.emplace_back(curPosition + 1, r);
			}
		}
	}

	assert(newSegments1.size() == segments.size() || newSegments1.empty());
	assert(newSegments2.size() == segments.size() || newSegments2.empty());

	int ch1 = calc(newSegments1);
	int ch2 = calc(newSegments2);
	par[ch1] = realRootId + 1;
	par[ch2] = realRootId + 1;

	// std::cout << "Edge: " << ch1 << ' ' << realRootId << std::endl;
	// std::cout << "Edge: " << ch2 << ' ' << realRootId << std::endl;
	return realRootId;
}

int main() {
	for (int i = 0; i < N; ++i) {
		values[i] = rnd();
		par[i] = -1;
	}

	int n, k;
	scanf("%d%d", &n, &k);

	// debug(n);
	// debug(k);

	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < n; ++j) {
			scanf("%d", &a[i][j]);
			--a[i][j];
			position[i][a[i][j]] = j;

			prefHash[i][j] = values[a[i][j]];
			if (j != 0) {
				prefHash[i][j] ^= prefHash[i][j - 1];
			}
		}
	}

	// debug("COCK");

	std::vector<std::pair<int, int>> segments;
	for (int i = 0; i < k; ++i) {
		segments.emplace_back(0, n - 1);
	}

	calc(segments);

	for (int i = 0; i < n; ++i) {
		printf("%d ", par[i]);
	}
	printf("\n");

	return 0;
}