#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solveTest(int n, int paths) {
	vector<vector<int>> graph(n);
	for (int it = 0; it < paths; ++it) {
		int nv; cin >> nv;
		vector<int> vs(nv);
		for (int& v : vs) {
			cin >> v;
			--v;
		}
		for (int i = 0; i + 1 < nv; ++i) {
			graph[vs[i]].push_back(vs[i + 1]);
			graph[vs[i + 1]].push_back(vs[i]);
		}
	}

	vector<vector<int>> cycles;
	vector<int> par(n);
	vector<int> d(n);
	vector<bool> used(n);
	auto dfs = [&](auto&& self, int v, int p = -1) -> void {
		used[v] = true;
		for (int u : graph[v]) {
			if (u == p) {
				continue;
			}

			if (used[u] && d[u] < d[v]) {
				cycles.emplace_back();
				int cur = v;
				while (true) {
					cycles.back().push_back(cur);
					if (cur == u) {
						break;
					}
					cur = par[cur];
				}
			}
			if (!used[u]) {
				d[u] = d[v] + 1;
				par[u] = v;
				self(self, u, v);
			}
		}
	};
	dfs(dfs, 0);
	int nc = int(cycles.size());
	set<pair<int, int>> badE;
	for (auto& c : cycles) {
		int len = int(c.size());
		for (int i = 0; i < len; ++i) {
			int v = c[i];
			int u = c[(i + 1) % len];
			badE.insert(minmax(v, u));
		}
	}
	vector<vector<int>> ng(n + nc);
	for (int v = 0; v < n; ++v) {
		for (int u : graph[v]) {
			if (!badE.count(minmax(u, v))) {
				ng[u].push_back(v);
			}
		}
	}
	for (int i = 0; i < nc; ++i) {
		for (int v : cycles[i]) {
			ng[n + i].push_back(v);
			ng[v].push_back(n + i);
		}
	}
	graph = ng;

	if (nc == 0) {
		cout << "Yes\n";
		return;
	}
	vector<int> cntNei(n);
	for (int i = 0; i < nc; ++i) {
		for (int v : graph[n + i]) {
			cntNei[v]++;
		}
	}
	for (int i = 0; i < nc; ++i) {
		int here = 0;
		for (int v : graph[n + i]) {
			here += cntNei[v] - 1;
		}
		here += 1;
		assert(here <= nc);
		if (here == nc) {
			cout << "Yes\n";
			return;
		}
	}
	vector<int> sz(n + nc);
	vector<bool> dp(n + nc);
	bool ans = false;
	auto dfs2 = [&](auto&& self, int v, int p = -1) -> void {
		sz[v] += (v >= n);
		vector<pair<int, int>> children;
		vector<int> badch;
		for (int u : graph[v]) {
			if (u == p) {
				continue;
			}
			self(self, u, v);
			sz[v] += sz[u];
			children.emplace_back(u, (sz[u] == 0) || (sz[u] == 1 && u >= n));
			if (!children.back().second) {
				badch.push_back(u);
			}
		}
		if (badch.empty()) {
			dp[v] = true;
		}
		for (auto[u, gu] : children) {
			if (badch.size() == 1 && u == badch[0]) {
				dp[v] = dp[u];
			}
		}

		int outside = nc;
		outside -= sz[v];
		if (p >= 0 && p >= n) {
			outside -= 1;
		}
		if (outside == 0) {
			if (badch.size() == 2) {
				bool alldp = true;
				for (auto[u, gu] : children) {
					if (u == badch[0] || u == badch[1]) {
						alldp &= dp[u];
					}
				}
				if (alldp) {
					ans = true;
				}
			}
		}
	};
	dfs2(dfs2, 0);
	cout << (ans || dp[0] ? "Yes" : "No") << '\n';
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, m;
	while (true) {
		cin >> n >> m;
		if (n == 0) {
			break;
		}
		solveTest(n, m);
	}	
	return 0;
}