#include <bits/stdc++.h>

using namespace std;

using ll = long long;

ll C(ll n) {
	return n * (n - 1) / 2;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, m;
	cin >> n >> m;
	vector<string> a(n);
	for (auto& s : a) {
		cin >> s;
	}
	int free[2]{};
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (a[i][j] == '.') {
				free[(i + j) % 2]++;
			}
		}
	}
	int nfree = free[0] + free[1];
	if ((free[0] + free[1]) % 2 == 1) {
		cout << min(ll(1e6), C(nfree)) << '\n';
		return 0;
	}
	if (abs(free[0] - free[1]) > 2) {
		cout << min(ll(1e6), C(nfree)) << '\n';
		return 0;
	}

	if (free[0] == free[1]) {
		if (C(free[0]) + C(free[1]) >= int(1e6)) {
			cout << int(1e6) << '\n';
			return 0;
		}
	} else {
		if (ll(free[0]) * free[1] >= int(1e6)) {
			cout << int(1e6) << '\n';
			return 0;
		}
	}

	vector<pair<int, int>> freeCells;
	vector idFree(n, vector<int>(m, -1));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (a[i][j] == '.') {
				int id = int(freeCells.size());
				freeCells.emplace_back(i, j);
				idFree[i][j] = id;
			}
		}
	}
	assert(int(freeCells.size()) == nfree);
	vector<int> DX{1, 0, -1, 0};
	vector<int> DY{0, 1, 0, -1};
	vector<vector<int>> graph(nfree);
	vector<int> part(nfree);
	for (int it = 0; it < nfree; ++it) {
		auto[i, j] = freeCells[it];
		part[it] = (i + j) % 2;
		for (int k = 0; k < 4; ++k) {
			int ii = i + DX[k];
			int jj = j + DY[k];
			if (ii >= 0 && ii < n && jj >= 0 && jj < m && a[ii][jj] == '.') {
				int jt = idFree[ii][jj];
				assert(jt >= 0);
				graph[it].push_back(jt);
			}
		}
	}

	ll ans = 0;
	
	vector<int> mt(nfree, -1);
	int timer = 0;
	vector<int> used(nfree, -1);

	int banned = -1;
	auto kuhn = [&](auto&& self, int v) -> bool {
		used[v] = timer;
		for (int u : graph[v]) {
			if (mt[u] < 0) {
				mt[u] = v;
				return true;
			}
		}
		for (int u : graph[v]) {
			assert(mt[u] >= 0);
			if (mt[u] != banned && used[mt[u]] != timer && self(self, mt[u])) {
				mt[u] = v;
				return true;
			}
		}
		return false;
	};

	for (int s = 0; s < nfree; ++s) {
		fill(mt.begin(), mt.end(), -1);

		// cerr << "Iteration " << s << endl;
		timer++;

		banned = s;
		int ma = 0;
		int unused = -1;
		bool done = false;
		for (int i = 0; i < nfree; ++i) {
			if (i == s || part[i] != part[s]) {
				continue;
			}
			if (kuhn(kuhn, i)) {
				timer++;
				ma += 1;	
				// cerr << "FoundL " << i << '\n';
			} else {
				// cerr << "MissedL " << i << '\n';
				if (unused >= 0) {
					done = true;
					break;
				}
				unused = i;
			}
		}
		if (done || ma * 2 != nfree - 2) {
			ans += n - 1;
			continue;
		}
		if (unused < 0) {
			for (int v = 0; v < nfree; ++v) {
				if (part[v] != part[s]) {
					// cerr << v << ' ' << mt[v] << '\n';
				}
				if (part[v] != part[s] && mt[v] < 0) {
					unused = v;
					break;
				}
			}
		}
		assert(unused >= 0 && unused != s);

		// cerr << "before " << s << " " << ans << '\n';
		// cerr << "unused: " << unused << '\n';
		// cerr << "partu: " << part[unused] << '\n';
		// cerr << "parts: " << part[s] << '\n';
		timer++;

		for (int v = 0; v < nfree; ++v) {
			if (part[v] != part[s] && mt[v] >= 0) {
				mt[mt[v]] = v;
			}
		}

		auto dfs2 = [&](auto&& self, int v) -> void {
			// cerr << "DFS: " << v << '\n';
			if (v == banned) {
				return;
			}

			if (part[v] == part[unused]) {
				++ans;
			}
			used[v] = timer;
			if (part[v] == part[unused]) {
				for (int u : graph[v]) {
					if (used[u] != timer) {
						self(self, u);
					}
				}
			} else {
				if (mt[v] >= 0 && used[mt[v]] != timer) {
					self(self, mt[v]);
				}
			}
		};
		dfs2(dfs2, unused);
		// cerr << "after: " << ans << '\n';
	}

	assert(ans % 2 == 0);
	ans /= 2;
	cout << min(ll(1e6), C(nfree) - ans) << '\n';
	return 0;
}