#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;

mt19937 rnd(239);

const int BUBEN = 300;

pair<vector<int>, vector<int>> slow_solve(int n, vector<int> &a) {
    vector<int> pos(n);
    for (int i = 0; i < n; i++) {
        pos[a[i]] = i;
    }
    vector<int> p(n);
    iota(p.begin(), p.end(), 0);
    do {
        bool ok = true;
        vector<int> pos_p(n);
        for (int j = 0; j < n; j++) {
            if (p[j] == j) {
                ok = false;
            }
            pos_p[p[j]] = j;
        }
        vector<int> q(n);
        for (int j = 0; j < n; j++) {
            q[j] = pos_p[pos[j]];
            if (q[j] == j) {
                ok = false;
            }
        }
        if (ok) {
            return {p, q};
        }
    } while (next_permutation(p.begin(), p.end()));
    return {vector<int>(), vector<int>()};
}

pair<vector<int>, vector<int>> fast_solve(int n, vector<int> &a) {
    vector<int> pos(n);
    for (int i = 0; i < n; i++) {
        pos[a[i]] = i;
    }
    vector<int> p = a, qq;
    for (int i = 0; i < BUBEN; i++) {
        shuffle(p.begin(), p.end(), rnd);
        bool ok = true;
        vector<int> pos_p(n);
        for (int j = 0; j < n; j++) {
            if (p[j] == j) {
                ok = false;
            }
            pos_p[p[j]] = j;
        }
        vector<int> q(n);
        for (int j = 0; j < n; j++) {
            q[j] = pos_p[pos[j]];
            if (q[j] == j) {
                ok = false;
            }
        }
        if (ok) {
            return {p, q};
        }
    }
    return {vector<int>(), vector<int>()};
}

int main() {
#ifdef PC
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    int T;
    cin >> T;
    while (T--) {
        int n;
        cin >> n;
        vector<int> a(n);
        for (auto &x : a) {
            cin >> x;
            x--;
        }
        if (n <= 6) {
            auto [p, q] = slow_solve(n, a);
            if (q.empty()) {
                cout << "Impossible\n";
            } else {
                cout << "Possible\n";
                for (auto it : p) {
                    cout << it + 1 << ' ';
                }
                cout << '\n';
                for (auto it : q) {
                    cout << it + 1 << ' ';
                }
                cout << '\n';
            }
        } else {
            auto [p, q] = fast_solve(n, a);
            if (q.empty()) {
                cout << "Impossible\n";
            } else {
                cout << "Possible\n";
                for (auto it : p) {
                    cout << it + 1 << ' ';
                }
                cout << '\n';
                for (auto it : q) {
                    cout << it + 1 << ' ';
                }
                cout << '\n';
            }
        }
    }
    return 0;
}
