#include <bits/stdc++.h>

using namespace std;

const int M = 1e9 + 7;
const int N = 107;
long long pow2[N];
int par[N];

map <int, pair <int, int>> calc_h(vector <int> perm) {
    vector <pair <int, int>> ans(perm.size());
    long long h = 0;
    for (int i = 0; i < (int) perm.size(); i++) {
        ans[i].first = h;
        h = (h + pow2[perm[i]]) % M;
    }
    h = 0;
    map <int, pair <int, int>> real_ans;
    for (int i = (int) perm.size() - 1; i >= 0; i--) {
        ans[i].second = h;
        h = (h + pow2[perm[i]]) % M;
        if (ans[i].second > ans[i].first)
            swap(ans[i].first, ans[i].second);
        real_ans[perm[i]] = ans[i];
    }
    return real_ans;
}

void find_root(vector<vector<int>> perm, int p = -1) {
    map <int, pair <int, int>> v_to_h = calc_h(perm[0]);
    set <int> good;
    for (int elem : perm[0]) good.insert(elem);

    for (int i = 1; i < (int) perm.size(); i++) {
        if ((int) good.size() == 1)
            break;
        auto h2 = calc_h(perm[i]);
        for (auto &elem : h2) {
            if (elem.second.first == 0 || elem.second.second == 0 || elem.second != v_to_h[elem.first]) {
                good.erase(elem.first);
            }
        }
    }
    //cout << good.size() << endl;
    assert((int) good.size() == 1);
    int x = *good.begin();
    par[x] = p;
    if ((int) perm[0].size() == 1)
        return;
    vector <vector <int>> p_ll, p_rr;
    for (int i = 0; i < (int) perm.size(); i++) {
        vector <int> p_l, p_r;
        bool fnd = 0;
        for (int j = 0; j < (int) perm[i].size(); j++) {
            if (perm[i][j] == x) {
                fnd = 1;
                continue;
            }
            if (!fnd)
                p_l.push_back(perm[i][j]);
            else
                p_r.push_back(perm[i][j]);
        }
        if (i == 0) {
            p_ll.push_back(p_l);
            p_rr.push_back(p_r);
            continue;
        }
        int y = p_ll[0][0];
        bool flag = 0;
        for (int &elem : p_l) {
            if (elem == y) {
                flag = 1;
                break;
            }
        }
        if (!flag)
            swap(p_l, p_r);

        p_ll.push_back(p_l);
        p_rr.push_back(p_r);
    }
    find_root(p_ll, x);
    find_root(p_rr, x);
}

signed main() {
    //freopen("input.txt", "r", stdin);
    pow2[0] = 1;
    for (int i = 1; i < N; i++) {
        pow2[i] = (pow2[i - 1] * 2) % M;
    }
    int n, k;
    cin >> n >> k;
    vector <vector <int>> perm(k);
    for (int i = 0; i < k; i++) {
        perm[i].resize(n);
        for (int j = 0; j < n; j++) {
            cin >> perm[i][j];
        }
    }
    find_root(perm);
    for (int i = 1; i <= n; i++) {
        cout << par[i] << ' ';
    }
    cout << "\n";
}
