#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <random>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<int> vi;
typedef vector<bool> vb;
typedef vector<vi> vvi;
#define y second
#define x first
#define pb push_back
#define mp make_pair

vvi divide_into_cycles(const vi& a) {
	vvi ans;
	const int n = a.size();
	vb used(n);
	for (int i = 0; i < n; ++i)
		if (!used[i]) {
			ans.emplace_back(1, i);
			while (a[ans.back().back()] != ans.back().front())
				ans.back().push_back(a[ans.back().back()]);
			for (int j : ans.back())
				used[j] = true;
		}
	return ans;
}
void constr(vi& p, vi& q, const vi& cycle) {
	const int C = cycle.size();
	for (int i = 0; i < C; ++i) {
		p[cycle[i]] = cycle[(i + 2) % C];
		q[cycle[i]] = cycle[(i + C - 1) % C];
	}
}
vi inverse(const vi& a) {
	vi b(a.size());
	for (int i = 0; i < a.size(); ++i)
		b[a[i]] = i;
	return b;
}
void add_one(vi& p, vi& q, const int y, const vi& cycle) {
	int z = q[y];
	int t = p[z];
	int x = cycle[0];
	q[x] = z;
	p[z] = x;
	q[y] = x;
	p[x] = t;
}
void add_two(vi& p, vi& q, const int y, const int yy, const vi& cycle) {
	int z = q[y];
	int t = p[z];
	int zz = q[yy];
	int tt = p[zz];
	int x = cycle[0];
	int v = cycle[1];

	q[x] = z;
	p[z] = v;
	q[v] = zz;
	p[zz] = x;
	q[y] = x;
	p[x] = t;
	q[yy] = v;
	p[v] = tt;
}
int count_fixed(const vi& a) {
	const int n = a.size();
	int ans = 0;
	for (int i = 0; i < n; ++i)
		if (a[i] == i)
			++ans;
	return ans;
}
pair<vi, vi> find_ans(vi a) {
	const int n = a.size();
	a = inverse(a);
	if (n == 1)
		return {};
	if (n == 2 && a[0] == 1)
		return {};
	if (n == 3 && count_fixed(a) == 1)
		return {};
	vvi d = divide_into_cycles(a);
	pair<vi, vi> ans{ vi(n, -1), vi(n, -1) };
	int maximum_cycle_index = 0;
	for (int i = 0; i < d.size(); ++i)
		if (d[i].size() > d[maximum_cycle_index].size())
			maximum_cycle_index = i;
	constr(ans.x, ans.y, d[maximum_cycle_index]);
	int x = d[maximum_cycle_index].front(), y = d[maximum_cycle_index].back();
	int ggg = 0;
	for (int cycle_index = 0; cycle_index < d.size(); ++cycle_index)
		if (cycle_index != maximum_cycle_index) {
			++ggg;
			if (d[cycle_index].size() >= 3)
				constr(ans.x, ans.y, d[cycle_index]);
			else if (d[cycle_index].size() == 2)
				add_two(ans.x, ans.y, x, y, d[cycle_index]);
			else
				add_one(ans.x, ans.y, ggg % 2 ? x : y, d[cycle_index]);
		}
	return ans;
}
bool has_fixed(const vi& a) {
	return count_fixed(a);
}
bool check(const vi& a, const pair<vi, vi>& ans) {
	if (has_fixed(ans.x))
		return false;
	if (has_fixed(ans.y))
		return false;
	const int n = a.size();
	if (ans.x.size() != n)
		return false;
	if (ans.y.size() != n)
		return false;
	for (int i = 0; i < n; ++i)
		if (a[ans.x[ans.y[i]]] != i)
			return false;
	return true;
}
void fail(const vi& v, const pair<vi, vi>& ans, const int I) {
	const int n = v.size();
	cerr << "DOESN'T WORK!!!!!!!!!!!!!!\n";
	cerr << I << " !!!!!!!!!!!!\n";
	for (int j = 0; j < n; ++j)
		cerr << v[j] << ' ';
	cerr << '\n';
	for (int j = 0; j < n; ++j)
		cerr << ans.x[j] << ' ';
	cerr << '\n';
	for (int j = 0; j < n; ++j)
		cerr << ans.y[j] << ' ';
	cerr << '\n';
	exit(1);
}
void stress() {
	const int N = 20;
	mt19937 rng;
	for (int III = 0; III < 1000000000; ++III) {
		if (III == 44) {
			III = 44;
		}
		if (III % 10000 == 0)
			cerr << '!';
		int n = rng() % N + 1;
		vi v(n);
		for (int i = 1; i < n; ++i)
			v[i] = i;
		shuffle(v.begin(), v.end(), rng);
		auto ans = find_ans(v);
		if (v.size() == 1 || v.size() == 2 && v[0] == 1 || v.size() == 3 && count_fixed(v) == 1) {
			if (ans.x.size()) {
				fail(v, ans, III);
			}
		}
		else {
			if (!ans.x.size()) {
				fail(v, ans, III);
			}
			if (!check(v, ans)) {
				fail(v, ans, III);
			}
		}
	}
}
int main() {
#ifdef HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	//stress();
#endif // HOME
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	for (int i = 0; i < t; ++i) {
		int n;
		cin >> n;
		vi a(n);
		for (int j = 0; j < n; ++j) {
			cin >> a[j];
			--a[j];
		}
		pair<vi, vi> ans = find_ans(a);
		if (ans.x.size() == 0)
			cout << "Impossible\n";
		else {
			cout << "Possible\n";
			for (int i = 0; i < n; ++i)
				cout << ans.x[i] + 1 << " \n"[i == n - 1];
			for (int i = 0; i < n; ++i)
				cout << ans.y[i] + 1 << " \n"[i == n - 1];
			if (!check(a, ans)) {
				cerr << "DOESN'T WORK!!!!!!!!!!!!!!\n";
				for (int j = 0; j < n; ++j)
					cerr << a[j] << ' ';
				cerr << '\n';
				for (int j = 0; j < n; ++j)
					cerr << ans.x[j] << ' ';
				cerr << '\n';
				for (int j = 0; j < n; ++j)
					cerr << ans.y[j] << ' ';
				cerr << '\n';
			}
		}
	}
	return 0;
}

/*
!DOESN'T WORK!!!!!!!!!!!!!!
4 1 2 3 0
0 2 3 4 1
3 4 1 2 0
*/