#include <bits/stdc++.h>

using namespace std;

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0), cout.tie(0);

  int n, m; cin >> n >> m;
  vector <string> a(n);
  for (string& i : a)
    cin >> i;

  int b = 0, w = 0;
  vector<vector<int>> id(n, vector<int>(m, -1));
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
      if (a[i][j] == '.') {
        if ((i + j) % 2) {
          id[i][j] = w++;
        }
        else {
          id[i][j] = b++;
        }
      }
    }
  }

  if (b > 1500 || w > 1500) {
    cout << 1000000;
    return 0;
  }

  vector<vector<int>> g(b);
  for (int i = 0; i < n; i++) {
    for (int j = 1; j < m; j++) {
      if (id[i][j - 1] != -1 && id[i][j] != -1) {
        if ((i + j) % 2)
          g[id[i][j - 1]].push_back(b + id[i][j]);
        else
          g[id[i][j]].push_back(b + id[i][j - 1]);
      }
    }
  }

  for (int i = 1; i < n; i++) {
    for (int j = 0; j < m; j++) {
      if (id[i - 1][j] != -1 && id[i][j] != -1) {
        if ((i + j) % 2)
          g[id[i - 1][j]].push_back(b + id[i][j]);
        else
          g[id[i][j]].push_back(b + id[i - 1][j]);
      }
    }
  }

  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++)
      cerr << id[i][j] << ' ';
    cerr << '\n';
  }

  for (int i = 0; i < b; i++) {
    cerr << i << ": ";
    for (int v: g[i])
      cerr << v << ' ';
    cerr << '\n';
  }

  vector <int> match(w, -1);

  int gen = 0;
  vector <int> was(b + w, 0);
  vector <bool> used(b, 0);
  function<bool(int)> kuhn = [&](int v) {
    if (was[v] == gen)
      return false;
    was[v] = gen;
    for (int u : g[v]) {
      if (match[u - b] == -1 || kuhn(match[u - b])) {
        match[u - b] = v;
        used[v] = true;
        return true;
      }
    }
    return false;
  };

  for (int i = 0; i < b; i++) {
    if (!used[i]) {
      gen++;
      kuhn(i);
    }
  }

  assert(find(match.begin(), match.end(), -1) == match.end());

  cerr << "matching\n";
  for (int i : match)
    cerr << i << ' ';
  cerr << '\n';

  vector<vector<int>> g2(b + w);
  for (int i = 0; i < b; i++) {
    for (int j: g[i]) {
      if (match[j - b] == i)
        g2[j].push_back(i);
      else
        g2[i].push_back(j);
    }
  }


  function<int(int, int)> dfs = [&](int root, int v) {
    was[v] = gen;
    int ans = (v >= b && match[v - b] != root);
    for (int i : g2[v]) {
      if (was[i] != gen)
        ans += dfs(root, i);
    }
    return ans;
  };

  int ans = b * (b - 1) / 2 + w * (w - 1) / 2;
  for (int i = 0; i < b; i++) {
    gen++;
    ans += w - 1 - dfs(i, i);
  }

  cout << ans << '\n';
}
