#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

int n;
vector<int> v;

mt19937 rnd(31312);

void gen() {
    n = rand() % 10 + 5;
    v.resize(n);
    iota(v.begin(), v.end(), 0);
    shuffle(v.begin(), v.end(), rnd);
}

void try_solve() {
    if (n == 1) {
        cout << "Impossible\n";
        return;
    }
    if (n == 2 && v[0] == 1 && v[1] == 0) {
        cout << "Impossible\n";
        return;
    }
    vector<int> pos_a(n);
    for (int i = 0; i < n; i++) {
        pos_a[v[i]] = i;
    }
    vector<int> cycles, p(n), q(n);
    vector<vector<int>> cycles_len2;
    vector<bool> used(n);
    for (int i = 0; i < n; i++) {
        if (used[i]) {
            continue;
        }
        used[i] = true;
        vector<int> cycle;
        cycle.push_back(i);
        int j = pos_a[i];
        while (i != j) {
            cycle.push_back(j);
            used[j] = true;
            j = pos_a[j];
        }

        if (cycle.size() != 2) {
            cycles.insert(cycles.end(), cycle.begin(), cycle.end());
        } else {
            cycles_len2.push_back(cycle);
        }
    }
    if (cycles_len2.size() > 0) {
        if (cycles_len2.size() > 1) {
            for (const auto& c: cycles_len2) {
                cycles.push_back(c[0]);
            }
            for (const auto& c: cycles_len2) {
                cycles.push_back(c[1]);
            }
        } else {
            if (cycles.empty()) {
                cout << "Impossible\n";
                return;
            }
            cycles.insert(cycles.begin(), cycles_len2[0][0]);
            cycles.push_back(cycles_len2[0][1]);
        }
    }

    auto cycle2 = cycles;
    cycle2.push_back(cycles[0]);
    cycle2.erase(cycle2.begin());
    for (int i = 0; i < n; i++) {
        p[cycles[i]] = cycle2[i];
    }
//    for (int i: cycles) {
//        cout << i << " ";
//    }
//    cout << endl;
//    for (int i: cycle2) {
//        cout << i << " ";
//    }
//    cout << endl;
    for (int i = 0; i < n; i++) {
        if (p[i] == i) {
            cout << "Impossible\n";
            return;
        }
    }
    vector<int> pos_p(n);
    for (int i = 0; i < n; i++) {
        pos_p[p[i]] = i;
    }
    for (int i = 0; i < n; i++) {
        q[i] = pos_p[v[i]];
        if (q[i] == i) {
            assert(false);
        }
    }

    cout << "Possible\n";
    for (int &e: p) {
        cout << e + 1 << " ";
    }
    cout << "\n";
    for (int &e: q) {
        cout << e + 1 << " ";
    }
    cout << "\n";
    return;
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
//    while (true) {/**/
//        gen();
//        try_solve();
//        cout << endl;
//    }
    int t;
    cin >> t;
    while (t--) {
        cin >> n;
        v.resize(n);
        for (int &e: v) {
            cin >> e;
            e--;
        }
        try_solve();
    }
    return 0;
}
