#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

int n;
vector<int> v;

mt19937 rnd(31312);

void gen() {
    n = rand() % 10 + 1;
    v.resize(n);
    iota(v.begin(), v.end(), 0);
    shuffle(v.begin(), v.end(), rnd);
}

void try_solve() {
    if (n == 1) {
        cout << "Impossible\n";
        return;
    }
    if (n == 2 && v[0] == 1 && v[1] == 0) {
        cout << "Impossible\n";
        return;
    }
    if (n == 2 && v[0] == 0 && v[1] == 1) {
        cout << "Possible\n2 1\n2 1\n";
        return;
    }
    vector<int> pos_a(n);
    for (int i = 0; i < n; i++) {
        pos_a[v[i]] = i;
    }
    vector<int> cycles, p(n), q(n);
    vector<vector<int>> cycles_len2, cycles_len1;
    vector<bool> used(n);
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        if (used[i]) {
            continue;
        }
        cnt++;
        used[i] = true;
        vector<int> cycle;
        cycle.push_back(i);
        int j = pos_a[i];
        while (i != j) {
            cycle.push_back(j);
            used[j] = true;
            j = pos_a[j];
        }
        if (cycle.size() == 1) {
            cycles_len1.push_back(cycle);
        } else if (cycle.size() == 2) {
            cycles_len2.push_back(cycle);
        } else {
            reverse(cycle.begin(), cycle.end());
            cycles.insert(cycles.end(), cycle.begin(), cycle.end());
        }
    }

    for (int i = 0; i < cycles.size(); i++) {
        p[cycles[i]] = cycles[(i + 1) % cycles.size()];
    }
    int k2 = cycles_len2.size();
    for (int i = 0; i < k2; i++) {
        p[cycles_len2[i][0]] = cycles_len2[(i + 1) % k2][0];
        p[cycles_len2[i][1]] = cycles_len2[(i + 1) % k2][1];
    }
    int k1 = cycles_len1.size();
    for (int i = 0; i + 1 < k1; i++) {
        p[cycles_len1[i][0]] = cycles_len1[i + 1][0];
    }
    if (k2 > 0 && k1 > 0) {
        p[cycles_len1[k1 - 1][0]] = cycles_len2[0][0];
        if (k2 >= 2) {
            p[cycles_len1[k1 - 1][0]] = cycles_len2[0][0];
            p[cycles_len2[k2 - 1][0]] = cycles_len2[0][1];
            p[cycles_len2[k2 - 1][1]] = cycles_len1[0][0];
        } else if (k2 == 1 && k1 >= 2) {
            p[cycles_len1[k1 - 1][0]] = cycles_len2[0][1];
            p[cycles_len2[0][1]] = cycles_len1[0][0];
            p[cycles_len1[0][0]] = cycles_len2[0][0];
            p[cycles_len2[0][0]] = cycles_len1[1][0];
        } else {
            // k2 = 1 && k1 = 1
            if (cycles.size() == 0) {
                cout << "Impossible\n";
                return;
            }
            p[cycles_len1[0][0]] = cycles_len2[0][0];
            p[cycles_len2[0][0]] = cycles[0];
            p[cycles.back()] = cycles_len2[0][1];
            p[cycles_len2[0][1]] = cycles_len1[0][0];
        }
    } else if (k2 == 0 && k1 >= 2) {
        p[cycles_len1[k1 - 1][0]] = cycles_len1[0][0];
    } else if (k2 == 0 && k1 == 1) {
        p[cycles_len1[k1 - 1][0]] = cycles[0];
        p[cycles.back()] = cycles_len1[0][0];
    } else if (k2 >= 2) {
        p[cycles_len2[k2 - 1][0]] = cycles_len2[0][1];
        p[cycles_len2[k2 - 1][1]] = cycles_len2[0][0];
    } else if (k2 == 1) {
        if (cycles.size() == 0) {
            cout << "Impossible\n";
            return;
        }
        p[cycles_len2[0][0]] = cycles[0];
        p[cycles[0]] = cycles_len2[0][1];
        p[cycles_len2[0][1]] = cycles[1];
        p[cycles.back()] = cycles_len2[0][0];
    }

//    for (int i: pos_a) {
//        cout << i << " ";
//    }
//    cout << endl;
//    for (int i: cycles) {
//        cout << i << " ";
//    }
//    cout << endl;
//    cout << "p: ";
//    for (int i: p) {
//        cout << i << " ";
//    }
//    cout << endl;
    for (int i = 0; i < n; i++) {
        if (p[i] == i) {
            cout << "Impossible\n";
            return;
        }
    }
    vector<int> pos_p(n);
    for (int i = 0; i < n; i++) {
        pos_p[p[i]] = i;
    }
//    cout << "q: ";
    for (int i = 0; i < n; i++) {
        q[i] = pos_p[pos_a[i]];
//        cout << q[i] << " ";
//        cout.flush();
        if (q[i] == i) {
            assert(false);
        }
    }
//    cout << endl;

    cout << "Possible\n";
    for (int &e: p) {
        cout << e + 1 << " ";
    }
    cout << "\n";
    for (int &e: q) {
        cout << e + 1 << " ";
    }
    cout << "\n";
    return;
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
//    while (true) {
//        gen();
//        cout << "1\n" << v.size() << "\n";
//        for (int i: v) {
//            cout << (i + 1) << " ";
//        }
//        cout << endl;
//        try_solve();
//        cout << endl;
//    }
    int t;
    cin >> t;
    while (t--) {
        cin >> n;
        v.resize(n);
        for (int &e: v) {
            cin >> e;
            e--;
        }
        try_solve();
    }
    return 0;
}
