#include <bits/stdc++.h>

using namespace std;

const int BASE = 1e9;
int SYM_LEN = 9;

int powers[] = {1, (int) 1e1, (int) 1e2, (int) 1e3, (int) 1e4, (int) 1e5, (int) 1e6, (int) 1e7, (int) 1e8, (int) 1e9};

inline vector<int> mult(const vector<int> &a, long long x) {
    vector<int> ans;
    long long per = 0;
    for (auto c: a) {
        per += c * x;
        ans.push_back(per % BASE);
        per /= BASE;
    }
    while (per) {
        ans.push_back(per % BASE);
        per /= BASE;
    }
    return ans;
}

inline int get(const vector<int> &a, int pos) {
    int i = pos / SYM_LEN;
    int j = pos % SYM_LEN;
    if (i >= a.size()) {
        return 0;
    }
    return (a[i] / powers[j]) % 10;
}

inline int get_size(const vector<int> &a) {
    return a.size() * SYM_LEN;
}

const int MAXN = 5982;

vector<vector<int>> factorials = {{0},
                                  {1}};

int guess = MAXN;

int request(int x) {
    cout << "? " << x + 1 << endl;
    int c;
    cin >> c;
    return c;
//    return get(factorials[guess], x);
}

void answer(int x) {
    cout << "! " << x << endl;
    string response;
    cin >> response;
//    assert(response == "YES");
}

inline vector<int> new_candidates(const vector<int> &candidates, int k, int c) {
    vector<int> ans;
    for (auto cand: candidates) {
        if (get(factorials[cand], k) == c) {
            ans.push_back(cand);
        }
    }
    return ans;
}

inline int get_best(const vector<int> &candidates) {
    int max_len = 0;
    pair<int, int> best = {1e9, 0};
    for (auto c: candidates) {
        max_len = max(max_len, get_size(factorials[c]));
    }
    for (int k = 0; k < max_len; k++) {
        int cnt[10] = {};
        for (auto c: candidates) {
            cnt[get(factorials[c], k)] += 1;
        }
        best = min(best, make_pair(*max_element(cnt, cnt + 10), k));
    }
    return best.second;
}

struct node {
    int r;
    vector<node *> go;
};

node *build(const vector<int> candidates, int depth = 3) {
    if (depth == 0) return nullptr;
    auto ans = new node();
    ans->r = get_best(candidates);
    for (int i = 0; i < 10; i++) {
        ans->go.push_back(build(new_candidates(candidates, ans->r, i), depth - 1));
    }
    return ans;
}

void print(node *r) {
    cout << "new node({.r=" << r->r << ",.go = {";
    for (auto c: r->go) {
        if (c == nullptr) {
            cout << "nullptr";
        } else {
            print(c);
        }
        cout << ",";
    }
    cout << "}})";
}


signed main() {
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    while (factorials.size() <= MAXN) {
        factorials.push_back(mult(factorials.back(), factorials.size()));
    }

    vector<int> candidates;
    for (int i = 1; i <= MAXN; i++) {
        candidates.push_back(i);
    }

//    auto root = build(candidates, 4);

    auto root = new node({.r=1601, .go = {new node({.r=181, .go = {new node(
            {.r=2001, .go = {new node({.r=28, .go = {}}), new node({.r=1442, .go = {}}), new node({.r=1461, .go = {}}),
                             new node({.r=1459, .go = {}}), new node({.r=1639, .go = {}}),
                             new node({.r=4427, .go = {}}), new node({.r=1473, .go = {}}),
                             new node({.r=1409, .go = {}}), new node({.r=1457, .go = {}}),
                             new node({.r=1503, .go = {}}),}}), new node(
            {.r=157, .go = {new node({.r=174, .go = {}}), new node({.r=123, .go = {}}), new node({.r=138, .go = {}}),
                            new node({.r=147, .go = {}}), new node({.r=89, .go = {}}), new node({.r=155, .go = {}}),
                            new node({.r=127, .go = {}}), new node({.r=49, .go = {}}), new node({.r=125, .go = {}}),
                            new node({.r=112, .go = {}}),}}), new node(
            {.r=162, .go = {new node({.r=188, .go = {}}), new node({.r=130, .go = {}}), new node({.r=146, .go = {}}),
                            new node({.r=146, .go = {}}), new node({.r=106, .go = {}}), new node({.r=116, .go = {}}),
                            new node({.r=63, .go = {}}), new node({.r=124, .go = {}}), new node({.r=171, .go = {}}),
                            new node({.r=134, .go = {}}),}}), new node(
            {.r=152, .go = {new node({.r=178, .go = {}}), new node({.r=155, .go = {}}), new node({.r=135, .go = {}}),
                            new node({.r=87, .go = {}}), new node({.r=126, .go = {}}), new node({.r=111, .go = {}}),
                            new node({.r=113, .go = {}}), new node({.r=117, .go = {}}), new node({.r=134, .go = {}}),
                            new node({.r=142, .go = {}}),}}), new node(
            {.r=167, .go = {new node({.r=159, .go = {}}), new node({.r=103, .go = {}}), new node({.r=128, .go = {}}),
                            new node({.r=142, .go = {}}), new node({.r=174, .go = {}}), new node({.r=152, .go = {}}),
                            new node({.r=119, .go = {}}), new node({.r=135, .go = {}}), new node({.r=107, .go = {}}),
                            new node({.r=192, .go = {}}),}}), new node(
            {.r=167, .go = {new node({.r=298, .go = {}}), new node({.r=225, .go = {}}), new node({.r=91, .go = {}}),
                            new node({.r=165, .go = {}}), new node({.r=162, .go = {}}), new node({.r=145, .go = {}}),
                            new node({.r=150, .go = {}}), new node({.r=185, .go = {}}), new node({.r=101, .go = {}}),
                            new node({.r=147, .go = {}}),}}), new node(
            {.r=198, .go = {new node({.r=111, .go = {}}), new node({.r=132, .go = {}}), new node({.r=78, .go = {}}),
                            new node({.r=121, .go = {}}), new node({.r=114, .go = {}}), new node({.r=157, .go = {}}),
                            new node({.r=165, .go = {}}), new node({.r=136, .go = {}}), new node({.r=112, .go = {}}),
                            new node({.r=165, .go = {}}),}}), new node(
            {.r=160, .go = {new node({.r=258, .go = {}}), new node({.r=144, .go = {}}), new node({.r=139, .go = {}}),
                            new node({.r=139, .go = {}}), new node({.r=89, .go = {}}), new node({.r=133, .go = {}}),
                            new node({.r=152, .go = {}}), new node({.r=138, .go = {}}), new node({.r=207, .go = {}}),
                            new node({.r=90, .go = {}}),}}), new node(
            {.r=207, .go = {new node({.r=109, .go = {}}), new node({.r=148, .go = {}}), new node({.r=115, .go = {}}),
                            new node({.r=220, .go = {}}), new node({.r=86, .go = {}}), new node({.r=165, .go = {}}),
                            new node({.r=168, .go = {}}), new node({.r=136, .go = {}}), new node({.r=111, .go = {}}),
                            new node({.r=135, .go = {}}),}}), new node(
            {.r=162, .go = {new node({.r=85, .go = {}}), new node({.r=167, .go = {}}), new node({.r=96, .go = {}}),
                            new node({.r=133, .go = {}}), new node({.r=77, .go = {}}), new node({.r=149, .go = {}}),
                            new node({.r=112, .go = {}}), new node({.r=119, .go = {}}), new node({.r=135, .go = {}}),
                            new node({.r=103, .go = {}}),}}),}}), new node({.r=1483, .go = {new node(
            {.r=1508, .go = {new node({.r=1269, .go = {}}), new node({.r=1333, .go = {}}),
                             new node({.r=1363, .go = {}}), new node({.r=902, .go = {}}), new node({.r=1036, .go = {}}),
                             new node({.r=771, .go = {}}), new node({.r=488, .go = {}}), new node({.r=1469, .go = {}}),
                             new node({.r=774, .go = {}}), new node({.r=1356, .go = {}}),}}), new node(
            {.r=1447, .go = {new node({.r=1464, .go = {}}), new node({.r=953, .go = {}}), new node({.r=1017, .go = {}}),
                             new node({.r=966, .go = {}}), new node({.r=959, .go = {}}), new node({.r=970, .go = {}}),
                             new node({.r=1117, .go = {}}), new node({.r=598, .go = {}}), new node({.r=1163, .go = {}}),
                             new node({.r=1129, .go = {}}),}}), new node(
            {.r=1889, .go = {new node({.r=726, .go = {}}), new node({.r=1422, .go = {}}), new node({.r=1106, .go = {}}),
                             new node({.r=978, .go = {}}), new node({.r=800, .go = {}}), new node({.r=1380, .go = {}}),
                             new node({.r=1432, .go = {}}), new node({.r=1257, .go = {}}), new node({.r=942, .go = {}}),
                             new node({.r=665, .go = {}}),}}), new node(
            {.r=1550, .go= {new node({.r=1324, .go = {}}), new node({.r=1301, .go = {}}), new node({.r=1266, .go = {}}),
                            new node({.r=326, .go = {}}), new node({.r=1223, .go = {}}), new node({.r=1350, .go = {}}),
                            new node({.r=1353, .go = {}}), new node({.r=1393, .go = {}}), new node({.r=1096, .go = {}}),
                            new node({.r=686, .go = {}}),}}), new node(
            {.r=1376, .go = {new node({.r=1462, .go = {}}), new node({.r=1161, .go = {}}), new node({.r=929, .go = {}}),
                             new node({.r=1006, .go = {}}), new node({.r=219, .go = {}}), new node({.r=893, .go = {}}),
                             new node({.r=796, .go = {}}), new node({.r=723, .go = {}}), new node({.r=920, .go = {}}),
                             new node({.r=1057, .go = {}}),}}), new node(
            {.r=1666, .go = {new node({.r=624, .go = {}}), new node({.r=960, .go = {}}), new node({.r=1171, .go = {}}),
                             new node({.r=1065, .go = {}}), new node({.r=253, .go = {}}), new node({.r=1449, .go = {}}),
                             new node({.r=896, .go = {}}), new node({.r=929, .go = {}}), new node({.r=774, .go = {}}),
                             new node({.r=1071, .go = {}}),}}), new node(
            {.r=1403, .go = {new node({.r=1447, .go = {}}), new node({.r=569, .go = {}}), new node({.r=0, .go = {}}),
                             new node({.r=1217, .go = {}}), new node({.r=869, .go = {}}), new node({.r=998, .go = {}}),
                             new node({.r=634, .go = {}}), new node({.r=1223, .go = {}}), new node({.r=946, .go = {}}),
                             new node({.r=1243, .go = {}}),}}), new node(
            {.r=1342, .go = {new node({.r=1412, .go = {}}), new node({.r=1025, .go = {}}), new node({.r=849, .go = {}}),
                             new node({.r=1155, .go = {}}), new node({.r=1166, .go = {}}), new node({.r=539, .go = {}}),
                             new node({.r=968, .go = {}}), new node({.r=1219, .go = {}}), new node({.r=781, .go = {}}),
                             new node({.r=687, .go = {}}),}}), new node(
            {.r=1792, .go = {new node({.r=1246, .go = {}}), new node({.r=713, .go = {}}), new node({.r=891, .go = {}}),
                             new node({.r=839, .go = {}}), new node({.r=1440, .go = {}}), new node({.r=1116, .go = {}}),
                             new node({.r=1388, .go = {}}), new node({.r=1179, .go = {}}), new node({.r=840, .go = {}}),
                             new node({.r=1027, .go = {}}),}}), new node(
            {.r=2376, .go = {new node({.r=1108, .go = {}}), new node({.r=1081, .go = {}}), new node({.r=462, .go = {}}),
                             new node({.r=1028, .go = {}}), new node({.r=1005, .go = {}}),
                             new node({.r=1105, .go = {}}), new node({.r=733, .go = {}}), new node({.r=674, .go = {}}),
                             new node({.r=1114, .go = {}}), new node({.r=1189, .go = {}}),}}),}}), new node(
            {.r=1692, .go = {new node({.r=1452, .go = {new node({.r=1488, .go = {}}), new node({.r=1413, .go = {}}),
                                                       new node({.r=1316, .go = {}}), new node({.r=796, .go = {}}),
                                                       new node({.r=853, .go = {}}), new node({.r=694, .go = {}}),
                                                       new node({.r=1138, .go = {}}), new node({.r=1255, .go = {}}),
                                                       new node({.r=881, .go = {}}), new node({.r=1119, .go = {}}),}}),
                             new node({.r=1541, .go = {new node({.r=1363, .go = {}}), new node({.r=650, .go = {}}),
                                                       new node({.r=1453, .go = {}}), new node({.r=1303, .go = {}}),
                                                       new node({.r=862, .go = {}}), new node({.r=852, .go = {}}),
                                                       new node({.r=1280, .go = {}}), new node({.r=837, .go = {}}),
                                                       new node({.r=1411, .go = {}}), new node({.r=1308, .go = {}}),}}),
                             new node({.r=1739, .go = {new node({.r=1310, .go = {}}), new node({.r=472, .go = {}}),
                                                       new node({.r=1073, .go = {}}), new node({.r=1244, .go = {}}),
                                                       new node({.r=1001, .go = {}}), new node({.r=611, .go = {}}),
                                                       new node({.r=1161, .go = {}}), new node({.r=1420, .go = {}}),
                                                       new node({.r=937, .go = {}}), new node({.r=1105, .go = {}}),}}),
                             new node({.r=1442, .go = {new node({.r=1494, .go = {}}), new node({.r=1001, .go = {}}),
                                                       new node({.r=1242, .go = {}}), new node({.r=996, .go = {}}),
                                                       new node({.r=1311, .go = {}}), new node({.r=1407, .go = {}}),
                                                       new node({.r=727, .go = {}}), new node({.r=903, .go = {}}),
                                                       new node({.r=1082, .go = {}}), new node({.r=666, .go = {}}),}}),
                             new node({.r=1378, .go = {new node({.r=1547, .go = {}}), new node({.r=1257, .go = {}}),
                                                       new node({.r=1121, .go = {}}), new node({.r=1234, .go = {}}),
                                                       new node({.r=795, .go = {}}), new node({.r=1335, .go = {}}),
                                                       new node({.r=1059, .go = {}}), new node({.r=1318, .go = {}}),
                                                       new node({.r=876, .go = {}}), new node({.r=1182, .go = {}}),}}),
                             new node({.r=1927, .go = {new node({.r=1284, .go = {}}), new node({.r=1152, .go = {}}),
                                                       new node({.r=1299, .go = {}}), new node({.r=1190, .go = {}}),
                                                       new node({.r=1388, .go = {}}), new node({.r=1152, .go = {}}),
                                                       new node({.r=1058, .go = {}}), new node({.r=1340, .go = {}}),
                                                       new node({.r=526, .go = {}}), new node({.r=1206, .go = {}}),}}),
                             new node({.r=1270, .go = {new node({.r=1430, .go = {}}), new node({.r=707, .go = {}}),
                                                       new node({.r=1121, .go = {}}), new node({.r=979, .go = {}}),
                                                       new node({.r=744, .go = {}}), new node({.r=936, .go = {}}),
                                                       new node({.r=681, .go = {}}), new node({.r=501, .go = {}}),
                                                       new node({.r=1205, .go = {}}), new node({.r=787, .go = {}}),}}),
                             new node({.r=2119, .go = {new node({.r=1326, .go = {}}), new node({.r=1045, .go = {}}),
                                                       new node({.r=729, .go = {}}), new node({.r=1330, .go = {}}),
                                                       new node({.r=1420, .go = {}}), new node({.r=1218, .go = {}}),
                                                       new node({.r=1024, .go = {}}), new node({.r=1298, .go = {}}),
                                                       new node({.r=757, .go = {}}), new node({.r=838, .go = {}}),}}),
                             new node({.r=1429, .go = {new node({.r=1465, .go = {}}), new node({.r=1038, .go = {}}),
                                                       new node({.r=1264, .go = {}}), new node({.r=808, .go = {}}),
                                                       new node({.r=896, .go = {}}), new node({.r=1327, .go = {}}),
                                                       new node({.r=1365, .go = {}}), new node({.r=1320, .go = {}}),
                                                       new node({.r=947, .go = {}}), new node({.r=1351, .go = {}}),}}),
                             new node({.r=1347, .go = {new node({.r=1440, .go = {}}), new node({.r=871, .go = {}}),
                                                       new node({.r=727, .go = {}}), new node({.r=920, .go = {}}),
                                                       new node({.r=865, .go = {}}), new node({.r=1247, .go = {}}),
                                                       new node({.r=591, .go = {}}), new node({.r=894, .go = {}}),
                                                       new node({.r=1101, .go = {}}),
                                                       new node({.r=1132, .go = {}}),}}),}}), new node({.r=2017, .go = {
            new node({.r=1196, .go = {new node({.r=1385, .go = {}}), new node({.r=1205, .go = {}}),
                                      new node({.r=1096, .go = {}}), new node({.r=895, .go = {}}),
                                      new node({.r=955, .go = {}}), new node({.r=574, .go = {}}),
                                      new node({.r=393, .go = {}}), new node({.r=191, .go = {}}),
                                      new node({.r=1110, .go = {}}), new node({.r=644, .go = {}}),}}), new node(
                    {.r=1302, .go = {new node({.r=1458, .go = {}}), new node({.r=1239, .go = {}}),
                                     new node({.r=958, .go = {}}), new node({.r=1265, .go = {}}),
                                     new node({.r=507, .go = {}}), new node({.r=1019, .go = {}}),
                                     new node({.r=1228, .go = {}}), new node({.r=867, .go = {}}),
                                     new node({.r=1114, .go = {}}), new node({.r=968, .go = {}}),}}), new node(
                    {.r=1615, .go ={new node({.r=1151, .go = {}}), new node({.r=953, .go = {}}),
                                    new node({.r=1338, .go= {}}), new node({.r=1417, .go = {}}),
                                    new node({.r=906, .go = {}}), new node({.r=1239, .go = {}}),
                                    new node({.r=1454, .go = {}}), new node({.r=973, .go = {}}),
                                    new node({.r=1225, .go = {}}), new node({.r=1000, .go = {}}),}}), new node(
                    {.r=1450, .go = {new node({.r=1483, .go = {}}), new node({.r=1270, .go = {}}),
                                     new node({.r=1045, .go = {}}), new node({.r=1417, .go = {}}),
                                     new node({.r=950, .go = {}}), new node({.r=445, .go = {}}),
                                     new node({.r=683, .go = {}}), new node({.r=713, .go = {}}),
                                     new node({.r=649, .go = {}}), new node({.r=888, .go = {}}),}}), new node(
                    {.r=1485, .go = {new node({.r=947, .go = {}}), new node({.r=978, .go = {}}),
                                     new node({.r=612, .go = {}}), new node({.r=1382, .go = {}}),
                                     new node({.r=915, .go = {}}), new node({.r=909, .go = {}}),
                                     new node({.r=759, .go = {}}), new node({.r=1280, .go = {}}),
                                     new node({.r=1226, .go ={}}), new node({.r=1080, .go = {}}),}}), new node(
                    {.r=1455, .go = {new node({.r=1278, .go = {}}), new node({.r=1346, .go = {}}),
                                     new node({.r=1088, .go = {}}), new node({.r=1277, .go = {}}),
                                     new node({.r=1318, .go = {}}), new node({.r=1102, .go = {}}),
                                     new node({.r=1264, .go = {}}), new node({.r=626, .go = {}}),
                                     new node({.r=1206, .go = {}}), new node({.r=1021, .go = {}}),}}),
            new node({.r=1997, .go = {new node({.r=1104, .go = {}}), new node({.r=1125, .go = {}}),
                                      new node({.r=1380, .go = {}}), new node({.r=1186, .go = {}}),
                                      new node({.r=893, .go ={}}), new node({.r=1292, .go = {}}),
                                      new node({.r=659, .go = {}}), new node({.r=1039, .go = {}}),
                                      new node({.r=787, .go = {}}), new node({.r=668, .go = {}}),}}), new node(
                    {.r=1444, .go = {new node({.r=1474, .go = {}}), new node({.r=1294, .go = {}}),
                                     new node({.r=1103, .go = {}}), new node({.r=848, .go = {}}),
                                     new node({.r=1327, .go = {}}), new node({.r=1135, .go = {}}),
                                     new node({.r=864, .go = {}}), new node({.r=1424, .go = {}}),
                                     new node({.r=783, .go = {}}), new node({.r=658, .go = {}}),}}), new node(
                    {.r=2237, .go = {new node({.r=565, .go = {}}), new node({.r=720, .go = {}}),
                                     new node({.r=1159, .go = {}}), new node({.r=1460, .go = {}}),
                                     new node({.r=1165, .go = {}}), new node({.r=1018, .go = {}}),
                                     new node({.r=1201, .go = {}}), new node({.r=1051, .go = {}}),
                                     new node({.r=1016, .go = {}}), new node({.r=1095, .go = {}}),}}), new node(
                    {.r=2373, .go = {new node({.r=1468, .go = {}}), new node({.r=831, .go = {}}),
                                     new node({.r=576, .go = {}}), new node({.r=1187, .go = {}}),
                                     new node({.r=1111, .go = {}}), new node({.r=1347, .go = {}}),
                                     new node({.r=947, .go = {}}), new node({.r=1255, .go = {}}),
                                     new node({.r=1165, .go = {}}), new node({.r=730, .go = {}}),}}),}}), new node(
            {.r=1543, .go = {new node({.r=1576, .go = {new node({.r=1101, .go = {}}), new node({.r=1350, .go = {}}),
                                                       new node({.r=984, .go = {}}), new node({.r=1148, .go = {}}),
                                                       new node({.r=964, .go = {}}), new node({.r=359, .go = {}}),
                                                       new node({.r=1132, .go = {}}), new node({.r=1048, .go = {}}),
                                                       new node({.r=822, .go = {}}), new node({.r=1419, .go = {}}),}}),
                             new node({.r=1475, .go = {new node({.r=1170, .go = {}}), new node({.r=986, .go = {}}),
                                                       new node({.r=1212, .go = {}}), new node({.r=1008, .go = {}}),
                                                       new node({.r=1354, .go = {}}), new node({.r=1303, .go = {}}),
                                                       new node({.r=1220, .go = {}}), new node({.r=824, .go = {}}),
                                                       new node({.r=764, .go = {}}), new node({.r=945, .go = {}}),}}),
                             new node({.r=1411, .go = {new node({.r=1468, .go = {}}), new node({.r=807, .go = {}}),
                                                       new node({.r=1284, .go = {}}), new node({.r=1305, .go = {}}),
                                                       new node({.r=1006, .go = {}}), new node({.r=1139, .go = {}}),
                                                       new node({.r=1027, .go = {}}), new node({.r=1078, .go = {}}),
                                                       new node({.r=1063, .go = {}}), new node({.r=1186, .go = {}}),}}),
                             new node({.r=1246, .go = {new node({.r=1388, .go = {}}), new node({.r=1058, .go = {}}),
                                                       new node({.r=883, .go = {}}), new node({.r=890, .go = {}}),
                                                       new node({.r=1146, .go = {}}), new node({.r=1069, .go = {}}),
                                                       new node({.r=879, .go = {}}), new node({.r=771, .go = {}}),
                                                       new node({.r=1014, .go = {}}), new node({.r=203, .go = {}}),}}),
                             new node({.r=1570, .go = {new node({.r=1296, .go = {}}), new node({.r=1124, .go = {}}),
                                                       new node({.r=1117, .go = {}}), new node({.r=814, .go = {}}),
                                                       new node({.r=941, .go = {}}), new node({.r=1238, .go = {}}),
                                                       new node({.r=1345, .go = {}}), new node({.r=1205, .go = {}}),
                                                       new node({.r=1461, .go = {}}), new node({.r=440, .go = {}}),}}),
                             new node({.r=1700, .go = {new node({.r=1386, .go = {}}), new node({.r=1188, .go = {}}),
                                                       new node({.r=952, .go = {}}), new node({.r=1323, .go ={}}),
                                                       new node({.r=889, .go = {}}), new node({.r=1385, .go = {}}),
                                                       new node({.r=1226, .go = {}}), new node({.r=1161, .go = {}}),
                                                       new node({.r=920, .go = {}}), new node({.r=656, .go = {}}),}}),
                             new node({.r=1831, .go = {new node({.r=1244, .go = {}}), new node({.r=964, .go = {}}),
                                                       new node({.r=1231, .go = {}}), new node({.r=1188, .go = {}}),
                                                       new node({.r=1058, .go = {}}), new node({.r=1283, .go = {}}),
                                                       new node({.r=810, .go = {}}), new node({.r=1298, .go = {}}),
                                                       new node({.r=1089, .go = {}}), new node({.r=933, .go = {}}),}}),
                             new node({.r=1361, .go = {new node({.r=1395, .go = {}}), new node({.r=1080, .go = {}}),
                                                       new node({.r=990, .go = {}}), new node({.r=563, .go = {}}),
                                                       new node({.r=1156, .go = {}}), new node({.r=931, .go = {}}),
                                                       new node({.r=582, .go = {}}), new node({.r=728, .go = {}}),
                                                       new node({.r=914, .go = {}}), new node({.r=1290, .go ={}}),}}),
                             new node({.r=1398, .go = {new node({.r=1444, .go = {}}), new node({.r=1295, .go = {}}),
                                                       new node({.r=610, .go = {}}), new node({.r=928, .go = {}}),
                                                       new node({.r=955, .go = {}}), new node({.r=1252, .go = {}}),
                                                       new node({.r=1317, .go = {}}), new node({.r=1032, .go = {}}),
                                                       new node({.r=1061, .go = {}}), new node({.r=1024, .go = {}}),}}),
                             new node({.r=1383, .go = {new node({.r=1437, .go = {}}), new node({.r=1348, .go = {}}),
                                                       new node({.r=767, .go = {}}), new node({.r=958, .go = {}}),
                                                       new node({.r=948, .go = {}}), new node({.r=1214, .go = {}}),
                                                       new node({.r=1181, .go = {}}), new node({.r=466, .go = {}}),
                                                       new node({.r=1048, .go = {}}),
                                                       new node({.r=808, .go = {}}),}}),}}), new node({.r=1524, .go = {
            new node({.r=1418, .go = {new node({.r=1400, .go = {}}), new node({.r=1068, .go = {}}),
                                      new node({.r=1211, .go = {}}), new node({.r=1194, .go = {}}),
                                      new node({.r=1233, .go = {}}), new node({.r=994, .go = {}}),
                                      new node({.r=846, .go = {}}), new node({.r=1234, .go = {}}),
                                      new node({.r=1170, .go = {}}), new node({.r=1354, .go = {}}),}}), new node(
                    {.r=1561, .go = {new node({.r=1308, .go = {}}), new node({.r=1316, .go = {}}),
                                     new node({.r=746, .go = {}}), new node({.r=1082, .go ={}}),
                                     new node({.r=334, .go = {}}), new node({.r=1077, .go = {}}),
                                     new node({.r=708, .go = {}}), new node({.r=1040, .go = {}}),
                                     new node({.r=1445, .go = {}}), new node({.r=1301, .go = {}}),}}), new node(
                    {.r=1428, .go = {new node({.r=1276, .go = {}}), new node({.r=1230, .go = {}}),
                                     new node({.r=1058, .go = {}}), new node({.r=793, .go = {}}),
                                     new node({.r=799, .go = {}}), new node({.r=961, .go = {}}),
                                     new node({.r=820, .go ={}}), new node({.r=1050, .go = {}}),
                                     new node({.r=989, .go = {}}), new node({.r=730, .go = {}}),}}), new node(
                    {.r=1429, .go = {new node({.r=1493, .go = {}}), new node({.r=1260, .go = {}}),
                                     new node({.r=1279, .go = {}}), new node({.r=502, .go = {}}),
                                     new node({.r=1368, .go = {}}), new node({.r=1241, .go = {}}),
                                     new node({.r=1075, .go = {}}), new node({.r=1100, .go = {}}),
                                     new node({.r=1369, .go = {}}), new node({.r=620, .go= {}}),}}), new node(
                    {.r=2083, .go = {new node({.r=1428, .go = {}}), new node({.r=1237, .go = {}}),
                                     new node({.r=773, .go = {}}), new node({.r=1172, .go = {}}),
                                     new node({.r=975, .go = {}}), new node({.r=785, .go = {}}),
                                     new node({.r=950, .go = {}}), new node({.r=1022, .go = {}}),
                                     new node({.r=1332, .go = {}}), new node({.r=1079, .go = {}}),}}), new node(
                    {.r=1833, .go = {new node({.r=1284, .go = {}}), new node({.r=1131, .go = {}}),
                                     new node({.r=1350, .go = {}}), new node({.r=1295, .go = {}}),
                                     new node({.r=1323, .go = {}}), new node({.r=1138, .go ={}}),
                                     new node({.r=1114, .go = {}}), new node({.r=968, .go = {}}),
                                     new node({.r=414, .go = {}}), new node({.r=1353, .go = {}}),}}), new node(
                    {.r=1816, .go = {new node({.r=912, .go = {}}), new node({.r=1415, .go = {}}),
                                     new node({.r=1236, .go = {}}), new node({.r=1161, .go = {}}),
                                     new node({.r=1290, .go = {}}), new node({.r=880, .go = {}}),
                                     new node({.r=825, .go = {}}), new node({.r=1141, .go = {}}),
                                     new node({.r=1189, .go = {}}), new node({.r=488, .go = {}}),}}), new node(
                    {.r=1354, .go = {new node({.r=1480, .go = {}}), new node({.r=1217, .go = {}}),
                                     new node({.r=587, .go = {}}), new node({.r=1308, .go = {}}),
                                     new node({.r=1083, .go = {}}), new node({.r=981, .go = {}}),
                                     new node({.r=1040, .go = {}}), new node({.r=854, .go = {}}),
                                     new node({.r=992, .go = {}}), new node({.r=764, .go = {}}),}}), new node(
                    {.r=1322, .go = {new node({.r=1456, .go = {}}), new node({.r=1289, .go = {}}),
                                     new node({.r=1037, .go = {}}), new node({.r=1244, .go = {}}),
                                     new node({.r=1132, .go = {}}), new node({.r=969, .go = {}}),
                                     new node({.r=718, .go = {}}), new node({.r=914, .go = {}}),
                                     new node({.r=878, .go = {}}), new node({.r=200, .go = {}}),}}), new node(
                    {.r=2199, .go = {new node({.r=210, .go = {}}), new node({.r=1453, .go = {}}),
                                     new node({.r=1252, .go = {}}), new node({.r=1337, .go = {}}),
                                     new node({.r=1320, .go = {}}), new node({.r=938, .go = {}}),
                                     new node({.r=1107, .go = {}}), new node({.r=1039, .go = {}}),
                                     new node({.r=652, .go = {}}), new node({.r=1254, .go = {}}),}}),}}), new node(
            {.r=1467, .go = {new node({.r=1521, .go = {new node({.r=643, .go = {}}), new node({.r=1241, .go = {}}),
                                                       new node({.r=1489, .go = {}}), new node({.r=1130, .go = {}}),
                                                       new node({.r=951, .go = {}}), new node({.r=1475, .go = {}}),
                                                       new node({.r=1112, .go = {}}), new node({.r=877, .go = {}}),
                                                       new node({.r=1336, .go = {}}), new node({.r=1191, .go = {}}),}}),
                             new node({.r=1414, .go = {new node({.r=1475, .go = {}}), new node({.r=1210, .go = {}}),
                                                       new node({.r=1025, .go = {}}), new node({.r=730, .go = {}}),
                                                       new node({.r=1121, .go = {}}), new node({.r=1274, .go ={}}),
                                                       new node({.r=771, .go = {}}), new node({.r=1386, .go = {}}),
                                                       new node({.r=770, .go = {}}), new node({.r=911, .go = {}}),}}),
                             new node({.r=1355, .go = {new node({.r=1429, .go = {}}), new node({.r=954, .go = {}}),
                                                       new node({.r=612, .go = {}}), new node({.r=1281, .go = {}}),
                                                       new node({.r=1022, .go = {}}), new node({.r=744, .go = {}}),
                                                       new node({.r=796, .go = {}}), new node({.r=1091, .go = {}}),
                                                       new node({.r=819, .go = {}}), new node({.r=1090, .go = {}}),}}),
                             new node({.r=1300, .go = {new node({.r=1427, .go = {}}), new node({.r=700, .go = {}}),
                                                       new node({.r=1268, .go = {}}), new node({.r=1164, .go = {}}),
                                                       new node({.r=601, .go = {}}), new node({.r=725, .go = {}}),
                                                       new node({.r=907, .go = {}}), new node({.r=1048, .go = {}}),
                                                       new node({.r=864, .go = {}}), new node({.r=1208, .go = {}}),}}),
                             new node({.r=1621, .go = {new node({.r=884, .go = {}}), new node({.r=989, .go = {}}),
                                                       new node({.r=1089, .go = {}}), new node({.r=1164, .go = {}}),
                                                       new node({.r=1001, .go = {}}), new node({.r=1020, .go = {}}),
                                                       new node({.r=1204, .go = {}}), new node({.r=875, .go = {}}),
                                                       new node({.r=1386, .go = {}}), new node({.r=638, .go = {}}),}}),
                             new node({.r=1509, .go = {new node({.r=870, .go = {}}), new node({.r=799, .go = {}}),
                                                       new node({.r=710, .go = {}}), new node({.r=807, .go = {}}),
                                                       new node({.r=1177, .go = {}}), new node({.r=892, .go = {}}),
                                                       new node({.r=1436, .go = {}}), new node({.r=896, .go = {}}),
                                                       new node({.r=711, .go = {}}), new node({.r=877, .go = {}}),}}),
                             new node({.r=1396, .go = {new node({.r=1410, .go = {}}), new node({.r=0, .go = {}}),
                                                       new node({.r=1061, .go = {}}), new node({.r=1288, .go = {}}),
                                                       new node({.r=1283, .go = {}}), new node({.r=844, .go = {}}),
                                                       new node({.r=1153, .go = {}}), new node({.r=859, .go = {}}),
                                                       new node({.r=512, .go = {}}), new node({.r=1059, .go ={}}),}}),
                             new node({.r=2539, .go = {new node({.r=1024, .go = {}}), new node({.r=780, .go = {}}),
                                                       new node({.r=708, .go = {}}), new node({.r=1052, .go = {}}),
                                                       new node({.r=1085, .go = {}}), new node({.r=1358, .go = {}}),
                                                       new node({.r=1249, .go = {}}), new node({.r=1270, .go = {}}),
                                                       new node({.r=1209, .go = {}}), new node({.r=847, .go = {}}),}}),
                             new node({.r=1515, .go = {new node({.r=1346, .go = {}}), new node({.r=1315, .go = {}}),
                                                       new node({.r=722, .go = {}}), new node({.r=1328, .go = {}}),
                                                       new node({.r=803, .go = {}}), new node({.r=1335, .go = {}}),
                                                       new node({.r=1278, .go = {}}), new node({.r=1172, .go = {}}),
                                                       new node({.r=1359, .go = {}}), new node({.r=1100, .go = {}}),}}),
                             new node({.r=1262, .go = {new node({.r=1417, .go = {}}), new node({.r=1126, .go = {}}),
                                                       new node({.r=1014, .go = {}}), new node({.r=863, .go = {}}),
                                                       new node({.r=1161, .go = {}}), new node({.r=1234, .go = {}}),
                                                       new node({.r=1172, .go = {}}), new node({.r=1090, .go = {}}),
                                                       new node({.r=1084, .go= {}}),
                                                       new node({.r=1127, .go = {}}),}}),}}), new node({.r=1786, .go = {
            new node({.r=1381, .go = {new node({.r=950, .go = {}}), new node({.r=876, .go = {}}),
                                      new node({.r=1124, .go = {}}), new node({.r=1240, .go = {}}),
                                      new node({.r=419, .go = {}}), new node({.r=1220, .go = {}}),
                                      new node({.r=1118, .go = {}}), new node({.r=660, .go = {}}),
                                      new node({.r=888, .go = {}}), new node({.r=775, .go = {}}),}}), new node(
                    {.r=1468, .go = {new node({.r=1484, .go = {}}), new node({.r=1115, .go = {}}),
                                     new node({.r=698, .go = {}}), new node({.r=1385, .go = {}}),
                                     new node({.r=1065, .go = {}}), new node({.r=1217, .go = {}}),
                                     new node({.r=1255, .go = {}}), new node({.r=1327, .go = {}}),
                                     new node({.r=1383, .go = {}}), new node({.r=985, .go = {}}),}}), new node(
                    {.r=1292, .go = {new node({.r=1454, .go = {}}), new node({.r=822, .go = {}}),
                                     new node({.r=738, .go = {}}), new node({.r=618, .go = {}}),
                                     new node({.r=820, .go = {}}), new node({.r=1017, .go = {}}),
                                     new node({.r=729, .go = {}}), new node({.r=820, .go = {}}),
                                     new node({.r=1032, .go = {}}), new node({.r=1043, .go = {}}),}}), new node(
                    {.r=1485, .go = {new node({.r=1237, .go = {}}), new node({.r=1188, .go = {}}),
                                     new node({.r=1053, .go = {}}), new node({.r=1100, .go = {}}),
                                     new node({.r=651, .go = {}}), new node({.r=990, .go = {}}),
                                     new node({.r=749, .go = {}}), new node({.r=610, .go = {}}),
                                     new node({.r=1328, .go = {}}), new node({.r=1046, .go = {}}),}}), new node(
                    {.r=1904, .go = {new node({.r=1375, .go = {}}), new node({.r=827, .go = {}}),
                                     new node({.r=1423, .go = {}}), new node({.r=919, .go = {}}),
                                     new node({.r=922, .go = {}}), new node({.r=1089, .go = {}}),
                                     new node({.r=842, .go = {}}), new node({.r=620, .go = {}}),
                                     new node({.r=1459, .go = {}}), new node({.r=879, .go = {}}),}}), new node(
                    {.r=1393, .go = {new node({.r=1480, .go = {}}), new node({.r=1182, .go = {}}),
                                     new node({.r=475, .go = {}}), new node({.r=1225, .go = {}}),
                                     new node({.r=1237, .go = {}}), new node({.r=940, .go = {}}),
                                     new node({.r=1153, .go = {}}), new node({.r=1006, .go = {}}),
                                     new node({.r=1264, .go = {}}), new node({.r=1175, .go = {}}),}}), new node(
                    {.r=1745, .go = {new node({.r=1145, .go = {}}), new node({.r=890, .go = {}}),
                                     new node({.r=1117, .go = {}}), new node({.r=1481, .go = {}}),
                                     new node({.r=1240, .go = {}}), new node({.r=514, .go = {}}),
                                     new node({.r=562, .go = {}}), new node({.r=1159, .go = {}}),
                                     new node({.r=1283, .go = {}}), new node({.r=1330, .go = {}}),}}), new node(
                    {.r=1462, .go = {new node({.r=959, .go = {}}), new node({.r=1206, .go = {}}),
                                     new node({.r=1292, .go = {}}), new node({.r=853, .go = {}}),
                                     new node({.r=1050, .go = {}}), new node({.r=1295, .go = {}}),
                                     new node({.r=1268, .go = {}}), new node({.r=211, .go = {}}),
                                     new node({.r=1254, .go = {}}), new node({.r=1356, .go = {}}),}}), new node(
                    {.r=2180, .go = {new node({.r=1205, .go = {}}), new node({.r=1275, .go = {}}),
                                     new node({.r=1350, .go = {}}), new node({.r=1209, .go = {}}),
                                     new node({.r=1061, .go = {}}), new node({.r=1175, .go = {}}),
                                     new node({.r=650, .go = {}}), new node({.r=1280, .go ={}}),
                                     new node({.r=1315, .go = {}}), new node({.r=770, .go = {}}),}}), new node(
                    {.r=1390, .go = {new node({.r=1458, .go = {}}), new node({.r=1046, .go = {}}),
                                     new node({.r=833, .go = {}}), new node({.r=1141, .go = {}}),
                                     new node({.r=604, .go = {}}), new node({.r=937, .go = {}}),
                                     new node({.r=1148, .go = {}}), new node({.r=862, .go = {}}),
                                     new node({.r=1251, .go = {}}), new node({.r=992, .go = {}}),}}),}}), new node(
            {.r=1456, .go = {new node({.r=1513, .go = {new node({.r=1457, .go = {}}), new node({.r=1034, .go = {}}),
                                                       new node({.r=1078, .go = {}}), new node({.r=1525, .go = {}}),
                                                       new node({.r=1193, .go = {}}), new node({.r=1176, .go = {}}),
                                                       new node({.r=1477, .go = {}}), new node({.r=1477, .go = {}}),
                                                       new node({.r=1482, .go = {}}), new node({.r=1473, .go = {}}),}}),
                             new node({.r=1484, .go = {new node({.r=907, .go = {}}), new node({.r=1303, .go = {}}),
                                                       new node({.r=962, .go = {}}), new node({.r=1118, .go = {}}),
                                                       new node({.r=973, .go = {}}), new node({.r=908, .go = {}}),
                                                       new node({.r=1034, .go = {}}), new node({.r=1373, .go = {}}),
                                                       new node({.r=1193, .go = {}}), new node({.r=724, .go = {}}),}}),
                             new node({.r=1556, .go = {new node({.r=848, .go = {}}), new node({.r=1183, .go = {}}),
                                                       new node({.r=413, .go = {}}), new node({.r=701, .go = {}}),
                                                       new node({.r=954, .go = {}}), new node({.r=1158, .go = {}}),
                                                       new node({.r=581, .go = {}}), new node({.r=1007, .go = {}}),
                                                       new node({.r=900, .go = {}}), new node({.r=1043, .go = {}}),}}),
                             new node({.r=1401, .go = {new node({.r=1410, .go = {}}), new node({.r=571, .go = {}}),
                                                       new node({.r=743, .go = {}}), new node({.r=762, .go = {}}),
                                                       new node({.r=423, .go = {}}), new node({.r=1200, .go = {}}),
                                                       new node({.r=736, .go = {}}), new node({.r=1099, .go = {}}),
                                                       new node({.r=1230, .go = {}}), new node({.r=1242, .go = {}}),}}),
                             new node({.r=1521, .go = {new node({.r=687, .go = {}}), new node({.r=709, .go = {}}),
                                                       new node({.r=1365, .go = {}}), new node({.r=1139, .go = {}}),
                                                       new node({.r=1101, .go = {}}), new node({.r=1461, .go = {}}),
                                                       new node({.r=1118, .go = {}}), new node({.r=994, .go = {}}),
                                                       new node({.r=1154, .go = {}}), new node({.r=852, .go = {}}),}}),
                             new node({.r=2608, .go = {new node({.r=976, .go = {}}), new node({.r=777, .go = {}}),
                                                       new node({.r=1002, .go = {}}), new node({.r=1344, .go = {}}),
                                                       new node({.r=1093, .go = {}}), new node({.r=1247, .go = {}}),
                                                       new node({.r=1362, .go = {}}), new node({.r=1298, .go = {}}),
                                                       new node({.r=1146, .go = {}}), new node({.r=1210, .go = {}}),}}),
                             new node({.r=1290, .go = {new node({.r=1243, .go = {}}), new node({.r=945, .go = {}}),
                                                       new node({.r=810, .go = {}}), new node({.r=727, .go = {}}),
                                                       new node({.r=1260, .go = {}}), new node({.r=474, .go = {}}),
                                                       new node({.r=602, .go = {}}), new node({.r=1200, .go = {}}),
                                                       new node({.r=806, .go = {}}), new node({.r=931, .go = {}}),}}),
                             new node({.r=1428, .go = {new node({.r=1447, .go = {}}), new node({.r=1360, .go = {}}),
                                                       new node({.r=476, .go = {}}), new node({.r=1295, .go = {}}),
                                                       new node({.r=929, .go = {}}), new node({.r=408, .go = {}}),
                                                       new node({.r=512, .go = {}}), new node({.r=1079, .go = {}}),
                                                       new node({.r=1189, .go = {}}), new node({.r=1223, .go = {}}),}}),
                             new node({.r=1346, .go = {new node({.r=1355, .go = {}}), new node({.r=1352, .go = {}}),
                                                       new node({.r=1097, .go = {}}), new node({.r=1012, .go = {}}),
                                                       new node({.r=1110, .go = {}}), new node({.r=926, .go = {}}),
                                                       new node({.r=283, .go = {}}), new node({.r=1196, .go = {}}),
                                                       new node({.r=725, .go = {}}), new node({.r=1208, .go = {}}),}}),
                             new node({.r=1268, .go = {new node({.r=1338, .go = {}}), new node({.r=1189, .go= {}}),
                                                       new node({.r=298, .go = {}}), new node({.r=1139, .go = {}}),
                                                       new node({.r=958, .go = {}}), new node({.r=1146, .go = {}}),
                                                       new node({.r=956, .go = {}}), new node({.r=1105, .go = {}}),
                                                       new node({.r=585, .go = {}}),
                                                       new node({.r=1095, .go = {}}),}}),}}), new node({.r=1600, .go = {
            new node({.r=1404, .go = {new node({.r=1475, .go = {}}), new node({.r=755, .go = {}}),
                                      new node({.r=1034, .go = {}}), new node({.r=1309, .go = {}}),
                                      new node({.r=898, .go = {}}), new node({.r=1312, .go = {}}),
                                      new node({.r=1017, .go = {}}), new node({.r=1277, .go = {}}),
                                      new node({.r=980, .go = {}}), new node({.r=1020, .go = {}}),}}), new node(
                    {.r=1453, .go = {new node({.r=1237, .go = {}}), new node({.r=1317, .go = {}}),
                                     new node({.r=915, .go = {}}), new node({.r=604, .go = {}}),
                                     new node({.r=1225, .go = {}}), new node({.r=1274, .go = {}}),
                                     new node({.r=912, .go = {}}), new node({.r=768, .go = {}}),
                                     new node({.r=784, .go = {}}), new node({.r=742, .go = {}}),}}), new node(
                    {.r=1485, .go = {new node({.r=1101, .go = {}}), new node({.r=1023, .go = {}}),
                                     new node({.r=1137, .go = {}}), new node({.r=713, .go = {}}),
                                     new node({.r=1318, .go = {}}), new node({.r=921, .go = {}}),
                                     new node({.r=1329, .go = {}}), new node({.r=1362, .go = {}}),
                                     new node({.r=1193, .go = {}}), new node({.r=993, .go = {}}),}}), new node(
                    {.r=1397, .go = {new node({.r=1422, .go = {}}), new node({.r=1134, .go = {}}),
                                     new node({.r=1130, .go = {}}), new node({.r=788, .go = {}}),
                                     new node({.r=1116, .go = {}}), new node({.r=1100, .go = {}}),
                                     new node({.r=822, .go = {}}), new node({.r=1100, .go = {}}),
                                     new node({.r=1241, .go = {}}), new node({.r=885, .go = {}}),}}), new node(
                    {.r=1359, .go = {new node({.r=1385, .go = {}}), new node({.r=624, .go = {}}),
                                     new node({.r=1217, .go = {}}), new node({.r=943, .go = {}}),
                                     new node({.r=1032, .go = {}}), new node({.r=864, .go = {}}),
                                     new node({.r=735, .go = {}}), new node({.r=826, .go = {}}),
                                     new node({.r=837, .go = {}}), new node({.r=677, .go = {}}),}}), new node(
                    {.r=1412, .go = {new node({.r=1486, .go = {}}), new node({.r=1229, .go = {}}),
                                     new node({.r=1051, .go = {}}), new node({.r=1065, .go = {}}),
                                     new node({.r=953, .go = {}}), new node({.r=1308, .go = {}}),
                                     new node({.r=1205, .go = {}}), new node({.r=1036, .go = {}}),
                                     new node({.r=1256, .go = {}}), new node({.r=1294, .go = {}}),}}), new node(
                    {.r=1338, .go = {new node({.r=1401, .go = {}}), new node({.r=830, .go = {}}),
                                     new node({.r=1222, .go = {}}), new node({.r=1150, .go = {}}),
                                     new node({.r=1298, .go = {}}), new node({.r=1051, .go = {}}),
                                     new node({.r=1150, .go = {}}), new node({.r=926, .go = {}}),
                                     new node({.r=0, .go = {}}), new node({.r=1008, .go = {}}),}}), new node(
                    {.r=1363, .go = {new node({.r=1460, .go = {}}), new node({.r=941, .go = {}}),
                                     new node({.r=735, .go = {}}), new node({.r=1288, .go = {}}),
                                     new node({.r=742, .go = {}}), new node({.r=1261, .go = {}}),
                                     new node({.r=1168, .go = {}}), new node({.r=1196, .go= {}}),
                                     new node({.r=1233, .go = {}}), new node({.r=0, .go = {}}),}}), new node(
                    {.r=2122, .go = {new node({.r=1476, .go = {}}), new node({.r=837, .go = {}}),
                                     new node({.r=1085, .go = {}}), new node({.r=833, .go = {}}),
                                     new node({.r=813, .go = {}}), new node({.r=1338, .go = {}}),
                                     new node({.r=987, .go = {}}), new node({.r=1415, .go = {}}),
                                     new node({.r=1175, .go = {}}), new node({.r=1279, .go = {}}),}}), new node(
                    {.r=1285, .go = {new node({.r=1350, .go = {}}), new node({.r=926, .go = {}}),
                                     new node({.r=1002, .go = {}}), new node({.r=849, .go = {}}),
                                     new node({.r=607, .go = {}}), new node({.r=1268, .go = {}}),
                                     new node({.r=932, .go = {}}), new node({.r=942, .go = {}}),
                                     new node({.r=1170, .go = {}}), new node({.r=1036, .go = {}}),}}),}}),}});


//    print(root);
//    cout.flush();

    int test_cases = 0;
    cin >> test_cases;
    auto can = candidates;
    while (test_cases--) {
        candidates = can;
        auto cur = root;
        while (candidates.size() > 1) {
            int r;
            if (cur == nullptr) {
                r = get_best(candidates);
            } else {
                r = cur->r;
            }
            int c = request(r);
            candidates = new_candidates(candidates, r, c);
//            cout << candidates.size() << " " << r << endl;
            if (cur && cur->go.size() > c) {
                cur = cur->go[c];
            } else {
                cur = nullptr;
            }
        }
        answer(candidates[0]);
    }

    return 0;
}
