#include <iostream>
#include <algorithm>
#include <random>

using namespace std;

void solve() {
    static mt19937 rng(623);
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &x: a) {
        cin >> x;
        --x;
    }

    if (n == 2) {
        if (a[0] == 0) {
            cout << "Possible\n2 1\n 2 1\n";
        } else {
            cout << "Impossible\n";
        }
        return;
    }

    vector<int> p(n), q(n);
    for (int i = 0; i < n; i++) p[i] = i;

    bool good = false;
    for (int tr = 0; tr < 256; tr++) {
        shuffle(p.begin(), p.end(), rng);
        good = true;
        for (int i = 0; i < n; i++) {
            if (p[i] == i || a[p[i]] == i) {
                good = false;
                break;
            }
        }

        if (good) break;
    }

    if (!good) {
        cout << "Impossible\n";
        return;
    }

    for (int i = 0 ; i < n; i++) {
        q[a[p[i]]] = i;
    }

    cout << "Possible\n";
    for (auto& x : p) cout << x+1 << ' ';
    cout << '\n';
    for (auto& x : q) cout << x+1 << ' ';
    cout << '\n';
    return;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }


    return 0;
}
