#include <iostream>
#include <algorithm>
#include "bits/stdc++.h"
#include <random>

using namespace std;

bool dfs(int s, const vector<vector<int>> e[2], vector<int> visited[2], vector<int> match[2], int &vis_cur, bool rem) {
    visited[rem][s] = vis_cur;
    for (int t: e[rem][s]) {
        if (match[!rem][t] == -1) {
            match[!rem][t] = s;
            match[rem][s] = t;
            return true;
        }

        int u = match[!rem][t];
        if (visited[rem][u] == vis_cur) continue;
        if (dfs(u, e, visited, match, vis_cur, rem)) {
            match[!rem][t] = s;
            match[rem][s] = t;
            return true;
        }
    }
    return false;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef _DEBUG
    freopen("../input.txt", "r", stdin);
#endif

    int n, k;
#ifndef _DEBUG
    cin >> n >> k;
    vector<vector<int>> pos(k, vector<int>(n));
    vector<vector<int>> p(k, vector<int>(n));
    for (int run = 0; run < k; run++) {
        for (int i = 0; i < n; i++) {
            int v;
            cin >> v;
            --v;
            pos[run][v] = i;
            p[run][i] = v;
        }
    }
#else
    n = 6;
    k = 50;
    vector<int> true_pars = { -1, 0, 0, 1, 1, 2, 2 };

    vector<vector<int>> pos(k, vector<int>(n));
    vector<vector<int>> p(k, vector<int>(n));

    vector<vector<int>> e(n);
    for (int i = 0; i < n; i++) if (true_pars[i] != -1) e[true_pars[i]].push_back(i);
    mt19937 rng(123);
//    function<void(int, vector<int>&)> gen = [&](int i, vector<int> &order) {
//        bool go = rng() & 1;
//        if (e[i].empty()) {
//            order.push_back(i);
//            return;
//        }
//        gen(e[go], order);
//        order.push_back(i);
//        gen(e[!go], order);
//    }

    for (int run = 0; run < k; run++) {
        for (int i = 0; i < n; i++) {
            int v = p[run][i];
            pos[run][v] = i;
        }
    }

#endif
    vector<vector<int>> prevs(n);
    vector<char> leaf(n, false);
    vector<int> par(n, -1);

    int notleafs = n;

    while (notleafs > 1) {
        vector<int> filtered(n);
        vector<set<pair<int, int>>> prv_nxt(n);
        vector<char> newleaf(n, 0);
        for (int run = 0; run < k; run++) {
            filtered.resize(0);
            for (int cur : p[run]) {
                if (leaf[cur]) continue;
                filtered.push_back(cur);
            }

            par[filtered[0]] = (filtered[1]);
            par[filtered.back()] = (filtered[filtered.size() - 2]);
            newleaf[filtered[0]] = true;
            newleaf[filtered.back()] = true;

            for (int i = 1; i + 1 < filtered.size(); i++) {
                prv_nxt[filtered[i]].insert({min(filtered[i - 1], filtered[i + 1]), max(filtered[i - 1], filtered[i + 1])});
            }
        }

        for (int c = 0; c < n; c++) {
            if (leaf[c] || newleaf[c]) continue;
            bool isleaf = false;
            for (auto [prv, nxt]: prv_nxt[c]) {
                for (int run = 0; run < k; run++) {
                    if ((pos[run][prv] < pos[run][c]) == (pos[run][nxt] < pos[run][c])) {
                        isleaf = true;
                        break;
                    }
                }
            }

            if (isleaf) {

                int par1 = -1, par2 = -1;
                int par_real = -1;
                for (auto [prv, nxt]: prv_nxt[c]) {
                    if (par1 == -1 && par2 == -1) {
                        par1 = prv; par2 = nxt;
                    } else {
                        if (par1 != prv && par1 != nxt) {
                            par_real = par2;
                            break;
                        }
                        if (par2 != prv && par2 != nxt) {
                            par_real = par1;
                            break;
                        }
                    }
                }
                par[c] = par_real;
                newleaf[c] = true;
            }
        }

        vector<char> parfound(n, 0);
        for (int i = 0; i < n; i++) {
            if (newleaf[i]) {
                parfound[par[i]]++;
            }
        }
        for (int i = 0; i < n; i++) {
            if (newleaf[i]) {
                if (parfound[par[i]] == 2) {
                    leaf[i] = true;
                    notleafs--;
                }
            }
        }
    }

    for (auto x: par) cout << ((x == -1) ? -1 : (x + 1)) << ' ';
    cout << '\n';

    return 0;
}
