#include <iostream>
#include <algorithm>
#include "bits/stdc++.h"
#include <random>

using namespace std;

bool dfs(int s, const vector<vector<int>> e[2], vector<int> visited[2], vector<int> match[2], int& vis_cur, bool rem) {
    visited[rem][s] = vis_cur;
    for (int t : e[rem][s]) {
        if (match[!rem][t] == -1) {
            match[!rem][t] = s;
            match[rem][s] = t;
            return true;
        }

        int u = match[!rem][t];
        if (visited[rem][u] == vis_cur) continue;
        if (dfs(u, e, visited, match, vis_cur, rem)) {
            match[!rem][t] = s;
            match[rem][s] = t;
            return true;
        }
    }
    return false;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef _DEBUG
    freopen("../input.txt", "r", stdin);
#endif

    int n, m;
    cin >> n >> m;
    vector<string> fld(n);
    for (auto& s : fld) cin >> s;

    map<pair<int, int>, int> id[2];
    int free = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (fld[i][j] != '.') continue;
            free++;
            auto& idc = id[(i + j) % 2];
            int sz = idc.size();
            idc[{i,j}] = sz;
        }
    }

    if (free > 2000) {
        cout << 1'000'000;
        return 0;
    }

    vector<vector<int>> e[2];
    e[0].resize(id[0].size());
    e[1].resize(id[1].size());

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (fld[i][j] != '.') continue;

            bool rem = (i + j) % 2;
            int cur_id = id[rem][{i,j}];

            vector<pair<int, int>> diffs = {{1, 0}, {0, 1}};
            for (auto [dx, dy] : diffs) {
                int it = i + dx;
                int jt = j + dy;
                if (it >= n || jt >= m || fld[it][jt] != '.') continue;

                int to_id = id[!rem][{it,jt}];
                e[rem][cur_id].push_back(to_id);
                e[!rem][to_id].push_back(cur_id);
            }
        }
    }

    vector<int> match[2];
    match[0].resize(e[0].size(), -1);
    match[1].resize(e[1].size(), -1);

    vector<int> visited[2];
    visited[0].resize(e[0].size(), -1);
    visited[1].resize(e[1].size(), -1);
    int vis_cur = 1;
    {
        for (int s = 0; s < match[0].size(); s++) {
            if (visited[0][s] == vis_cur || match[0][s] != -1) continue;
            bool x = dfs(s, e, visited, match, vis_cur, false);
            if (!x) exit(123);
            vis_cur++;
        }
    }

    int64_t P = (free / 2) * (free / 2 - 1);
    int64_t A = 0;
    for (char rem = 0; rem <= 1; rem++) {

        for (int s = 0; s < e[rem].size(); s++) {
            int ss = match[rem][s];
            bool x = dfs(ss, e, visited, match, vis_cur, !rem);
            if (x) exit(123);

            int left_cnt = 0;

            for (int tt = 0; tt < e[!rem].size(); tt++) {
                if (visited[!rem][tt] == vis_cur) {
                    for (int p : e[!rem][tt]) {
                        if (visited[rem][p] != vis_cur) {
                            left_cnt++;
                            visited[rem][p] = vis_cur;
                        }
                    }
                }
            }
            vis_cur++;

            A += e[rem].size() - left_cnt;
        }
    }



    cout << min(P + A / 2, (int64_t) 1'000'000) << '\n';
    cerr << P << ' ' << A << endl;
    return 0;
}
