#include <bits/stdc++.h>

void wperm (const std::vector<int> &p)
{
    for (int i = 0; i < (int)p.size(); ++i) {
        std::cout << (i ? " " : "") << (p[i]+1);
    }
    std::cout << "\n";
}

void inv (const std::vector<int> &in,
          std::vector<int> &out)
{
    out.resize(in.size());
    for (int i = 0; i < (int)in.size(); ++i) {
        out[in[i]] = i;
    }
}

void mul (const std::vector<int> &a,
          const std::vector<int> &b,
          std::vector<int> &out)
{
    int n = (int)a.size();
    out.resize(n);
    for (int i = 0; i < n; ++i) {
        out[i] = a[b[i]];
    }
}

void cycshift(const std::vector<int> &src,
              int k,
              std::vector<int> &dst)
{
    int n = (int)src.size();
    dst.resize(n);
    for (int i = 0; i < n; ++i) {
        int di = i + k;
        if (di >= n) {
            di -= n;
        }
        dst[i] = src[di];
    }
}

void swapbad(const std::vector<int> &x,
             std::vector<int> &q)
{
    int n = (int)x.size();
    int bad = -1;
    for (int i = 0; i < n; ++i) {
        if (x[i] == q[i]) {
            bad = i;
            break;
        }
    }

    for (int i = 0; i < n; ++i) {
        if (i == q[bad] or x[i] == q[bad]) {
            continue;
        } else {
            std::swap(q[i], q[bad]);
            break;
        }
    }
}

void findq(const std::vector<int> &x,
           const std::vector<int> &disco,
           std::vector<int> &q)
{
    int n = (int)x.size();
    std::vector<int> one (n);
    for (int i = 0; i < n; ++i) {
        one[i] = i;
    }
    for (int i = 1; i < n; ++i) {
        if (disco[i] == 0) {
            cycshift(one, i, q);
            break;
        } else if (disco[i] == 1) {
            cycshift(one, i, q);
            swapbad(x, q);
            break;
        }
    }
}

bool bada (const std::vector<int> &a)
{
    return a[0] == 1 and a[1] == 0;
}

void do1 ()
{
    int n;
    std::cin >> n;

    std::vector<int> a (n);
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i];
        a[i]--;
    }

    if (n == 1 or (n == 2 and bada(a))) {
        std::cout << "Impossible\n";

    } else {
        std::vector<int> x(n);
        inv(a, x);

        std::vector<int> disco(n); // disable cyclic shifts
        for (int i = 0; i < n; ++i) {
            int d = x[i] - i;
            if (d < 0) {
                d += n;
            }
            disco[d]++;
        }

        std::vector<int> q(n);
        findq(x, disco, q);

        std::vector<int> qinv(n);
        inv(q, qinv);

        std::vector<int> p(n);
        mul(x, qinv, p);

        std::cout << "Possible\n";
        wperm(p);
        wperm(q);
    }
}

int main ()
{
    std::ios_base::sync_with_stdio(false);

    int t;
    std::cin >> t;
    for (int i = 0; i < t; ++i) {
        do1();
    }

    return 0;
}
