#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <cmath>
#include <queue>
#include <stack>
#include <ctime>
#include <random>
using namespace std;

typedef long long ll;
typedef long double ld;

mt19937 rndm(0);

void start() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cout.precision(10); cout.setf(ios::fixed);

}

const int maxn = 1e5 + 5;

pair<int, int> st[4 * maxn];

set<int> ban[maxn];

int vl[maxn];
int sav[maxn];

int inp[maxn];
int ansq[maxn];
int ansp[maxn];
int rev[maxn];

set<int> nonu;

void build(int v, int l, int r) {
	sav[v] = 0;
	if (l == r) {
		st[v] = { vl[l], l };
	}
	else {
		int mid = (l + r) >> 1;
		build(v * 2, l, mid);
		build(v * 2 + 1, mid + 1, r);
		st[v] = min(st[v * 2], st[v * 2 + 1]);
	}
}

void push(int v) {
	st[v * 2].first -= sav[v];
	st[v * 2 + 1].first -= sav[v];
	sav[v * 2] += sav[v];
	sav[v * 2 + 1] += sav[v * 2 + 1];
	sav[v] = 0;
}

void query(int v, int l, int r, int tl, int tr, int val) {
	if (l != r) {
		push(v);
	}
	if (tl > r || tr < l) return;
	if (tl == l && tr == r) {
		st[v].first -= val;
		sav[v] = val;
	}
	else {
		int mid = (l + r) >> 1;
		query(v * 2, l, mid, tl, min(tr, mid), val);
		query(v * 2 + 1, mid + 1, r, max(mid + 1, tl), tr, val);
		st[v] = min(st[v * 2], st[v * 2 + 1]);
	}
}

int main() {
	start();
	int tt;
	cin >> tt;
	while (tt--) {
		int n;
		cin >> n;
		for (int i = 1; i <= n; ++i) {
			cin >> inp[i];
			rev[inp[i]] = i;
		}
		if (n <= 2) {
			if (n == 2 && inp[1] == 1) {
				cout << "Possible\n";
				cout << "2 1\n";
				cout << "2 1\n";
			}
			else {
				cout << "Impossible\n";
			}
			continue;
		}
		cout << "Possible\n";
		for (int i = 1; i <= n; ++i) {
			ban[i] = { i };
		}
		for (int i = 1; i <= n; ++i) {
			ban[inp[i]].insert(i);
			nonu.insert(i);
		}
		for (int i = 1; i <= n; ++i) {
			vl[i] = n - ban[i].size();
		}
		build(1, 1, n);
		for (int i = 0; i < n; ++i) {
			int cmin = st[1].second;
			int take;
			for (auto& i : nonu) {
				if (ban[cmin].count(i))
					continue;
				take = i;
				break;
			}
			nonu.erase(take);
			ansq[cmin] = take;
			ansp[take] = rev[cmin];
			query(1, 1, n, 1, n, 1);
			query(1, 1, n, cmin, cmin, -1e9);
			query(1, 1, n, take, take, -1);
			if (inp[take] != take)
				query(1, 1, n, inp[take], inp[take], -1);
		}
		for (int i = 1; i <= n; ++i)
			cout << ansp[i] << ' ';
		cout << '\n';
		for (int i = 1; i <= n; ++i)
			cout << ansq[i] << ' ';
		cout << '\n';
	}
}