#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long double ld;
using ll = long long;

using vi = vector<int>;

const int INFi = 2e9;
const ll INF = 2e18;
const int maxN = 1e5;

vi g[maxN];
int mt[maxN];
int used[maxN];
bool ban[maxN];

int T = 1;
set<int> freed;

bool kuhn(int v) {
    if (used[v] == T) return false;
    used[v] = T;
    for(auto &u : g[v]) {
        if (ban[u]) continue;
        if (mt[u] == -1 || kuhn(mt[u])) {
            mt[u] = v;
            mt[v] = u;
            return true;
        }
    }
    return false;
}

int cnt = 0;
void dfs2(int v) {
    if (used[v] == T) return;
    used[v] = T;
    cnt++;
    for(auto &u : g[v]) {
        if (mt[u] != -1) {
            dfs2(mt[u]);
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> a(n);
    rep(i, n) cin >> a[i];
    vector<vi> ind(n, vi(m));
    vi L, R;
    int N = 0;
    rep(i, n) {
        rep(j, m) {
            if (a[i][j] == '#') {
                ind[i][j] = -1;
            } else {
                if ((i + j) % 2) {
                    L.push_back(N);
                } else {
                    R.push_back(N);
                }
                ind[i][j] = N++;
            }
        }
    }
    ll ans = 0;
    for(int lc = 0; lc <= 2; ++lc) {
        int rc = 2 - lc;
        if (lc > L.size() || rc > R.size()) continue;
        ll cur = 1;
        if (lc == 1) cur *= (ll)L.size();
        if (rc == 1) cur *= (ll)R.size();
        if (lc == 2) cur *= (ll)L.size() * ((ll)L.size() - 1) / 2;
        if (rc == 2) cur *= (ll)R.size() * ((ll)R.size() - 1) / 2;
        int Lsz = (int)L.size() - lc;
        int Rsz = (int)R.size() - rc;
        if (Lsz != Rsz) ans += cur;
    }
    ll MX = 1e6;
    ans = min(ans, MX);
    if (ans == MX) {
        cout << ans << '\n';
        return;
    }
    int d = (int)L.size() - (int)R.size();
    // L - y == R - x
    // x + y == 2
    // y - x = L - R
    int y = d + 2;
    if (y % 2 == 1) {
        cout << ans << '\n';
        return;
    }
    y /= 2;
    int x = 2 - y;
    assert((int)L.size() - y == (int)R.size() - x);
    if (y > L.size() || x > R.size()) {
        cout << ans << '\n';
        return;
    }
    vi di = {1, 0, -1, 0};
    vi dj = {0, 1, 0, -1};
    rep(i, n) {
        rep(j, m) {
            if (ind[i][j] == -1) continue;
            rep(w, 4) {
                int i2 = i + di[w];
                int j2 = j + dj[w];
                if (i2 < 0 || i2 >= n || j2 < 0 || j2 >= m || ind[i2][j2] == -1) continue;
                g[ind[i][j]].push_back(ind[i2][j2]);
            }
        }
    }
    if (y == 0) {
        swap(L, R);
        swap(x, y);
    }
    assert(y >= 1);
    rep(i, N) mt[i] = -1;
    rep(i, N) freed.insert(i);
    for(auto &i : L) {
        T++;
        kuhn(i);
    }
    vi to(N);
    for(auto i : L) to[i] = 1;
    rep(i, N) if (mt[i] != -1) freed.erase(i);
    if (freed.size() >= 3) {
        cout << ans << '\n';
        return;
    }
    if (y == 2) {
        assert(freed.size() == 2);
        for(auto &i : freed) assert(to[i] == 1);
        ll res = 0;
        for(auto &i : L) {
            if (mt[i] == -1) {
                freed.erase(i);
                int j = *freed.begin();
                T++;
                cnt = 0;
                dfs2(j);
                res += (int)L.size() - cnt - 1;
                freed.insert(i);
            } else {
                int j = mt[i];
                mt[i] = -1;
                mt[j] = -1;
                ban[i] = true;
                T++;
                bool result = kuhn(j);
                if (!result) {
                    res += (int)L.size() - 1;
                    mt[i] = j;
                    mt[j] = i;
                } else {
                    vi del;
                    for(auto &t : freed) if (mt[t] != -1) del.push_back(t);
                    for(auto &t : del) freed.erase(t);
                    assert(freed.size() == 1);
                    int e = *freed.begin();
                    T++;
                    cnt = 0;
                    dfs2(e);
                    res += (int)L.size() - cnt - 1;
                    freed.insert(i);
                }
                ban[i] = false;
            }
        }
        res /= 2;
        ans += res;
    } else {
        assert(y == 1);
        for(auto &i : L) {
            if (mt[i] == -1) {
                freed.erase(i);
                int j = *freed.begin();
                T++;
                cnt = 0;
                dfs2(j);
                ans += (int)R.size() - cnt;
                freed.insert(i);
            } else {
                int j = mt[i];
                mt[i] = -1;
                mt[j] = -1;
                ban[i] = true;
                T++;
                freed.insert(j);
                kuhn(j);
                vi del;
                for(auto &t : freed) if (mt[t] != -1) del.push_back(t);
                for(auto &t : del) freed.erase(t);
                if (freed.size() >= 2) {
                    ans += R.size();
                } else {
                    assert(freed.size() == 1);
                    int e = *freed.begin();
                    T++;
                    cnt = 0;
                    dfs2(e);
                    ans += (int)R.size() - cnt;
                }
                freed.insert(i);
                ban[i] = false;
                T++;
                kuhn(i);
            }
        }
    }
    cout << min(ans, MX) << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    for(int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}