#include <bits/stdc++.h>

using namespace std;

const int MAXN = 100100;
vector<int> G[MAXN];

vector<int> stackk;
int used[MAXN];

int par[MAXN];
bool bad[MAXN];

int get(int v) {
    if (par[v] == v)
        return v;
    return par[v] = get(par[v]);
}

bool merge(int v, int u) {
    v = get(v);
    u = get(u);
    if (v == u)
        return false;
    par[u] = v;
    return true;
}

void dfs(int v, int p) {
    used[v] = 1;
    stackk.emplace_back(v);
    for (int u : G[v]) {
        if (u == p)
            continue;
        if (used[u] == 1) {
            int id = stackk.size() - 1;
            while (stackk[id] != u) {
                merge(v, stackk[id]);
                --id;
            }
            bad[v] = true;
        } else if (!used[u]) {
            dfs(u, v);
        }
    }
    used[v] = 2;
    stackk.pop_back();
}

vector<int> G2[MAXN];
bool ans = true;

int dfs2(int v, int p) {
    int cnt = 0;
    for (int u : G2[v]) {
        if (u == p)
            continue;
        cnt += dfs2(u, v);
    }
    if (p == -1) {
        if (cnt > 2)
            ans = false;
    } else if (cnt >= 2) {
        ans = false;
    }
    if (bad[v] || cnt)
        return 1;
    return 0;
}

set<int> st[MAXN];
int usd[MAXN];

vector<vector<int>> cyc;
vector<int> path;

void dfs1(int v, int p = -1) {
    path.push_back(v);
    usd[v] = true;
    for (auto u : st[v]) {
        if (u == p) continue;
        if (usd[u]) {
            vector<int> cur;
            int id = path.size() - 1;
            while (id >= 0 && path[id] != u) {
                cur.push_back(path[id]);
                id--;
            }
            cur.push_back(u);
            cyc.push_back(cur);
        } else {
            dfs1(u, v);
        }
    }
    path.pop_back();
}

vector<int> in[MAXN];
int deg[MAXN];

bool check(int n) {
    path.clear();
    cyc.clear();
    fill(usd, usd + n, 0);
    for (int i = 0; i < n; ++i) {
        in[i].clear();
        st[i].clear();
        for (int u : G[i]) {
            st[i].insert(u);
        }
    }
    set<array<int, 2>> all;
    for (int i = 0; i < n; ++i) {
        all.insert({(int)st[i].size(), i});
    }
    while (!all.empty() && (*all.begin())[0] == 1) {
        int v = (*all.begin())[1];
        all.erase(all.begin());
        int u = (*st[v].begin());
        all.erase({(int)st[u].size(), u});
        st[u].erase(v);
        all.insert({(int)st[u].size(), u});
    }
    if (all.empty()) return true;
    dfs1((*all.begin())[1]);
    for (int i = 0; i < (int)cyc.size(); ++i) {
        for (int x : cyc[i]) {
            in[x].push_back(i);
        }
    }
    fill(deg, deg + n, 0);
    for (int i = 0; i < n; ++i) {
        if (st[i].size() >= 3) {
            for (int x: in[i]) {
                deg[x]++;
            }
        }
    }
    for (int i = 0; i < (int)cyc.size(); ++i) {
        if (deg[i] >= 3) return false;
    }
    for (auto elem : all) {
        int v = elem[1];
        int cnt = 0;
        for (int i : in[v]) {
            if (deg[i] >= 2) cnt++;
        }
        cnt += st[v].size() - 2 * in[v].size();
        if (cnt >= 3) return false;
    }
    return true;
}

int main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    while (true) {
        int n, m;
        cin >> n >> m;
        if (n == 0 && m == 0)
            break;
        for (int i = 0; i < n; ++i) {
            G[i].clear();
        }
        fill(used, used + n, 0);
        fill(bad, bad + n, false);
        for (int i = 0; i < n; ++i)
            par[i] = i;
        for (int i = 0; i < m; ++i) {
            int k;
            cin >> k;
            int pr;
            cin >> pr;
            --pr;
            for (int j = 1; j < k; ++j) {
                int v;
                cin >> v;
                --v;
                G[pr].emplace_back(v);
                G[v].emplace_back(pr);
                pr = v;
            }
        }
        if (!check(n)) {
            cout << "No" << endl;
            continue;
        }
        cout << "Yes" << endl;
        continue;
    }
    return 0;
}
