#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

void Solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    Solve();
}

const int N = 1e5 + 5;

struct P {
    int x, y, z, t;
};

int a[N];
int p[N];
int q[N];
bool used[N];
vector<vector<P>> b[4];
vector<P> d;

void unite(P l, P r) {
    swap(l.y, r.y);
    d.push_back(l);
    d.push_back(r);
}

void greedy() {
    while (b[1].size() >= 2) {
        P l = b[1].back().back();
        b[1].pop_back();
        P r = b[1].back().back();
        b[1].pop_back();
        unite(l, r);
    }
    if (!b[1].empty()) {
        P l = b[1].back().back();
        b[1].pop_back();
        P r = b[3].back().back();
        b[3].back().pop_back();
        unite(l, r);
    }
    if (b[2].size() >= 2) {
        int k = b[2].size();
        for (int i = 0; i < k; i++) {
            auto& L = b[2][i];
            auto& R = b[2][(i + 1) % k];
            unite(L[1], R[0]);
        }
    }
    else if (b[2].size() == 1) {
        for (P l : b[2][0]) {
            P r = b[3].back().back();
            b[3].back().pop_back();
            unite(l, r);
        }
    }
}

void no() {
    cout << "Impossible\n";
}

void shift(vector<P> v) {
    int k = v.size();
    for (int i = 1; i < k; i++) {
        swap(v[0].y, v[i].y);
    }
    for (auto& i : v) {
        d.push_back(i);
    }
}

void Solve() {
    int T;
    cin >> T;
    while (T--) {
        for (int i = 1; i <= 3; i++) b[i].clear();
        d.clear();
        int n;
        cin >> n;
        for (int i = 1; i <= n; i++) {
            cin >> a[i];
            used[i] = 0;
            p[i] = 0;
            q[i] = 0;
        }
        for (int i = 1; i <= n; i++) {
            if (used[i]) continue;
            vector<int> c;
            int v = i;
            do {
                c.push_back(v);
                used[v] = 1;
                v = a[v];
            } while (v != i);
            if (c.size() == 1) {
                int v = c[0];
                b[1].push_back({P{v, v, v, v}});
            }
            else if (c.size() == 2) {
                int u = c[0];
                int v = c[1];
                b[2].push_back({P{u, u, v, u}, P{v, v, u, v}});
            }
            else {
                int k = c.size();
                b[3].push_back({});
                for (int i = 0; i < k; i++) {
                    int x = c[i];
                    int nxt = c[(i + 1) % k];
                    int prv = c[(i - 1 + k) % k];
                    int y = nxt;
                    int z = prv;
                    int t = x;
                    b[3].back().push_back({x, y, z, t});
                }
            }
        }
        /*
        if (!b[3].empty()) {
            greedy();
        }
        else if (b[1].size() & 1) {
            no();
            continue;
        }
        else if (b[2].size() != 1) {
            greedy();
        }
        else if (b[1].empty()) {
            no();
            continue;
        }
        else if (b[1].size() >= 2) {
            P l1 = b[1].back().back();
            b[1].pop_back();
            P l2 = b[1].back().back();
            b[1].pop_back();
            P r1 = b[2][0][0];
            P r2 = b[2][0][1];
            b[2].pop_back();
            unite(l1, r1);
            unite(l2, r2);
            greedy();
        }
        else assert(0);
        */
        if (!b[3].empty()) {
            greedy();
        }
        else if (b[2].size() >= 2) {
            int k = b[2].size();
            for (int i = 0; i + 1 < k; i++) {
                P l = b[2][i][1];
                P r = b[2][i + 1][0];
                unite(l, r);
            }
            P l = b[2][k - 1][1];
            P r = b[2][0][0];
            if (b[1].empty()) {
                unite(l, r);
            }
            else {
                vector<P> v = {l, r};
                for (auto& e : b[1]) {
                    v.push_back(e[0]);
                }
                shift(v);
            }
        }
        else if (b[1].size() >= 2) {
            vector<P> v;
            if (!b[2].empty()) {
                P l = b[2][0][0];
                P r = b[2][0][1];
                v = {l, r};
            }
            for (auto& e : b[1]) {
                v.push_back(e[0]);
            }
            if (!b[2].empty()) {
                swap(v[1], v[2]);
            }
            shift(v);
            /*
            for (auto& i : v) {
                cout << i.x << " " << i.y << " " << i.z << " " << i.t << endl;
            }
            */
        }
        else if (!b[1].empty() || !b[2].empty()) {
            no();
            continue;
        }
        for (auto& e : b[3]) {
            for (auto& i : e) {
                d.push_back(i);
            }
        }
        for (auto& v : d) {
            q[v.x] = v.y;
            p[v.y] = v.z;
        }
        for (int i = 1; i <= n; i++) {
            assert(a[p[q[i]]] == i);
            assert(p[i] != i);
            assert(q[i] != i);
        }
        cout << "Possible\n";
        for (int i = 1; i <= n; i++) {
            cout << p[i] << " ";
        }
        cout << "\n";
        for (int i = 1; i <= n; i++) {
            cout << q[i] << " ";
        }
        cout << "\n";
        sort(p + 1, p + n + 1);
        sort(q + 1, q + n + 1);
        for (int i = 1; i <= n; i++) {
            assert(p[i] == i && q[i] == i);
        }
    }
}
