#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

void Solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    Solve();
}

map<pair<int, int>, int> Map;

int get_id(int i, int j) {
    if (Map.count({i, j})) {
        return Map[{i, j}];
    }
    int id = Map.size() + 1;
    Map[{i, j}] = id;
    return id;
}

const int K = 1005;
const int MAX = 1'000'000;

char a[K][K];
int dx[] = {1, -1, 0, 0};
int dy[] = {0, 0, 1, -1};

vector<pair<int, int>> es;

mt19937 rnd;
const int N = 5005;
vector<int> g[N];
int used[N];
bool used1[N];
int match[N];

bool dfs(int v, int root) {
    if (used[v] == root) {
        return false;
    }
    used[v] = root;
    for (int to : g[v]) {
        if (!match[to] || dfs(match[to], root)) {
            match[to] = v;
            return true;
        }
    }
    return false;
}

int Kuhn(int n) {
    for (int i = 1; i <= n; i++) {
        match[i] = 0;
        used1[i] = false;
        used[i] = 0;
    }
    for (int i = 1; i <= n; i++) {
        if (used1[i]) continue;
        shuffle(g[i].begin(), g[i].end(), rnd);
        for (int to : g[i]) {
            if (!match[to]) {
                match[i] = to;
                match[to] = i;
                used1[i] = true;
                used1[to] = true;
                break;
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        if (used1[i]) continue;
        dfs(i, i);
    }
    int cnt = 0;
    for (int i = 1; i <= n; i++) {
        if (match[i]) {
            cnt++;
        }
    }
    return cnt / 2;
}

int col[N];
vector<int> G[N];
bool vis[N];

int calc(int v) {
    vis[v] = 1;
    int res = col[v];
    for (int u : G[v]) {
        if (vis[u]) continue;
        res += calc(u);
    }
    return res;
}

void Solve() {
    int n, m;
    cin >> n >> m;
    ll w = 0;
    for (int i = 0; i <= n + 1; i++) {
        for (int j = 0; j <= m + 1; j++) {
            a[i][j] = '#';
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            char c;
            cin >> c;
            a[i][j] = c;
            if (c == '#') continue;
            if ((i + j) & 1) w++;
        }
    }
    if (w * w - w >= ll(MAX)) {
        cout << MAX << "\n";
        return;
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (a[i][j] == '#') continue;
            int v = get_id(i, j);
            if ((i + j) & 1) {
                col[v] = 0;
            }
            else {
                col[v] = 1;
            }
            for (int k = 0; k < 4; k++) {
                int ni = i + dx[k];
                int nj = j + dy[k];
                if (a[ni][nj] == '#') continue;
                int u = get_id(ni, nj);
                g[v].push_back(u);
                if ((i + j) & 1) {
                    es.push_back({v, u});
                }
            }
        }
    }
    assert(w == Map.size() / 2);
    Kuhn(w + w);
    for (auto [u, v] : es) {
        if (match[u] == v) {
            G[u].push_back(v);
        }
        else {
            G[v].push_back(u);
        }
    }
    ll ans = w * w - w;
    for (int i = 1; i <= w + w; i++) {
        if (col[i] == 1) continue;
        for (int j = 1; j <= w + w; j++) {
            vis[j] = 0;
        }
        ans += w - calc(i);
    }
    ans = min(ans, ll(MAX));
    cout << ans << "\n";
}
