#include <bits/stdc++.h>

using namespace std;

typedef long long ll;


int TEN(int k) {
    int res = 1;
    while (k--) res *= 10;
    return res;
}
int get_kth_(int x, int k) {
    while (k--) x /= 10;
    return x % 10;
}

const int len = 6;
const int base = TEN(len);

const int MAXN = 6000;
const int N = MAXN / 4 + 100;

struct Num {
    vector<ll> a;
    int max_size;

    void norm() {
        while (a.back() == 0) a.pop_back();
    }

    Num& operator*=(int x) {
        for (int i = 0; i < a.size(); ++i) {
            a[i] *= x;
        }
        for (int i = 0; i < a.size(); ++i) {
            int nxt = a[i] / base;
            if (nxt && i + 1 == a.size()) {
                a.push_back(0);
            }
            if (nxt) a[i + 1] += nxt;
            a[i] %= base;
        }
        while (a.size() > max_size) {
            a.pop_back();
        }
        norm();
        return *this;
    }
    Num operator*(int x) const {
        auto tmp(*this);
        tmp *= x;
        return tmp;
    }

    string to_string() const {
        string res = "";
        for (int ai : a) {
            for (int i = 0; i < len; ++i) {
                res += char('0' + (ai) % 10);
                ai /= 10;
            }
        }
        return res;
    }

    void print() const {
        string s = to_string();
        reverse(s.begin(), s.end());
        cout << s << endl;
    }

    int size() const {
        return a.size() * len;
    }

    int first_nonzero() const {
        int i = 0;
        while (a[i] == 0) ++i;
        int x = a[i];
        int r = 0;
        while (x % 10 == 0) {
            x /= 10;
            ++r;
        }
        return i * len + r;
    }

    int get_kth(int k) const {
        int i = k / len;
        if (i >= a.size()) return 0;
        return get_kth_(a[i], k % len);
    }
};

int get_digit(const string& x, int k) {
    return (x.size() > k ? x[k] - '0' : 0);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);


    vector<Num> fact(MAXN + 1);
    vector<string> f(MAXN + 1);
    fact[0] = {{1}, N};

    for (int i = 1; i <= MAXN; ++i) {
        fact[i] = fact[i - 1] * i;
        f[i] = fact[i].to_string();
        //cout << i << ' ' << fact[i].first_nonzero() << ' ' << fact[i].size() << '\n';
        //cout << i << "! = " << f << endl;
        //cout << "fact[" << i << "] = "; fact[i].print();
        //cout << endl;
    }

    int t;
    cin >> t;
    while (t--) {
        set<int> cands;
        for (int x = 1; x <= MAXN; ++x) {
            cands.insert(x);
        }
        vector<int> asked(N, false);

        while (cands.size() > 1) {
            vector<vector<int>> cnt(N, vector<int>(10, 0));
            int best_k = 0;
            int min_mx = 1e9;
            for (int k = 0; k < N; ++k) {
                for (int x : cands) {
                    int digit = (f[x].size() > k ? f[x][k] - '0' : 0);
                    ++cnt[k][digit];
                }
                int mx = *max_element(cnt[k].begin(), cnt[k].end());
                if (mx < min_mx) {
                    min_mx = mx;
                    best_k = k;
                }
            }


            int k = best_k;
            while (asked[k]) ++k;

            /*
            for (int x : cands) {
                cout << x << ' ' << fact[x].first_nonzero() << ' ' << fact[x].size() << '\n';
            }
            cout << endl;
            */

            cout << "? " << k << endl;
            //int digit = get_digit(f[5982], k);
            int digit;
            cin >> digit;

            set<int> new_cands;
            for (int x : cands) {
                if (get_digit(f[x], k) == digit) {
                    new_cands.insert(x);
                }
            }
            asked[k] = true;

            cands = new_cands;
            //cout << "size = " << cands.size() << endl;
        }

        cout << "! " << *cands.begin() << endl;
        string res;
        cin >> res;
        assert(res == "YES");
    }

}
