#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define vin(a) for (auto& i : a) cin >> i
#define all(a) (a).begin(), (a).end()
#define pbc push_back
#define mp make_pair

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline void chkmin(T1& x, const T2& y) {
    if (y < x) x = y;
}

template<typename T1, typename T2>
inline void chkmax(T1& x, const T2& y) {
    if (x < y) x = y;
}

vector<int> dx = {-1, 0, 0, 1};
vector<int> dy = {0, -1, 1, 0};

vector<vector<int>> g, gr;
vector<int> used;
vector<int> match;

bool dfs(int v) {
    if (v >= (int) g.size()) {
        return false;
    }
    if (used[v]) {
        return false;
    }
    used[v] = 1;
    for (int u : g[v]) {
        if (match[u] == -1) {
            match[u] = v;
            return true;
        }
    }
    for (int u : g[v]) {
        if (dfs(match[u])) {
            match[u] = v;
            return true;
        }
    }
    return false;
}

const ll MAXC = 1000000;

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    cout.precision(20), cout.setf(ios::fixed);
    int n, m;
    cin >> n >> m;
    vector<string> arr(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
    }
    vector<int> cnt(2);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (arr[i][j] == '.') {
                cnt[(i + j) & 1]++;
            }
        }
    }
    if (abs(cnt[0] - cnt[1]) > 2 || abs(cnt[0] - cnt[1]) == 1) {
        ll x = cnt[0] + cnt[1];
        cout << min(MAXC, x * (x - 1) / 2) << endl;
        return 0;
    }
    ll already = 0;
    if (cnt[0] - cnt[1] != 2) {
        already += (ll) cnt[0] * (cnt[0] - 1) / 2;
    }
    if (cnt[1] - cnt[0] != 2) {
        already += (ll) cnt[1] * (cnt[1] - 1) / 2;
    }
    if (cnt[0] != cnt[1])  {
        already += (ll) cnt[0] * cnt[1];
    }
    if (already >= MAXC) {
        cout << MAXC << endl;
        return 0;
    }
    vector<vector<pair<int, int>>> cells(2);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (arr[i][j] == '.') {
                cells[(i + j) & 1].push_back({i, j});
                
            }
        }
    }
    sort(all(cells[0]));
    sort(all(cells[1]));
    vector<vector<int>> num(n, vector<int> (m));
    {
        int cur = 0;
        for (int i = 0; i < (int) cells[0].size(); ++i) {
            num[cells[0][i].first][cells[0][i].second] = cur++;
        }
    }
    {
        int cur = 0;
        for (int i = 0; i < (int) cells[1].size(); ++i) {
            num[cells[1][i].first][cells[1][i].second] = cur++;
        }
    }
    g.resize(cells[0].size());
    gr.resize(cells[1].size());
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (((i + j) & 1) == 0) {
                for (int k = 0; k < 4; ++k) {
                    int i1 = i + dx[k];
                    int j1 = j + dy[k];
                    if (0 <= i1 && i1 < n && 0 <= j1 && j1 < m && arr[i1][j1] == '.') {
                        g[num[i][j]].push_back(num[i1][j1]);
                        gr[num[i1][j1]].push_back(num[i][j]);
                    }
                }
            }
        }
    }
    
    if (cnt[0] == cnt[1]) {
        match.resize(cnt[0], -1);
        int matchsz = 0;
        used.assign(cnt[0], 0);
        for (int i = 0; i < cnt[0]; ++i) {
            if (dfs(i)) {
                used.assign(cnt[0], 0);
                ++matchsz;
            }
        }
        if (matchsz < cnt[0] - 1) {
            already += cnt[0] * cnt[0];
        } else {
            ll cntnew = 0;
            for (int u = 0; u < cnt[1]; ++u) {
                for (int i = 0; i < cnt[1]; ++i) {
                    if (match[i] == cnt[0]) {
                        match[i] = -1;
                    }
                }
                match[u] = cnt[0];
                vector<int> matched(cnt[0]);
                for (int i = 0; i < cnt[1]; ++i) {
                    if (match[i] < cnt[0] && match[i] != -1) {
                        matched[match[i]] = 1;
                    }
                }
                used.assign(cnt[0], 0);
                int matchsz = 0;
                for (int v = 0; v < cnt[0]; ++v) {
                    if (!matched[v]) {
                        if (dfs(v)) {
                            matched[v] = 1;
                            used.assign(cnt[0], 0);
                        }
                    }
                    if (matched[v]) {
                        ++matchsz;
                    }
                }
                if (matchsz < cnt[0] - 1) {
                    cntnew += cnt[0];
                    continue;
                }
                assert(matchsz == cnt[0] - 1);
                int v = 0;
                while (matched[v]) {
                    ++v;
                }
                assert(v < cnt[0]);
                used.assign(cnt[0], 0);
                assert(!dfs(v));
                int cntnotused = 0;
                for (int i = 0; i < cnt[0]; ++i) {
                    if (!used[i]) {
                        cntnotused++;
                    }
                }
                cntnew += cntnotused;
            }
            already += cntnew;
        }
    } else if (abs(cnt[0] - cnt[1]) == 2) {
        if (cnt[1] > cnt[0]) {
            swap(cnt[0], cnt[1]);
            swap(g, gr);
        }
        match.resize(cnt[1]);
        int matchsz = 0;
        for (int i = 0; i < cnt[0]; ++i) {
            if (dfs(i)) {
                matchsz++;
            }
        }
        if (matchsz < cnt[1]) {
            already += (ll) cnt[0] * (cnt[0] - 1) / 2;
        } else {
            int cntnew = 0;
           
            for (int v = 0; v < cnt[0]; ++v) {
                vector<int> matched(cnt[0]);
                for (int i = 0; i < cnt[1]; ++i) {
                    if (match[i] < cnt[0] && match[i] != -1) {
                        matched[match[i]] = 1;
                    }
                }
                int matchsz = 0;
                for (int u = 0; u < cnt[1]; ++u) {
                    if (match[u] == v) {
                        match[u] = -1;
                    }
                    if (match[u] != -1) {
                        matchsz++;
                    }
                }
                matched[v] = 0;
                used.assign(cnt[0], 0);
                for (int i = 0; i < cnt[0]; ++i) {
                    if (!matched[i] && i != v) {
                        if (dfs(i)) {
                            matched[i] = 1;
                            used.assign(cnt[0], 0);
                        }
                    }
                }
                if (matchsz < cnt[1]) {
                    cntnew += cnt[0] - 1;
                    continue;
                }
                int v2 = 0;
                while (v2 == v || matched[v2]) {
                    ++v2;
                }
                used.assign(cnt[0], 0);
                used[v] = 1;
                assert(!dfs(v2));
                int cntnotused = 0;
                for (int i = 0; i < cnt[0]; ++i) {
                    if (!used[i]) {
                        cntnotused++;
                    }
                }
                cntnew += cntnotused;
            }
            assert(cntnew % 2 == 0);
            cntnew /= 2;
            already += cntnew;
        }
    }

    cout << min(MAXC, already);
    return 0;
}