#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define vin(a) for (auto& i : a) cin >> i
#define all(a) (a).begin(), (a).end()
#define pbc push_back
#define mp make_pair

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
// mt19937 rnd(228);

template<typename T1, typename T2>
inline void chkmin(T1& x, const T2& y) {
    if (y < x) x = y;
}

template<typename T1, typename T2>
inline void chkmax(T1& x, const T2& y) {
    if (x < y) x = y;
}

int get(int l, int r) {
    return (ull)rnd() % (r - l + 1) + l;
}

int C = 1e6;
int Q = 0;
int last_x = -1, last_y = -1;

#ifdef LOCAL

int ans_x, ans_y;

ll sq(ll x) {
    return x * x;
}

ll calc(int x, int y) {
    return sq(x - ans_x) + sq(y - ans_y);
}

#endif

string query(int x, int y) {
    assert(++Q <= 64);
    // ++Q;
    assert(x >= 0 && y >= 0 && x <= C && y <= C);
    cout << x << " " << y << endl;
    
    string ans;
    
    #ifdef LOCAL
    if (last_x == -1) {
        ans = "Not Found";
    } else {
        ll last = calc(last_x, last_y);
        ll cur = calc(x, y);
        if (cur == 0) {
            ans = "Found!";
        } else if (cur < last) {
            ans = "<";
        } else if (cur == last) {
            ans = "=";
        } else {
            ans = ">";
        }
    }
    cerr << "ans: " << ans << endl;
    #else
    // cin >> ans;
    getline(cin, ans);
    #endif
    
    if (ans.back() == '!') {
        // cerr << "Q = " << Q << endl;
        exit(0);
    }

    last_x = x;
    last_y = y;
    
    return ans;
}

pair<string, string> findGreater() {
    string c11 = query(1, 1);
    string c00 = query(0, 0);
    c11 = query(1, 1);
    c00 = query(0, 0);
    if (c11 == c00) {
        string c01 = query(0, 1);
        string c10 = query(1, 0);
    }   
    return {c00, c11};
}

bool isIn(int x) {
    return x >= 0 && x <= C;
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    cout.precision(20), cout.setf(ios::fixed);
#ifdef LOCAL
    C = get(3, 1e6);
    ans_x = get(0, 2), ans_y = get(0, 2);
    // C = 6;
    // ans_x = 0, ans_y = 4;
    cerr << "ans_x = " << ans_x << " ans_y = " << ans_y << " C = " << C << endl;
#endif

    auto [greater, less] = findGreater();
    #ifdef LOCAL
    cerr << "greater = " << greater << endl;
    #endif
    int lx = 0, rx = C + 1;

    while (lx < rx - 1) {
        int mx = (lx + rx) / 2;
        int need_x = 2 * mx - last_x;
        // cerr << "lx = " << lx << " mx = " << mx << " rx = " << rx << " need_x = " << need_x << endl;
        if (!isIn(need_x)) {
            if (mx - lx < rx - 1 - mx) {
                query(lx, 0);
            } else {
                query(rx - 1, 0);
            }
            need_x = 2 * mx - last_x;
            // cerr << "lx = " << lx << " mx = " << mx << " rx = " << rx << " need_x = " << need_x << endl;
        } 
        if (need_x == last_x) {
            query(lx, 0);
            need_x = 2 * mx - last_x;
        }
        assert(need_x != last_x);
        need_x = 2 * mx - last_x;
            
        assert(isIn(need_x));
        string has = query(need_x, 0);
        if (has != greater && has != less) {
            lx = mx;
            rx = lx + 1;
            break;
        }
        if (!((greater != has) ^ (need_x >= mx))) {
            lx = mx;
        } else {
            rx = min(rx, mx + 1);
        }
    }


    cerr << "guessed x : " << lx << endl;

    #ifdef LOCAL
    assert(lx == ans_x);
    #endif

    query(lx, 0);
    int ly = 0, ry = C + 1;
    while (ly < ry - 1) {
        int my = (ly + ry) / 2;
        int need_y = 2 * my - last_y;
        if (!isIn(need_y)) {
            if (my - ly < ry - 1 - my) {
                query(lx, ly);
            } else {
                query(lx, ry - 1);
            }
        }
        
        if (need_y == last_y) {
            query(lx, ly);
            need_y = 2 * my - last_y;
        }
        assert(need_y != last_y);
        need_y = 2 * my - last_y;
        assert(isIn(need_y));
        string has = query(lx, need_y);
        if (has != greater && has != less) {
            ly = my;
            ry = ly + 1;
            break;
        }
        if (!((greater != has) ^ (need_y >= my))) {
            ly = my;
        } else {
            ry = min(ry, my + 1);
        }
    }



    // cerr << "guessed y : " << ly << endl;

    #ifdef LOCAL
    assert(ly == ans_y);
    #endif

    query(lx, ly);

    #ifdef LOCAL
    cerr << Q << endl;
    #endif
    return 0;
}