#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;

    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}

void solve() {
    int n;
    cin >> n;
    vector<bool> used(n, false);
    vector<int> a(n), p(n, 0), q(n, 0);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }

    map<int, vector<vector<int>>> cc;
    for (int i = 0; i < n; ++i) {
        if (used[i]) {
            continue;
        }
        int j = i;
        vector<int> cycle;
        while (true) {
            cycle.push_back(j);
            used[j] = true;
            j = a[j];
            if (j == i) {
                break;
            }
        }
        cc[cycle.size()].push_back(std::move(cycle));
    }

    for (auto& it : cc) {
        if (it.first % 2 == 0 && it.second.size() % 2 != 0) {
            cout << "Impossible\n";
            return;
        }
    }

    for (auto& it : cc) {
        if (it.first == 1) {
            continue;
        } else if (it.first % 2 == 1) {
            auto& cycles = it.second;
            while (!cycles.empty()) {
                auto& cycle = cycles.back();
                for (int i = 0; i < cycle.size(); ++i) {
                    p[i] = a[a[i]];
                    q[a[i]] = i;
                }
                cycles.pop_back();
            }
        } else {
            auto& cycles = it.second;
            while (!cycles.empty()) {
                auto cycle1 = std::move(cycles.back());
                cycles.pop_back();
                auto cycle2 = std::move(cycles.back());
                cycles.pop_back();
                for (int i = 0; i < it.first; ++i) {
                    p[cycle1[i]] = cycle2[i];
                    p[cycle2[i]] = cycle1[(i + 1) % cycle1.size()];
                    q[cycle2[i]] = cycle1[(i + 1) % cycle1.size()];
                    q[cycle1[(i + 1) % cycle1.size()]] = cycle2[(i + 1) % cycle2.size()];
                }
            }
        }
    }

    auto& cycles = cc[1];
    if (!cycles.empty()) {
        vector<int> fixed;
        for (auto& cycle : cycles) {
            fixed.push_back(cycle[0]);
        }
        if (fixed.size() == 1) {
            cout << "Impossible\n";
            return;
        }
        for (int i = 0; i < fixed.size(); ++i) {
            int cur = fixed[i];
            int nxt = fixed[(i + 1) % fixed.size()];
            p[cur] = nxt;
            q[nxt] = cur;
        }
    }

    cout << "Possible\n";
    for (int i : p) {
        cout << i + 1 << " ";
    }
    cout << "\n";
    for (int i : q) {
        cout << i + 1 << " ";
    }
    cout << "\n";
}
