#include <bits/stdc++.h>

using namespace std;

constexpr int N = 1e5;

int n;
vector<array<int, 2>> nei[N];
int tin[N], tup[N], ct;
int ccyc[N];

void calct(int v, int p) {
  tup[v] = tin[v] = ++ct;
  for (auto& [u, nb]: nei[v]) if (!tin[u]) {
    calct(u, v);
    tup[v] = min(tup[v], tup[u]);
    ccyc[v] += ccyc[u];
    ccyc[v] += tup[u] == tin[v];
    nb = 1;
  } else if (u != p && tin[u] < tin[v]) {
    nb = 2;
    tup[v] = min(tup[v], tin[u]);
  }
}

bool gather_v(int v) {
  if (tup[v] < tin[v]) return 1;
  int cup = ccyc[0], nc = 0;
  for (auto [u, nb]: nei[v]) if (nb == 1) {
    nc += !!ccyc[u];
    cup -= ccyc[u];
  }
  return nc + !!cup < 3;
}

int gather_c2(int v) {
  int res = 0, cc = 0;
  for (auto [u, nb]: nei[v]) if (nb == 1 && tup[u] == tup[v]) {
    res += gather_c2(u);
  }
  for (auto [u, nb]: nei[v]) if (nb == 1 && tup[u] != tup[v]) {
    if (tup[u] == tin[v]) cc = 1;
    else res += !!ccyc[u];
  }
  return res + cc;
}

bool gather_c(int v) {
  if (tup[v] >= tin[v]) return 1;
  bool ok = 1;
  int p = -1;
  for (auto [u, nb]: nei[v]) if (nb == 2) {
    p = u;
    ok &= tup[v] == tin[u];
  }
  if (!ok) return 1;
  int bv = gather_c2(v), pc = 0;
  if (ccyc[p] != ccyc[v] + 1 || tup[p] < tin[p]) pc = 1;
  if (tup[p] >= tin[p]) {
    bv += ccyc[0] != ccyc[p];
  }
  return bv + pc < 3;
}

bool solve() {
  int m; cin >> n >> m;
  if (!n) return 0;
  for (int i = 0; i < m; ++i) {
    int k; cin >> k;
    int p, c; cin >> p;
    while (--k) {
      cin >> c;
      nei[p - 1].push_back({c - 1, 0});
      nei[c - 1].push_back({p - 1, 0});
      p = c;
    }
  }
  calct(0, 0);
  for (int i = 0; i < n; ++i) if (!gather_c(i) || !gather_v(i)) {
    cout << "No\n";
    return 1;
  }
  cout << "Yes\n";
  return 1;
}


int main() {
  cin.tie(0)->sync_with_stdio(0);
  while (solve()) {
    for (int i = 0; i < n; ++i) nei[i].clear();
    ct = 0;
    fill_n(tin, n, 0);
    fill_n(tup, n, 0);
    fill_n(ccyc, n, 0);
  }
  return 0;
}
