//
// Created by nef on 07.12.2022.
//
#include <bits/stdc++.h>

using namespace std;

#define int long long

using ull = unsigned long long;

int n, k;
vector<vector<int>> records;
vector<vector<int>> index_in_record;
vector<vector<ull>> hashes;
vector<int> parents;

ull hsh(int i, int l, int r) {
    return hashes[i][r] ^ hashes[i][l];
}

void solve(const vector<pair<int, int>>& bounds, int parent) {
    if(bounds[0].first == bounds[0].second) {
        return;
    }
    if(bounds[0].first + 1 == bounds[0].second) {
        int v = records[0][bounds[0].first];
        parents[v] = parent;
        return;
    }
    for(int i = bounds[0].first; i < bounds[0].second; i++) {
        if((i - bounds[0].first) % 2 == 0) {
            continue;
        }
        int v = records[0][i];
        pair<ull, ull> cur_hash;
        bool ok = true;
        for(int j = 0; j < k; j++) {
            int idx = index_in_record[j][v];
            assert(bounds[j].first <= idx && idx < bounds[j].second);
            pair<ull, ull> stuff{hsh(j, bounds[j].first, idx), hsh(j, idx + 1, bounds[j].second)};
            if(stuff.second < stuff.first) {
                swap(stuff.first, stuff.second);
            }
            if(j == 0) {
                cur_hash = stuff;
            } else if(cur_hash != stuff) {
                ok = false;
                break;
            }
        }
        if(!ok) {
            continue;
        }
        vector<pair<int, int>> bounds_left(k), bounds_right(k);
        for(int j = 0; j < k; j++) {
            int idx = index_in_record[j][v];
            assert(bounds[j].first <= idx && idx < bounds[j].second);
            pair<ull, ull> stuff{hsh(j, bounds[j].first, idx), hsh(j, idx + 1, bounds[j].second)};
            if(stuff.first == cur_hash.first) {
                bounds_left[j] = {bounds[j].first, idx};
                bounds_right[j] = {idx + 1, bounds[j].second};
            } else {
                bounds_left[j] = {idx + 1, bounds[j].second};
                bounds_right[j] = {bounds[j].first, idx};
            }
        }
        parents[v] = parent;
        solve(bounds_left, v);
        solve(bounds_right, v);
        return;
    }
    assert(false);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> k;

    mt19937_64 rd;

    vector<ull> hash_vec(k);
    for(ull& x: hash_vec) {
        x = rd();
    }

    records.resize(k, vector<int>(n));
    index_in_record.resize(k, vector<int>(n));
    hashes.resize(k, vector<ull>(n + 1));
    for(int i = 0; i < k; i++) {
        for(int j = 0; j < n; j++) {
            cin >> records[i][j];
            records[i][j]--;
            index_in_record[i][records[i][j]] = j;
            hashes[i][j + 1] = hashes[i][j] ^ hash_vec[records[i][j]];
        }
    }

    parents.resize(n);

    vector<pair<int, int>> bounds(k, make_pair(0, n));
    solve(bounds, -1);

    for(int v: parents) {
        cout << (v == -1 ? -1 : v + 1) << " ";
    }
    cout << endl;

    return 0;
}

/*
3 50
1 2 3 1 2 3 3 2 1 1 2 3
3 2 1 1 2 3 1 2 3 1 2 3
1 2 3 3 2 1 1 2 3 3 2 1
1 2 3 3 2 1 1 2 3 3 2 1
1 2 3 1 2 3 3 2 1 1 2 3
3 2 1 1 2 3 3 2 1 1 2 3
1 2 3 3 2 1 1 2 3 1 2 3
1 2 3 1 2 3 3 2 1 1 2 3
3 2 1 3 2 1 1 2 3 3 2 1
1 2 3 3 2 1 3 2 1 1 2 3
1 2 3 3 2 1 1 2 3 3 2 1
3 2 1 3 2 1 1 2 3 1 2 3
3 2 1 3 2 1

 */