#include<bits/stdc++.h>
#define int long long
#define p pair<int, int>
#define endl '\n'
const int INF = 1e9+1;

using namespace std;

vector<vector<int>> d;
vector<vector<int>> revd;
vector<int> pa, pb;
vector<bool> was;

bool DFS(int vertex) {
    was[vertex] = true;
    for (int q : d[vertex]) {
        if (pb[q] == -1 || (!was[pb[q]] && DFS(pb[q]))) {
            pa[vertex] = q, pb[q] = vertex;
            return true;
        }
    }
    return false;
}

void Kun(int n, int m) {
    pa.assign(n, -1), pb.assign(m, -1);
    for (int q = 0; q < n; q++) {
        was.assign(n, false);
        DFS(q);
    }
}

vector<char> usedL;
vector<char> usedR;

void try_dfs(int v) {
    int i = pa[v];
    {
        if (!usedR[i]) {
            usedR[i] = 1;
            for (auto j : revd[i]) {
                if (!usedL[j]) {
                    usedL[j] = 1;
                    try_dfs(j);
                }
            }
        }
    }
}

void run() {
    int n, m;
    cin >> n >> m;
    vector<string> in(n);
    for (int i = 0; i < n; ++i) {
        cin >> in[i];
    }
    int cnt_empty = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (in[i][j] == '.')
                cnt_empty++;
        }
    }
    if (cnt_empty >= 2022) {
        cout << 1000000;
        return;
    }
    vector<pair<int, int>> whites;
    vector<pair<int, int>> blacks;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (in[i][j] == '#')
                continue;
            if ((i + j) % 2 == 0) {
                whites.push_back({i, j});
            } else {
                blacks.push_back({i, j});
            }
        }
    }
    d.resize(whites.size());
    int sa = whites.size();
    int sb = blacks.size();
    sort(whites.begin(), whites.end());
    sort(blacks.begin(), blacks.end());
    int id = 0;
    for (auto& el : whites) {
        int i = el.first;
        int j = el.second;
        if (i + 1 < n && in[i + 1][j] == '.') {
            d[id].push_back((lower_bound(blacks.begin(), blacks.end(), make_pair(i + 1, j)) - blacks.begin()));
            //cerr << id << ':' << d[id].back() << endl;
        }
        if (j + 1 < m && in[i][j + 1] == '.') {
            d[id].push_back((lower_bound(blacks.begin(), blacks.end(), make_pair(i, j + 1)) - blacks.begin()));
            //cerr << id << ':' << d[id].back() << endl;
        }
        if (i - 1 >= 0 && in[i - 1][j] == '.') {
            d[id].push_back((lower_bound(blacks.begin(), blacks.end(), make_pair(i - 1, j)) - blacks.begin()));
            //cerr << id << ':' << d[id].back() << endl;
        }
        if (j - 1 >= 0 && in[i][j - 1] == '.') {
            d[id].push_back((lower_bound(blacks.begin(), blacks.end(), make_pair(i, j - 1)) - blacks.begin()));
            //cerr << id << ':' << d[id].back() << endl;
        }
        ++id;
    }
    Kun(sa, sb);
    int ans = 0;
    usedR.resize(sb);
    usedL.resize(sa);
    revd.resize(sb);
    for (int i = 0; i < sa; ++i) {
        for (auto j : d[i]) {
            revd[j].push_back(i);
        }
    }
    for (int i = 0; i < sa; ++i) {
        // try delete i;
        usedL.assign(sa, 0);
        usedR.assign(sb, 0);
        usedL[i] = 1;
        usedR[pa[i]] = 1;
        //cerr << i << ' ' << pa[i] << endl;
        for (auto k : revd[pa[i]]) {
            if (!usedL[k])
                try_dfs(k);
        }
        int tcnt = 0;
        for (int j = 0; j < sb; ++j) {
            if (!usedR[j])
                tcnt++;
        }
        ans += tcnt;
    }
    ans += sa * (sa - 1) / 2;
    ans += sb * (sb - 1) / 2;
    cout << min(ans, 1000000ll);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    run();
    return 0;
}
