#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define LF '\n'
#define SP ' '
#define rep(i, a, b) for (int i = a; i < (b); i++)
#define all(x) begin(x), end(x)

vector<int> mul(const vector<int> &a, const vector<int> &b) {
    int n = a.size();
    vector<int> r(n);
    for (int i = 0; i < n; i++) {
        r[i] = a[b[i] - 1];
    }
    return r;
}

vector<int> inv(const vector<int> &a) {
    int n = a.size();
    vector<int> r(n);
    for (int i = 0; i < n; i++) {
        r[a[i] - 1] = i + 1;
    }
    return r;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &i: a)
        cin >> i;

    if (n == 1) {
        cout << "Impossible" << LF;
        return;
    }
    if (n == 2) {
        if (a[0] == 2) {
            cout << "Impossible" << LF;
            return;
        }
        cout << "Possible\n2 1\n2 1\n";
        return;
    }

    vector<int> cyclic(n);
    for (int i = 0; i < n; i++) {
        cyclic[i] = (i + 1) % n + 1;
    }
    vector<int> p = mul(inv(a), cyclic);
    bool flag = true;
    for (int i = 0; i < n; i++) {
        if (p[i] == i + 1)
            flag = false;
    }
    if (!flag) {
        cyclic = mul(cyclic, cyclic);
        p = mul(inv(a), cyclic);
    }
    auto q = inv(cyclic);

    cout << "Possible" << LF;
    for (auto &i: p)
        cout << i << SP;
    cout << LF;
    for (auto &i: q)
        cout << i << SP;
    cout << LF;
}

int main() {
    int t;
    cin >> t;
    while (t--)
        solve();
}