#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int MAXN = 1000;
const ll P = 1009;
const ll MOD = 1e9 + 9;
ll p[MAXN];
int my_anc[MAXN];

void precalc() {
    p[0] = 1;
    for (int i = 1; i < MAXN; ++i)
        p[i] = (p[i - 1] * P) % MOD;
}

vector<vector<ll>> hesh;
vector<vector<int>> v;
vector<vector<int>> pos_by_number;
int n, k;

void count_hesh() {
    for (int i = 0; i < k; ++i) {
        hesh[i][0] = 0;
        for (int j = 0; j < n; ++j) {
            hesh[i][j + 1] = (hesh[i][j] + p[v[i][j]]) % MOD;
        }
    }
}

ll get_hash228(int line, int l, int r) {
    ll all = hesh[line][r];
    ll lish = hesh[line][l];
    return (all + MOD - lish) % MOD;
}

pair<ll, ll> get_hash(int line, pair<int, int>& seg, int mid) {
    ll A = get_hash228(line, seg.first, mid);
    ll B = get_hash228(line, mid + 1, seg.second);
    if (A < B)
        return {A, B};
    else
        return {B, A};
}

int find_root(vector<pair<int, int>> &my_seg) {
    for (int id228 = my_seg[0].first + 1; id228 < my_seg[0].second - 1; ++id228) {
        int may_be_root = v[0][id228];
        pair<ll, ll> my_val = get_hash(0, my_seg[0], pos_by_number[0][may_be_root]);
        //cout << may_be_root << " " << my_val.first << " " << my_val.second << endl;
        bool ok = true;
        for (int i = 0; i < k; ++i) {
            pair<ll, ll> this_val = get_hash(i, my_seg[i], pos_by_number[i][may_be_root]);
            //cout << i << " " << this_val.first << " " << this_val.second << endl;
            if (this_val != my_val)
                ok = false;
        }
        //cout << " OK " << ok << endl << endl;
        if (ok)
            return may_be_root;
    }
    //cout << my_seg[0].first << " " << my_seg[0].second << endl;
    assert(false);
    return -1;

}

void solver(int anc, vector<pair<int, int>> &my_seg) {
    if (my_seg[0].second - my_seg[0].first == 1) {
        my_anc[v[0][my_seg[0].first]] = anc;
        return;
    }
    int root = find_root(my_seg);
    my_anc[root] = anc;
    vector<pair<int, int>> on_left;
    vector<pair<int, int>> on_right;
    ll HESH_left = get_hash228(0, my_seg[0].first, pos_by_number[0][root]);
    //cout << HESH_left << " " << HESH_left << endl;
    for (int ln = 0; ln < k; ++ln) {
        int mid = pos_by_number[ln][root];
        ll HESH_left_here = get_hash228(ln, my_seg[ln].first, mid);
        if (HESH_left_here == HESH_left) {
            on_left.push_back({my_seg[ln].first, mid});
            on_right.push_back({mid + 1, my_seg[ln].second});
        } else {
            on_right.push_back({my_seg[ln].first, mid});
            on_left.push_back({mid + 1, my_seg[ln].second});
        }
    }
    solver(root, on_left);
    solver(root, on_right);
}

void solve() {
    cin >> n >> k;
    v.assign(k, vector<int>(n));
    hesh.assign(k, vector<ll>(n + 1));
    pos_by_number.assign(k, vector<int>(n));
    for (int i = 0; i < k; ++i)
        for (int j = 0; j < n; ++j) {
            cin >> v[i][j];
            --v[i][j];
        }
    count_hesh();

    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < n; ++j) {
            pos_by_number[i][v[i][j]] = j;
        }
    }
    vector<pair<int, int>> my_val(k, {0, n});
    solver(-2, my_val);

    for (int i = 0; i < n; ++i)
        cout << my_anc[i] + 1 << ' ';
    cout << '\n';
}

int main() {
    //freopen("input.txt", "r", stdin);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    precalc();
    int t = 1; // cin >> t;
    while (t--)
        solve();
    return 0;
}

/*

vector<int> ans, center;
vector<set<int>> cnt;
vector<vector<int>> v;
unordered_set<int> in_left;
vector<unordered_set<int>> counter;

int find_root(vector<pair<int, int>> &where) {
    for (int i = 0; i < v.size(); ++i) {
        for (int j = where[i].first; j < where[i].second; ++j)
            counter[v[i][j]].insert(j);
    }
    int best = -1;
    for (int j = where[0].first; best == -1 && j < where[0].second; ++j) {
        cout << v[0][j] << " " << counter[v[0][j]].size() << endl;

    }
    cout << "LOL\n";
    for (int j = where[0].first + 1; best == -1 && j < where[0].second - 1; ++j) {
        //cout << v[0][j] << " " << counter[v[0][j]].size() << endl;
        if (counter[v[0][j]].size() == 1) {
            best = v[0][j];
        }
    }
    for (int j = where[0].first + 1; best == -1 && j < where[0].second - 1; ++j)
        if (counter[v[0][j]].size() == 2) {
            best = v[0][j];
        }
    assert(best != -1);
    for (int j = where[0].first; j < where[0].second; ++j)
       counter[v[0][j]].clear();
    for (int i = 0; i < v.size(); ++i) {
        for (int j = where[i].first; j < where[i].second; ++j)
            if (v[i][j] == best)
                center[i] = j;
    }
    return best;
}

void solver(vector<pair<int, int>> &where, int anc) {
    int nw = find_root(where);
    ans[nw] = anc;
    if (v[0].size() == 1)
        return;
    vector<pair<int, int>> one_part;
    vector<pair<int, int>> other_part;
    bool fl = false;
    for (auto x: v[0]) {
        if (x == nw) {
            break;
        }
        in_left.insert(x);
    }

    for (int i = 0; i < v.size(); ++i) {
        int kekl = v[i][where[i].first];
        if (in_left.count(kekl)) {
            one_part.push_back({where[i].first, center[i]});
            other_part.push_back({center[i], where[i].second});
        } else {
            other_part.push_back({where[i].first, center[i]});
            one_part.push_back({center[i], where[i].second});
        }
    }
    in_left.clear();
    solver(one_part, nw);
    solver(other_part, nw);
}

void solve() {
    int n, k;
    cin >> n >> k;
    ans.resize(n);
    cnt.resize(n);
    center.resize(n);
    counter.resize(n);
    v.assign(k, vector<int>(n));
    for (int i = 0; i < k; ++i)
        for (int j = 0; j < n; ++j) {
            cin >> v[i][j];
            --v[i][j];
        }
    vector<pair<int, int>> data(k, {0, n});
    solver(data, -2);
    for (int i = 0; i < n; ++i)
        cout << ans[i] + 1 << ' ';
    cout << '\n';
}

int main() {
    freopen("input.txt", "r", stdin);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1; // cin >> t;
    while (t--)
        solve();
    return 0;
}
*/

