#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

typedef long long ll;

ll cnt_edge = 0;

void add_edge(ll v1, ll v2, ll num_1, ll num_2, vector <set <ll>>& cnt, vector <vector <char>>& gr, ll& cnt_full, ll& cnt_last) {
	if (num_1 > num_2) {
		swap(v1, v2);
		swap(num_1, num_2);
	}
	gr[v1][v2] = 1;
	gr[v2][v1] = 1;
	cnt_last = max(cnt_last, num_2 + 1);
	
	set <ll> st;
	st.insert(num_1);
	st.insert(num_1 + 1);
	st.insert(num_2);
	st.insert(num_2 + 1);
	ll cnt_before = 0;
	for (auto i: st)
		cnt_before += (cnt[i].size() > 0);

	cnt[num_1].erase(v1);
	cnt[num_2].erase(v2);
	cnt[num_1 + 1].insert(v1);
	cnt[num_2 + 1].insert(v2);

	ll cnt_now = 0;
	for (auto i : st)
		cnt_now += (cnt[i].size() > 0);

	cnt_full -= cnt_before;
	cnt_full += cnt_now;

	cnt_edge++;
}

void add(ll s, vector <set <ll>>& cnt, vector <vector <char>>& gr, ll k, ll& cnt_full, ll& cnt_last) {
	cnt[0].insert(s);
	cnt_full += 1;
	add_edge(s, 0, 0, cnt_last, cnt, gr, cnt_full, cnt_last);
	ll num_s = 1;
	ll cnt_num = cnt_last - 1;
	while (cnt_full != k) {
		if (cnt_num - 1 >= 0 && cnt[cnt_num - 1].size() > 0 && cnt[cnt_num].size() == 0) {
			ll first = *cnt[cnt_num - 1].begin();
			add_edge(s, first, num_s, cnt_num - 1, cnt, gr, cnt_full, cnt_last);
			num_s += 1;
		}
		cnt_num -= 1;
		if (cnt_num < 0)
			cnt_num = cnt_last - 1;
	}
}

int main() {
	ll n, k;
	cin >> n >> k;
	if (n == k) {
		if (n == 1)
			cout << "YES\n" << 0;
		else
			cout << "NO";
		return 0;
	}
	if (k == 1) {
		if (n == 2)
			cout << "YES\n" << 1 << "\n" << "1 2";
		else {
			cout << "YES\n" << n << "\n";
			for (ll i = 1; i < n; i++)
				cout << i << " " << i + 1 << '\n';
			cout << n << " " << 1;
			return 0;
		}
		return 0;
	}
	vector <set <ll>> cnt(501);
	vector <vector <char>> gr(n, vector <char>(n, 0));
	cnt[1].insert(0);
	cnt[1].insert(1);
	gr[0][1] = 1;
	gr[1][0] = 1;
	cnt_edge++;
	ll cnt_full = 1;
	ll cnt_last = 1;
	for (ll i = 2; i < n; ++i) {
		add(i, cnt, gr, min(k, i), cnt_full, cnt_last);
	}
	cout << "YES\n";
	cout << cnt_edge << '\n';
	for (ll i = 0; i < n; ++i)
		for (ll j = i + 1; j < n; ++j)
			if (gr[i][j] == 1)
				cout << i + 1 << " " << j + 1 << '\n';
}