#include <bits/stdc++.h>

using namespace std;

using pii = pair<int, int>;

struct graph {
    int n;
    vector< vector<int> > g;
    set<pii> edges;

    graph(int _n) : n(_n), g(n) {

    }

    void add_edge(int u, int v) {
        pii uv = {u, v};
        pii vu = {v, u};
        if (edges.count(uv) or edges.count(vu)) {
            throw "EGOR";
        }
        edges.insert(uv);
        g[u].push_back(v);
        g[v].push_back(u);
    }

    int get_k() {
        set<int> ks;
        for (int i = 0; i < n; ++i) {
            ks.insert(g[i].size());
        }
        return ks.size();
    }

    void print() {
        cout << edges.size() << '\n';
        for (pii el : edges) {
            cout << el.first + 1 << ' ' << el.second + 1 << '\n';
        }
    }
};

void solve() {
    int n, k;
    cin >> n >> k;

    if (k >= n and n > 1) {
        cout << "NO\n";
        return;
    }

    if (k == 1) {
        cout << "YES\n";
        if (n == 1) {
            cout << "0\n";
        } else if (n == 2) {
            cout << "1\n";
            cout << "1 2\n";
        } else {
            cout << n << '\n';
            for (int i = 0; i < n; ++i) {
                cout << i + 1 << ' ' << (i + 1) % n + 1 << '\n';
            }
        }
        return;
    }

    graph g(n);

    int r = k - (k & 1);
    int i = 0;
    vector<int> arr(n);
    int cnt = n - 1;


    while (r) {
        int j = i + 1;
        while (arr[i] < cnt) {
            g.add_edge(i, j);

            ++arr[i];
            ++arr[j];
            ++j;
        }
        ++i;
        --cnt;
        r -= 2;

//        for (int el : arr) {
//            cout << el << ' ';
//        }
//        cout << endl;
    }

    if (k & 1) {
        g.add_edge(cnt, cnt - 1);
    }


    int kk = g.get_k();
//    cout << k << ' ' << kk << endl;
    assert(k == kk);
    cout << "YES\n";

    g.print();
}

int main() {
    solve();

}