#include <iostream>
#include <set>
#include <vector>
#include <cmath>
#include <map>
#include <bitset>
#include <iomanip>
using namespace std;

#define sp " "
#define int int64_t

int get(const set<int>& a, int i, int j){
    for(int s: a)
        if(s != i && s != j)
            return s;
    return -1;
}

void repair(int n, int gde, const vector<int>& a, const vector<pair<int, int> >& net, vector<int>& p){
    for(int i = 1; i <= n; ++i)
        if(i != gde && (gde != net[p[i]].first && gde != net[p[i]].second) && (net[gde].first != i && net[gde].second != i)){
            swap(p[i], p[gde]);
            break;
        }
}

void get_q(int n, const vector<int>& a, const vector<int>& p, vector<int>& q){
    vector<int> pos_a(n + 1), pos_p(n + 1);
    for(int i = 1; i <= n; ++i){
        pos_a[a[i]] = i;
        pos_p[p[i]] = i;
    }

    for(int i = 1; i <= n; ++i){
        q[i] = pos_p[pos_a[i]];
    }
}

void solve(){
    int n;
    cin >> n;

    set<int> s;
    for(int i = 0; i < n; ++i)
        s.insert(i + 1);

    vector<int> a(n + 1), p(n + 1), q(n + 1);
    vector<pair<int, int> > net(n + 1);
    for(int i = 1; i <= n; ++i){
        cin >> a[i];
        net[i] = {i, a[i]};
    }

    vector<pair<int, int> > tmp(n);
    for(int i = 0; i < n; ++i)
        tmp[i] = {i + 1, a[i + 1]};

    for(int k = 0; k < n; ++k){
        int j = tmp[k].first;
        int i = tmp[k].second;

        int pos = get(s, i, j);

        if(pos != -1){
            p[pos] = j;
            s.erase(pos);
        }
        else{
            if(k == n - 2){
                if(i == n && tmp[k + 1].second == n - 1){
                    p[n - 1] = n - 1;
                    p[n] = n;
                    swap(p[1], p[n - 1]);
                    swap(p[2], p[n]);
                    break;
                }
                else{
                    swap(tmp[k], tmp[k + 1]);
                    --k;
                    continue;
                }
            }
            else{
                int gde;
                for(int f = 1; f <= n; ++f)
                    if(p[f] == 0){
                        p[f] = j;
                        gde = f;
                        break;
                    }

                repair(n, gde, a, net, p);
                break;
            }
        }
    }

    // Print answer
    if(n == 1 || n == 2){
        cout << "Impossible" << endl;
        return;
    }

    get_q(n, a, p, q);

    for(int i = 1; i <= n; ++i)
        if(p[i] == i || q[i] == i || a[p[q[i]]] != i){
            cout << "Impossible" << endl;
            return;
        }

    cout << "Possible" << endl;
    for(int i = 1; i <= n; ++i)
        cout << p[i] << sp;
    cout << endl;
    for(int i = 1; i <= n; ++i)
        cout << q[i] << sp;
    cout << endl;
}



int32_t main(){
    int t;
    cin >> t;
    while(t--)
        solve();
    return 0;
}
