#include <bits/stdc++.h>

using namespace std;

bool is_valid(const vector<int> &a) {
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        if (a[i] == i) {
            return false;
        }
    }
    return true;
}

bool is_identity(const vector<int> &a) {
    for (int i = 0; i < a.size(); ++i) {
        if (a[i] != i) {
            return false;
        }
    }
    return true;
}

vector<int> apply(const vector<int> &a, const vector<int> &p, const vector<int> &q) {
    vector<int> res;
    for (int i = 0; i < a.size(); ++i) {
        res.push_back(a[p[q[i]]]);
    }
    return res;
}

vector<pair<vector<int>, vector<int>>> solve_slow(const vector<int> &a) {
    int n = a.size();
    vector<pair<vector<int>, vector<int>>> res;
    vector<int> p;
    for (int i = 0; i < n; ++i) {
        p.push_back(i);
    }
    do {
        if (!is_valid(p)) {
            continue;
        }
        vector<int> q;
        for (int i = 0; i < n; ++i) {
            q.push_back(i);
        }
        do {
            if (!is_valid(q)) {
                continue;
            }
            if (is_identity(apply(a, p, q))) {
                res.push_back({p, q});
                return res;
            }
        } while(next_permutation(q.begin(), q.end()));
    } while(next_permutation(p.begin(), p.end()));
    return res;
}

pair<vector<int>, vector<int>> solve(const vector<int> &a, const vector<int> &am1, const set<int> &bb, int costil) {
    int n = am1.size();
    set<int> bad = bb;
    for (int i = 0; i < n; i++) {
        int b = (n - am1[i] + i) % n;
        bad.insert(b);
//            cout << "bad: " << b << " (" << a[i] + 1 << "," << am1[i] + 1 << "," << i + 1 << ")" << endl;
    }
    if (bad.size() == n) {
        return {{}, {}};
    }
    int k = 1;
    for (; k < n; ++k) {
        if (bad.find(k) == bad.end()) {
            break;
        }
    }
    vector<int> p, q;
    for (int i = 0; i < n; ++i) {
        p.push_back(am1[(i + k) % n]);
    }
    for (int i = 0; i < n; ++i) {
        int cur = (i + n - k) % n;
        if (costil == 2) {
            if (cur == (n - k + 1) % n) {
                q.push_back((n - k) % n);
            } else if (cur == (n - k) % n) {
                q.push_back((n - k + 1) % n);
            } else {
                q.push_back(cur);
            }
        } else if (costil == 3) {
            if (cur == (n - k + 1) % n) {
                q.push_back((n - k + 2) % n);
            } else if (cur == (n - k + 2) % n) {
                q.push_back((n - k + 1) % n);
            } else {
                q.push_back(cur);
            }
        } else if (costil == 4) {
            if (cur == (n - k + 2) % n) {
                q.push_back((n - k) % n);
            } else if (cur == (n - k) % n) {
                q.push_back((n - k + 2) % n);
            } else {
                q.push_back(cur);
            }
        } else {
            q.push_back(cur);
        }
    }
    assert(is_identity(apply(a, p, q)));
    return {p, q};
}

bool print_solve(const vector<int> &a, const vector<int> &am1, const set<int> &bb, int costil) {
    auto pq = solve(a, am1, bb, costil);
    auto p = pq.first;
    auto q = pq.second;
    if (p.size() != 0) {
        cout << "Possible" << endl;
        for (auto i : p) {
            cout << i + 1 << " ";
        }
        cout << endl;
        for (auto i : q) {
            cout << i + 1 << " ";
        }
        cout << endl;
        return true;
    }
    return false;
}

bool solve_solve(const vector<int> &a) {
    int n = a.size();
    vector<int> am1(n);
    for (int i = 0; i < n; ++i) {
        am1[a[i]] = i;
    }
    if (print_solve(a, am1, {0}, 1)) {
        return true;
    }
    swap(am1[0], am1[1]);
    if (print_solve(a, am1, {0, 1, n - 1}, 2)) {
        return true;
    }
    swap(am1[0], am1[1]);
    if (n >= 3) {
        swap(am1[1], am1[2]);
        if (print_solve(a, am1, {0, 1, n - 1}, 3)) {
            return true;
        }
        swap(am1[1], am1[2]);
        swap(am1[0], am1[2]);
        if (print_solve(a, am1, {0, 2, n - 2}, 4)) {
            return true;
        }
    }
    cout << "Impossible" << endl;
    return false;
}

int main() {
//    const int N = 6;
//    vector<int> a(N);
//    for (int i = 0; i < N; ++i) {
//        a[i] = i;
//    }
//    do {
//        bool ok = solve_solve(a);
//        auto res = solve_slow(a);
//        bool ok2 = !res.empty();
//        if (ok != ok2) {
//            cout << "FOUND" << endl;
//            for (int i : a) {
//                cout << i + 1 << " ";
//            }
//            cout << endl;
//            for (auto pq : res) {
//                auto p = pq.first;
//                auto q = pq.second;
//                for (int i : p) {
//                    cout << i + 1 << " ";
//                }
//                cout << endl;
//                for (int i : q) {
//                    cout << i + 1 << " ";
//                }
//                cout << endl << endl;
//            }
//            return 0;
//        }
//    } while(next_permutation(a.begin(), a.end()));
//    return 0;

    int tests;
    cin >> tests;
    for (;tests > 0; --tests) {
        int n;
        cin >> n;
        if (n == 1) {
            cin >> n;
            cout << "Impossible" << endl;
            continue;
        }
        vector<int> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
            --a[i];
        }
        solve_solve(a);
//        auto res = solve_slow(a);
//        if (res.empty()) {
//            cout << "Impossible" << endl;
//        } else {
//            cout << "Possible" << endl;
//            for (auto pq : res) {
//                auto p = pq.first;
//                auto q = pq.second;
//                for (int i : p) {
//                    cout << i + 1 << " ";
//                }
//                cout << endl;
//                for (int i : q) {
//                    cout << i + 1 << " ";
//                }
//                cout << endl << endl;
//            }
//        }

    }
}
