#include <iostream>
#include <vector>
#include <random>
#include <algorithm>

using namespace std;

mt19937 rng(123);

vector<int> compose(vector<int> p, vector<int> q) {
	vector<int> ans(p.size());
	for (int i = 0; i < (int)p.size(); i++) {
		ans[i] = p[q[i]];
	}
	return ans;
}

bool check(vector<int>& a) {
	for (int i = 0; i < (int)a.size(); i++) {
		if (a[i] == i) {
			return false;
		}
	}
	return true;
}

vector<int> inv(vector<int> a) {
	vector<int> res(a.size());
	for (int i = 0; i < a.size(); i++) {
		res[a[i]] = i;
	}
	return res;
}

void solve() {
	int n;
	cin >> n;
	vector<int> a(n);
	for (int& i: a) {
		cin >> i;
		i--;
	}
	if (n == 1) {
		cout << "Impossible\n";
		return;
	}
	vector<int> p(n);
	iota(p.begin(), p.end(), 0);
	a = inv(a);
	for (int iter = 0; iter < 50; iter++) {
		while (!check(p)) {
			shuffle(p.begin(), p.end(), rng);
		}
		auto q = compose(a, inv(p));
		if (check(q)) {
			cout << "Possible\n";
			for (int i: p) {
				cout << i+1 << " ";
			}
			cout << "\n";
			for (int i: q) {
				cout << i+1 << " ";
			}
			cout << "\n";
			return;
		}
	}
	cout << "Impossible\n";
}

int main() {
	// ios_base::sync_with_stdio(0);
	// cin.tie(0);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}
