import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.StringTokenizer;

public class K {
    private static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    private static StringTokenizer st = null;

    private static String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    private static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    private class Pair {
        int k;
        int v;

        public Pair(int k, int v) {
            this.k = k;
            this.v = v;
        }
    }

    public static void main(String[] args) throws IOException {
        int n = nextInt(), k = nextInt();
        if (n == 2 && k == 1) {
            System.out.println("YES\n2\n1 2");
            return;
        }
        if (k >= n) {
            System.out.println((k == 1) ? "YES\n0" : "NO");
            return;
        }
        if (k == 1) {
            System.out.println("YES\n" + n);
            for (int i = 0; i < n - 1; i++) {
                System.out.println(i + 1 + " " + (i + 2));
            }
            System.out.println(n + " 1");
            return;
        }
        int g = k + 1;
        LinkedList<Integer>[] graph = new LinkedList[g];
        for (int i = 0; i < g; i++) graph[i] = new LinkedList<>();
        for (int i = 0; i < g; i += 2) {
            /*graph[i].addLast(i + 1);
            graph[i + 1].addLast(i);*/
            for (int j = i + 1; j < g; j++) {
                graph[i].addLast(j);
                graph[j].addLast(i);
            }
        }
        int two = -1;
        for (int i = 0; i < g; i++) {
            if (graph[i].size() == 2) two = i;
        }

        StringBuilder ans = new StringBuilder();

        int m = 0;
        for (int i = 0; i < g; i++) {
            if (i == two) continue;
            for (int j : graph[i]) {
                if (j == two) continue;
                if (i < j) {
                    m += 1;
                    ans.append(i + 1 + " " + (j + 1) + "\n");
                }
            }
        }

        int u = graph[two].pop();
        int v = graph[two].pop();
        for (int i = k + 1; i < n; i++) {
            m += 1;
            ans.append(u + 1 + " " + (i + 1) + "\n");
            u = i;
        }
        m += 2;
        ans.append(u + 1 + " " + (two + 1) + "\n");
        ans.append(two + 1 + " " + (v + 1) + "\n");

        System.out.println("YES\n" + m);
        System.out.println(ans);
    }
}
