#include <iostream>
#include <vector>
#include <queue>

using namespace std;

vector <int> rt;
vector <int> sz;

int get_root(int v){
    int b = v;
    while(v != rt[v]){
        v = rt[v];
    }
    rt[b] = v;
    return v;
}

void concat(int v, int u){
    v = get_root(v);
    u = get_root(u);
    if(u != v){
        if(sz[v] < sz[u]){
            rt[v] = u;
            sz[u] += sz[v];
        }else{
            rt[u] = v;
            sz[v] += sz[u];
        }
    }
}

int main()
{
    int t;
    cin >> t;
    while(t--){
        int n;
        cin >> n;
        vector<int> a(n);
        rt = vector<int> (n, 0);
        sz = vector<int> (n, 1);
        for(int i = 0; i < n; ++i){
            cin >> a[i];
            --a[i];
            rt[i] = i;
        }
        if(n == 1){
            cout << "Impossible\n";
        }else{
            vector<int> to(n);
            vector<int> pr(n);
            for(int i = 0; i < n; ++i){
                to[i] = a[i];
                pr[to[i]] = i;
                concat(i, to[i]);
            }
            vector<int> ones(0);
            vector<int> twos(0);
            vector<int> bigs(0);
            for(int i = 0; i < n; ++i){
                if(sz[i] == 1 && i == get_root(i)){
                    ones.push_back(i);
                }
                if(sz[i] == 2 && i == get_root(i)){
                    twos.push_back(i);
                }
                if(sz[i] > 2 && i == get_root(i)){
                    bigs.push_back(i);
                }
            }
            if(ones.size() > 1){
                for(int i = 0; i < ones.size()-1; ++i){
                    int a = ones[i];
                    int b = ones[i+1];
                    concat(a, b);
                    to[a] = b;
                    pr[b] = a;
                }
                int a = ones[ones.size()-1];
                int b = ones[0];
                to[a] = b;
                pr[b] = a;
                int r = get_root(a);
                bigs.push_back(r);
            }
            if(twos.size() == 1 && bigs.size() == 0){
                cout << "Impossible\n";
            }else{
                cout << "Possible\n";
                int i = 0;
                int base;
                if(twos.size() > 1){
                    base = twos[0];
                    ++i;
                }else{
                    base = bigs[0];
                }

                for(i; i < twos.size(); ++i){
                    int a = get_root(twos[i]);
                    int a_to = to[a];
                    int b = get_root(i);
                    int b_pr = pr[b];
                    int b_to = to[b];

                    to[b_pr] = a;
                    pr[a] = b_pr;

                    to[a] = b;
                    pr[b] = a;

                    to[b] = a_to;
                    pr[a_to] = b;

                    to[a_to] = b_to;
                    pr[b_to] = a_to;
                }
                if(ones.size() == 1){
                    int a = ones[0];
                    int p = pr[0];

                    to[a] = 0;
                    pr[0] = a;

                    to[p] = a;
                    pr[a] = p;
                }
                vector<int> p(n);
                for(int i = 0; i < n; ++i){
                    p[i] = to[i];
                }
                for(int i = 0; i < n; ++i){
                    pr[i] = p[i];
                    cout << p[i]+1 << ' ';
                }
                cout << endl;
                for(int i = 0; i < n; ++i){
                    p[i] = a[pr[i]];
                }
                for(int i = 0; i < n; ++i){
                    pr[p[i]] = i;
                }
                for(int i = 0; i < n; ++i){
                    cout << pr[i]+1 << ' ';
                }
                cout << endl;
            }
        }
    }
    return 0;
}
