#include <bits/stdc++.h>

#ifdef ONPC
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimiez("O3")
#pragma unroll
#endif

using namespace std;

const int MAXITER = 30;

bool Failed(int i, int qi, const vector<int>& a) {
    return (qi == i) || (a[qi] == i);
}

void Solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }

    vector<int> q(n);
    iota(q.begin(), q.end(), 0);
    mt19937 rnd(7545923);
    for (int iter = 0; iter < MAXITER; ++iter) {
        shuffle(q.begin(), q.end(), rnd);

        bool succ{true};

        for (int i = 0; i < n; ++i) {
            bool failed{Failed(i, q[i], a)};

            if (failed) {
                for (int j = 0; j < n; ++j) {
                    if (!Failed(i, q[j], a) && !Failed(j, q[i], a)) {
                        swap(q[i], q[j]);
                        failed = false;
                        break;
                    }
                }
            }

            if (failed) {
                succ = false;
                break;
            }
        }

        if (succ) {
            cout << "Possible\n";

            vector<int> b(n);
            for (int i = 0; i < n; ++i) {
                b[i] = a[q[i]];
            }

//            for (int i = 0; i < n; ++i) {
//                cout << b[i] << " ";
//            }
//            cout << "\n";

            vector<int> p(n);
            for (int i = 0; i < n; ++i) {
                p[b[i]] = i;
            }

            for (int x : q) {
                cout << x + 1 << " ";
            }
            cout << "\n";
            for (int x : p) {
                cout << x + 1 << " ";
            }
            cout << "\n";

//            for (int i = 0; i < n; ++i) {
//                if (a[q[p[i]]] != i) {
//                    cout << "FAIL!!!\n";
//                }
//            }

            return;
        }
    }

    cout << "Impossible\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef ONPC
    freopen("../input.txt", "r", stdin);
#endif

    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        Solve();
    }

    return 0;
}
