#include <bits/stdc++.h>

#ifdef ONPC
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimiez("O3")
#pragma unroll
#endif

using namespace std;

bool IsCandOK(const vector<vector<int>>& a, int maxn, int cand, vector<vector<int>>& la, vector<vector<int>>& ra) {
    la.assign(a.size(), {});
    ra.assign(a.size(), {});

    vector<char> isl(maxn, false);
    int nl{0}, nr = a[0].size() - 1;
    for (int i = 0; a[0][i] != cand; ++i) {
        isl[a[0][i]] = true;
        ++nl;
        --nr;
    }

    if (nl % 2 == 0 || nr % 2 == 0) {
        return false;
    }

    for (int i = 0; i < a.size(); ++i) {
        bool isfl = isl[a[i][0]];
        isfl = !isfl;

        int lal, lar, ral, rar;
        if (!isfl) {
            lal = 0;
            lar = nl;
            ral = lar + 1;
            rar = a[0].size();
        } else {
            ral = 0;
            rar = nr;
            lal = rar + 1;
            lar = a[0].size();
        }

        for (int j = lal; j < lar; ++j) {
            if (!isl[a[i][j]]) {
                return false;
            }
            la[i].push_back(a[i][j]);
        }
        for (int j = ral; j < rar; ++j) {
            if (isl[a[i][j]]) {
                return false;
            }
            ra[i].push_back(a[i][j]);
        }
    }

    return true;
}

int GetRoot(vector<vector<int>> a, int n, int maxn, int k, vector<int> &ans) {
    //cerr << "Looking at " << n << endl;

    if (n == 1) {
        return a[0][0];
    }

    // init number of left and of right
    vector<int> nl(maxn, -1), nr(maxn, -1);
    for (int i = 0; i < n; ++i) {
        nl[a[0][i]] = i;
        nr[a[0][i]] = n - i - 1;
    }

    // go, find
    for (int i = 1; i < k; ++i) {
        for (int j = 0; j < n; ++j) {
            int cx = a[i][j];
            int cl = j;
            if (cl != nl[cx] && cl != nr[cx]) {
                nl[cx] = -1;
                nr[cx] = -1;
            }
        }
    }

    // find candidates
    set<int> cands;
    //cerr << "Candidates are:";
    for (int i = 0; i < maxn; ++i) {
        if (nl[i] != -1) {
            //cerr << " " << i;
            cands.insert(i);
        }
    }
    //cerr << endl;

    int cand{-1};

    vector<vector<int>> la, ra;
    for (int cc : cands) {
        if (IsCandOK(a, maxn, cc, la, ra)) {
            cand = cc;
            //cerr << "Candidate " << cand << " is ok" << endl;
            break;
        }
    }

    // Recursion
    ans[GetRoot(la, la[0].size(), maxn, k, ans)] = cand;
    ans[GetRoot(ra, ra[0].size(), maxn, k, ans)] = cand;

    return cand;
}

void Solve() {
    int n, k;
    cin >> n >> k;
    vector<vector<int>> a(k, vector<int>(n));
    for (vector<int> &x: a) {
        for (int &y: x) {
            cin >> y;
            --y;
        }
    }

//    for (int i = 0; i < k; ++i) {
//        for (int j = 0; j < n; ++j) {
//            cout << a[i][j] << " ";
//        }
//        cout << "\n";
//    }

    vector<int> ans(n, -1);
    ans[GetRoot(a, n, n, k, ans)] = -2;

    for (int x: ans) {
        cout << x + 1 << " ";
    }
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef ONPC
    freopen("../input.txt", "r", stdin);
#endif

    Solve();

    return 0;
}
