#include <bits/stdc++.h>

#ifdef ONPC
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimiez("O3")
#pragma unroll
#endif

using namespace std;

bool solved{false};

string GetAns(int x, int y) {
    cout << x << " " << y << endl;
    string s;
    getline(cin, s);
    if (s.back() == '!') {
        solved = true;
    }
    return s;
}

string further, closer;

enum Res {
    FURT,
    CLOS,
    SAME
};

Res ParseAns(string ans) {
    if (ans == further) {
        return FURT;
    } else if (ans == closer) {
        return CLOS;
    }
    return SAME;
}

void GetQueries() {
    GetAns(1, 0);
    if (solved) return;
    GetAns(0, 1);
    if (solved) return;
    GetAns(0, 0);
    if (solved) return;
    closer = GetAns(1, 1);
    if (solved) return;
    further = GetAns(0, 0);
}

bool is_first_coord;
int other_coord_val;

Res Query(int cx) {
    if (is_first_coord) {
        return ParseAns(GetAns(cx, other_coord_val));
    } else {
        return ParseAns(GetAns(other_coord_val, cx));
    }
}

const int MAXX = 1000000;

int SolveCoord(bool isf, int othval) {
    is_first_coord = isf;
    other_coord_val = othval;

    int cl{0}, cr{MAXX};
    int lastx{0};

    while (!solved && cr > cl) {
        int delta = lastx - cl;
        if (cr - delta >= 0 && cr - delta <= MAXX && cr - delta != lastx) {
            // query
            Res res = Query(cr - delta);
            lastx = cr - delta;
            bool has_mid = ((cr - cl) % 2 == 0);
            if (res == SAME) {
                int mid = (cl + cr) / 2;
                cl = mid;
                cr = mid;
            } else {
                if (lastx < cl + delta) {
                    if (res == CLOS) {
                        res = FURT;
                    } else {
                        res = CLOS;
                    }
                }
                if (res == FURT) {
                    // left half
                    cr = (cl + cr - 1) / 2;
                } else {
                    // right half
                    cl = (cl + cr + 2) / 2;
                }
            }
        } else {
            // new lastx
            int newd = (cr - cl + 1) / 3;
            if (cl == 0) {
                newd = ((cr - cl + 1) * 2) / 3;
            }
            while (cr - newd < 0 || cl + newd == cr - newd || cl + newd >= cr) {
                --newd;
            }
            Query(cl + newd);
            lastx = cl + newd;
        }
    }

    if (!solved && lastx != cl) {
        Query(cl);
    }

    return cl;
}

void Solve() {
    GetQueries();

    if (!solved) {
        int cx = SolveCoord(true, 0);

        if (!solved) {
            SolveCoord(false, cx);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef ONPC
//    freopen("../input.txt", "r", stdin);
#endif

//    int t;
//    cin >> t;
//    for (int i = 0; i < t; ++i) {
        Solve();
//    }

    return 0;
}
