#include <bits/stdc++.h>

#ifdef ONPC
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimiez("O3")
#pragma unroll
#endif

using namespace std;

typedef long long ll;

int n, m;
vector<int> ru, rv;
vector<int> to_add;
ll p;

vector<vector<int>> r;

vector<int> ans_delta;
vector<vector<int>> ans_i;

void Add(ll& a, ll b) {
    a += b;
    if (a >= p) {
        a -= p;
    }
}

void Mul(ll& a, ll b) {
    a = (a * b) % p;
}

ll ToDeg(ll x, ll d) {
    if (d == -1) {
        d += p - 1;
    }

    if (d == 0) {
        return 1;
    }

    ll ans = ToDeg(x, d / 2);
    Mul(ans, ans);
    if (d & 1) {
        Mul(ans, x);
    }

    return ans;
}

int GetOther(int i, int u) {
    if (ru[i] == u) {
        return rv[i];
    }
    return ru[i];
}

int GetRoot(int i, vector<int>& root) {
    if (root[i] == i) {
        return i;
    }
    root[i] = GetRoot(root[i], root);
    return root[i];
}

bool Unite(int u, int v, vector<int>& root) {
    u = GetRoot(u, root);
    v = GetRoot(v, root);

    if (root[u] == v) {
        return false;
    }
    root[u] = v;

    return true;
}

void EdgeBiConnDFS(int u, int le, vector<int>& root, vector<int>& path, vector<char>& vis_node, vector<char> vis_edge) {
//    //cerr << "visiting node " << u << " through edge " << le << endl;

    if (le >= 0) {
        vis_edge[le] = true;
    }

    if (vis_node[u]) {
        // update dsu
//        //cerr << "Updating dsu..." << endl;
        int ci = path.size() - 2;
        while (path[ci] != u) {
            ci -= 2;
        }
        ++ci;
        while (ci < path.size()) {
            Unite(le, path[ci], root);
            ci += 2;
        }

//        //cerr << "Updated dsu" << endl;

        return;
    }

    path.push_back(u);
    vis_node[u] = true;

    for (int i = 0; i < r[u].size(); ++i) {
        int ei = r[u][i];
        int v = GetOther(ei, u);

        if (ei == le) {
            continue;
        }

        if (!vis_edge[ei]) {
            path.push_back(ei);
            EdgeBiConnDFS(v, ei, root, path, vis_node, vis_edge);
            path.pop_back();
        }
    }

    path.pop_back();
    vis_node[u] = false;
}

vector<vector<int>> GetBiConnectedComps() {
    vector<char> vis_node(n, false);
    vector<char> vis_edge(m, false);
    vector<int> path;

    vector<int> edge_root(m);
    iota(edge_root.begin(), edge_root.end(), 0);

    EdgeBiConnDFS(0, -1, edge_root, path, vis_node, vis_edge);

    map<int, int> comp_ind;
    vector<vector<int>> comp_e;
    for (int i = 0; i < m; ++i) {
        int ri = GetRoot(i, edge_root);

        if (comp_ind.count(ri) == 0) {
            comp_ind[ri] = comp_e.size();
            comp_e.push_back({});
        }

        comp_e[comp_ind[ri]].push_back(i);
    }

    return comp_e;
}

vector<int> span_root;

vector<int> FindSpanningTree(const vector<int>& edges, int li = -1, int ri = -1) {
    if (span_root.empty()) {
        span_root.resize(n);
    }

    for (int ei : edges) {
        span_root[ru[ei]] = ru[ei];
        span_root[rv[ei]] = rv[ei];
    }

    if (li != -1) {
        Unite(ru[li], rv[li], span_root);
    }

    vector<int> span;
    for (int ei : edges) {
        if (ei == ri) {
            continue;
        }
        if (Unite(ru[ei], rv[ei], span_root)) {
            span.push_back(ei);
        }
    }

    if (li != -1) {
        span.push_back(li);
    }

    return span;
}

void AddTree(const vector<vector<int>>& edge_list, int delta) {
    if (delta < 0) {
        delta += p;
    }

    ans_delta.push_back(delta);
    ans_i.push_back({});

    for (const vector<int>& edges : edge_list) {
        for (int ei : edges) {
            ans_i.back().push_back(ei);
            to_add[ei] -= delta;
            if (to_add[ei] < 0) {
                to_add[ei] += p;
            }
        }
    }
}

void AddDefTree(const vector<vector<int>>& default_tree, const vector<vector<int>>& comp_e) {
    ll val{0};
    {
        ll sum{0};
        for (int ei : comp_e[0]) {
            //cerr << ei << " ";
            sum += to_add[ei];
        }
        //cerr << endl;
        sum %= p;

        //cerr << sum << "\n";
        //cerr << "ne = " << default_tree[0].size() << "\n";
        //cerr << "ne^-1 = " << ToDeg(default_tree[0].size(), -1) << endl;

        Mul(sum, ToDeg(default_tree[0].size(), -1));
        val = sum;
        //cerr << "val = " << val << endl;
    }

    if (val == 0) {
        return;
    }

    AddTree(default_tree, val);
}

void Solve() {
    cin >> n >> m >> p;
    ru.resize(m);
    rv.resize(m);
    to_add.resize(m);
    r.resize(n);
    for (int i = 0; i < m; ++i) {
        cin >> ru[i] >> rv[i] >> to_add[i];
        --ru[i];
        --rv[i];
        r[ru[i]].push_back(i);
        r[rv[i]].push_back(i);
    }

    // find bi-connected components
    vector<vector<int>> comp_e = GetBiConnectedComps();
    int k = comp_e.size();

    // build default spanning tree
    vector<vector<int>> default_tree(k);
    for (int i = 0; i < k; ++i) {
        default_tree[i] = FindSpanningTree(comp_e[i]);
    }

    // if there's bridges, add default
    AddDefTree(default_tree, comp_e);

    // process components
    for (int ki = 0; ki < k; ++ki) {
        // check sum 0
        ll wsum{0};
        for (int ei : comp_e[ki]) {
            wsum += to_add[ei];
        }

        if (wsum % p != 0) {
            cout << "-1\n";
            return;
        }

        // collect bad edges, get them
        for (int ei : comp_e[ki]) {
            if (to_add[ei] != 0) {
                int oth_ei = comp_e[ki][1];
                if (oth_ei == ei) {
                    oth_ei = comp_e[ki][0];
                }

                int delta = to_add[ei];

                vector<int> save = default_tree[ki];

                default_tree[ki] = FindSpanningTree(comp_e[ki], ei, oth_ei);

                AddTree(default_tree, delta);

                default_tree[ki] = FindSpanningTree(comp_e[ki], oth_ei, ei);

                AddTree(default_tree, -delta);

                default_tree[ki] = save;
            }
        }
    }

    // print answer
    cout << ans_delta.size() << "\n";
    for (int i = 0; i < ans_delta.size(); ++i) {
        cout << ans_delta[i];
        for (int j : ans_i[i]) {
            cout << " " << j + 1;
        }
        cout << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef ONPC
    freopen("../input.txt", "r", stdin);
#endif

    Solve();

    return 0;
}
