#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define el "\n"
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()

using namespace std;

const int N = 1e3 + 50;

const int steps[4][2] = {{0, 1}, {1, 0}, {0, -1}, {-1, 0}};

vector <int> g[N * N];
int cnt[2], a[N][N];
vector <int> who[2];
bool mk[N * N];
int mt[N * N], to[N * N];
ll ans;

bool kuhn(int v) {
    if (mk[v]) {
        return 0;
    }
    mk[v] = 1;
    for (auto u : g[v]) {
        if (mt[u] == -1 || kuhn(mt[u])) {
            mt[u] = v;
            to[v] = u;
            return 1;
        }
    }
    return 0;
}
void try_kuhn(int v) {
    if (mk[v]) {
        return;
    }
    mk[v] = 1;
    ans--;
    for (auto u : g[v]) {
        if (to[v] == u) {
            continue;
        }
        try_kuhn(mt[u]);
    }
    return;
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);

//    freopen("output.txt", "w", stdout);

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        for (int j = 0  ; j < m; j++) {
            char c;
            cin >> c;
            if (c == '.') {
                a[i][j] = 0;
                cnt[(i + j) % 2]++;
                who[(i + j) & 1].pb(i * m + j);
            } else {
                a[i][j] = 1;
            }
        }
    }
    ans = cnt[0] * 1ll * (cnt[0] - 1) / 2ll + cnt[1] * 1ll * (cnt[1] - 1) / 2ll;

    if (ans > (ll)1e6) {
        cout << "1000000";
        return 0;
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j]) {
                continue;
            }
            for (auto [dx, dy] : steps) {
                int x = i + dx, y = j + dy;
                if (x < 0 || x >= n || y < 0 || y >= m || a[x][y]) {
                    continue;
                }
                g[i * m + j].pb(x * m + y);
            }
        }
    }
    if (sz(who[0]) > sz(who[1])) {
        swap(who[0], who[1]);
        swap(cnt[0], cnt[1]);
    }

    for (auto i : who[1]) {
        mt[i] = -1;
    }

    for (auto i : who[0]) {
        for (auto x : who[0]) {
            mk[x] = 0;
        }
        kuhn(i);
    }

    ans += cnt[0] * 1ll * cnt[1];
    for (auto i : who[0]) {
        for (auto x : who[0]) {
            mk[x] = 0;
        }
        try_kuhn(i);
    }
    cout << min((ll)1e6, ans);
}