#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
using ull = unsigned long long;

template<class T, class U> inline void umin(T& a, const U b) { if (b < a) a = b; }
template<class T, class U> inline void umax(T& a, const U b) { if (b > a) a = b; }

const int N = 1010;
const ll MAX = 1'000'000;
int n, m;

string row[N];
vector<int> vertices;
vector<int> wh_vertices;
vector<int> bk_vertices;
vector<int> edges[N * N];
bool mrk[N * N];
bool used[N * N];
ll glob_siz;
int mt[N * N];
int mem_b;

int ID(int x, int y) {
    return x * m + y;
}

void dfs(int v) {
    if (mrk[v]) return;

    mrk[v] = true;
    glob_siz++;
    for (int u : edges[v]) {
        dfs(u);
    }
}

void GetVert(int v) {
    if (mrk[v]) return;

    mrk[v] = true;
    int cur_x = v / m;
    int cur_y = v % m;
    if ((cur_x + cur_y) % 2 == 0) {
        wh_vertices.push_back(v);
    } else {
        bk_vertices.push_back(v);
    }
    vertices.push_back(v);
    for (int u : edges[v]) {
        GetVert(u);
    }
}

bool try_kuhn(int v) {
    if (used[v]) {
        return false;
    }
    used[v] = true;

    for (int u : edges[v]) {
        if (mt[u] == -1 || try_kuhn(mt[u])) {
            mt[u] = v;
            return true;
        }
    }

    return false;
}

void Count(int v) {
    if (used[v]) {
        return;
    }
    glob_siz++;
    used[v] = true;

    for (int u : edges[v]) {
        if (u == mem_b) continue;
        Count(mt[u]);
//        if (mt[u] == -1 || try_kuhn(mt[u])) {
//            mt[u] = v;
//            return true;
//        }
    }
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> row[i];
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (row[i][j] == '#') continue;

            if (i + 1 < n) {
                if (row[i + 1][j] == '.') {
                    edges[ID(i, j)].push_back(ID(i + 1, j));
                    edges[ID(i + 1, j)].push_back(ID(i, j));
                }
            }

            if (j + 1 < m) {
                if (row[i][j + 1] == '.') {
                    edges[ID(i, j + 1)].push_back(ID(i, j));
                    edges[ID(i, j)].push_back(ID(i, j + 1));
                }
            }
        }
    }

    fill(mrk, mrk + n * m, false);
    vector<ll> sizes;
    ll al_sum = 0;
    ll ans = 0;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (row[i][j] == '#') continue;

            int ind = ID(i, j);
            if (mrk[ind]) continue;

            glob_siz = 0;
            dfs(ind);

            sizes.push_back(glob_siz);
            al_sum += glob_siz;
        }
    }

    ll rem = 0;
    for (ll cur_siz : sizes) {
        ans += rem * cur_siz;
        if (cur_siz > 2) {
            ll mem = cur_siz / 2;
            ans += mem * (mem - 1);
        }
        rem += cur_siz;
    }

    if (ans >= MAX) {
        cout << MAX << '\n';
        return;
    }

    fill(mrk, mrk + n * m, false);
    fill(mt, mt + n * m, -1);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (row[i][j] == '#') continue;

            int ind = ID(i, j);
            if (mrk[ind]) continue;

            wh_vertices.clear();
            bk_vertices.clear();
            vertices.clear();
            GetVert(ind);

//            cerr << wh_vertices.size() << '\n';
//            cerr << bk_vertices.size() << '\n';
//            cerr << vertices.size() << '\n';

            for (int v : wh_vertices) {
                for (int u : vertices) {
                    used[u] = false;
                }
//                cerr << "AGA\n";
                assert(try_kuhn(v));
//                cerr << "MATCVH\n";
//                for (int u : bk_vertices) {
//                    cerr << u << " " << mt[u] << '\n';
//                }
            }

            for (int v : bk_vertices) {
                assert(mt[v] != -1);
                mt[mt[v]] = v;
            }

            for (int u : bk_vertices) {
                glob_siz = 0;

                for (int in : vertices) {
                    used[in] = false;
                }
                mem_b = u;
                Count(mt[u]);

                ans += wh_vertices.size() - glob_siz;

                if (ans >= MAX) {
                    cout << MAX << '\n';
                    return;
                }
            }
        }
    }

    cout << min<ll>(ans, MAX) << '\n';
}

signed main() {
    cout.precision(15);
#ifdef KEK
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(0);
    ios::sync_with_stdio(false);
#endif
//    int qq; cin >> qq;
//    for (; qq; qq--) {
        solve();
//    }
}
