#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
using ull = unsigned long long;

template<class T, class U> inline void umin(T& a, const U b) { if (b < a) a = b; }
template<class T, class U> inline void umax(T& a, const U b) { if (b > a) a = b; }

string clo, far;
string CLO = "C", FAR = "F", SAM = "S";

int px, py, ansx, ansy, gotx, goty;

ll sq(ll x) { return x * x; }
ll dist(int x, int y) { return sq(x - ansx) + sq(y - ansy); }
int CNT = 0, WAS = 0;

string q(int x, int y) {
#ifdef KEK
    ++CNT;
    string res;
    if (x == ansx && y == ansy) WAS = 1;
    if (dist(x, y) < dist(px, py)) {
        res = CLO;
    } else if (dist(x, y) > dist(px, py)) {
        res = FAR;
    } else {
        res = SAM;
    }
    px = x;
    py = y;
    return res;
#else
    cout << x << ' ' << y << endl;
    string u;
    getline(cin, u);
    if (u.back() == '!') exit(0);
    px = x;
    py = y;
    return u;
#endif
}

enum class response {farther, closer, same};

response req(int x, int y) {
    string t = q(x, y);
    if (t == clo) return response::closer;
    if (t == far) return response::farther;
    return response::same;
}

constexpr int n = 1e6;

void solve() {
    q(0, 0);
    clo = q(1, 1);
    q(1, 0);
    q(0, 1);
    q(1, 1);
    far = q(0, 0);
    int lx = 0, rx = n;
    int ly = 0, ry = n;
    bool bad_x = false, bad_y = false;
    while (lx < rx || ly < ry) {
        if (!bad_y && ly < ry) {
            // y
            int m = ly + ry >> 1;
            response re;
            if (py == ly) {
                re = req(px, ry);
            } else {
                re = req(px, ly);
            }
            bool to_l, stop = false;
            switch (re) {
                case response::farther: {
                    to_l = py == ry;
                    bad_y = to_l == (py == ry);
                    break;
                }
                case response::closer: {
                    to_l = py == ly;
                    bad_y = to_l == (py == ry);
                    break;
                }
                case response::same: {
                    ly = ry = m;
                    stop = true;
                    break;
                }
            }
            if (stop) continue;
            if (to_l) {
                if (ly + ry & 1) {
                    ry = m;
                } else {
                    ry = m - 1;
                }
            } else {
                ly = m + 1;
            }
        } else if (!bad_x && lx < rx) {
            // x
            int m = lx + rx >> 1;
            response re;
            if (px == lx) {
                re = req(rx, py);
            } else {
                re = req(lx, py);
            }
            bool to_l, stop = false;
            switch (re) {
                case response::farther: {
                    to_l = px == rx;
                    bad_x = to_l == (px == rx);
                    break;
                }
                case response::closer: {
                    to_l = px == lx;
                    bad_x = to_l == (px == rx);
                    break;
                }
                case response::same: {
                    lx = rx = m;
                    stop = true;
                    break;
                }
            }
            if (stop) continue;
            if (to_l) {
                if (lx + rx & 1) {
                    rx = m;
                } else {
                    rx = m - 1;
                }
            } else {
                lx = m + 1;
            }
        } else {
            bad_x = false;
            bad_y = false;
            q(lx, ly);
        }
    }
    gotx = rx;
    goty = ry;
    q(rx, ry);
}

void test(int x, int y) {
    px = -1;
    py = -1;
    CNT = 0;
    WAS = 0;
    ansx = x;
    ansy = y;
    solve();
    if (!WAS && (gotx != x || goty != y || CNT > 64)) {
        cerr << "gavno! " << x << ' ' << y << ' ' <<
            "got: " << gotx << ' ' << goty  << ' ' << CNT << endl;
        exit(1);
    }
    cerr << x << ' ' << y << " ok! " << CNT << endl;
}

signed main() {
    cout.precision(15);
#ifdef KEK
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
test(0, 5);
    vector<int> f = {0, 1, 2, 3, 4, 5, 20, 5000, 500000, 500001};
    vector<int> x = f;
    for (int i : f) x.push_back(n - i);
    std::sort(x.begin(), x.end());
    for (int i : x) {
        for (int j : x) {
            test(i, j);
        }
    }
#else
//    cin.tie(0);
//    ios::sync_with_stdio(false);
#endif
    solve();
}