//#include <iostream>
#include <bits/stdc++.h>

using namespace std;

int a[1050][1050];
int b[1050][1050];
int vertices_indices[1050][1050];
int cnts[2] = {0, 0};
int dx[4] = {0, 0, -1, 1};
int dy[4] = {-1, 1, 0, 0};

vector<int> g[100000];


namespace kuhn {

int n, k;
vector<int> mt;
vector<int> used;

bool try_kuhn(int v) {
    if (used[v]) {
        return false;
    }
    used[v] = true;
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        if (mt[to] == -1 || try_kuhn(mt[to])) {
            mt[to] = v;
            return true;
        }
    }
    return false;
}

}

int used[1050][1050];
int cur_ans = 0;
pair<int, int> another[1050][1050];

//int dxxx[4] = {-1, -1, 1, 1};
//int dyyy[4] = {1, -1, 1, -1};

void Dfs(int x, int y, int n, int m) {
//    cout << x << ' ' << y << endl;
    ++cur_ans;
    used[x][y] = true;
    for (int i = 0; i < 4; ++i) {
        int new_x = x + dx[i];
        int new_y = y + dy[i];
        if (new_x < 0 || new_x >= n || new_y < 0 || new_y >= m) {
            continue;
        }
        if (!b[new_x][new_y] || b[new_x][new_y] == b[x][y]) {
            continue;
        }
        auto [tox, toy] = another[new_x][new_y];
        if (!used[tox][toy]) {
            Dfs(tox, toy, n, m);
        }
    }
}

int main() {
//    freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);

    for (int i = 0; i < 1050; ++i) {
        for (int j = 0; j < 1050; ++j) {
            vertices_indices[i][j] = -1;
        }
    }

    int n, m;
    cin >> n >> m;
    int free = 0;
    vector<pair<int, int>> frees;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < m; ++j) {
            a[i][j] = s[j] == '#';
            free += a[i][j] == 0;
        }
    }

    if (free > 2005) {
        return cout << 1000000 << endl, 0;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (!a[i][j]) {
                frees.emplace_back(i, j);
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j]) {
                continue;
            }
            vertices_indices[i][j] = cnts[(i + j) & 1]++;
        }
    }
    assert(cnts[0] == cnts[1]);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j]) {
                continue;
            }
            if ((i + j) & 1) {
                continue;
            }
            for (int k = 0; k < 4; ++k) {
                int new_x = i + dx[k];
                int new_y = j + dy[k];
                if (new_x < 0 || new_x >= n || new_y < 0 || new_y >= m) {
                    continue;
                }
                if (a[new_x][new_y]) {
                    continue;
                }

                g[vertices_indices[i][j]].push_back(vertices_indices[new_x][new_y]);
//                cout << i << ' ' << j << ' ' << vertices_indices[i][j] << "\t  " << new_x << ' ' << new_y << ' ' << vertices_indices[new_x][new_y] << endl;
            }
        }
    }

    kuhn::k = cnts[0];
    kuhn::n = cnts[0];
    kuhn::mt.assign(kuhn::k, -1);
    for (int i = 0; i < kuhn::k; ++i) {
        kuhn::used.assign(kuhn::k, false);
        kuhn::try_kuhn(i);
    }

    int timer = 0;
    map<int, int> res;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j]) {
                continue;
            }
            if (((i + j) & 1) == 0) {
                continue;
            }
            int val = kuhn::mt[vertices_indices[i][j]];
            if (val != -1) {
                ++timer;
                res[kuhn::mt[vertices_indices[i][j]]] = timer;
//                cout << kuhn::mt[vertices_indices[i][j]] << endl;
                b[i][j] = timer;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j]) {
                continue;
            }
            if (((i + j) & 1) == 0) {
                assert(res.count(vertices_indices[i][j]));
//                cout << i << ' ' << j << res[vertices_indices[i][j]] << endl;
                b[i][j] = res[vertices_indices[i][j]];
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (!b[i][j]) {
                continue;
            }
            for (int k = 0; k < 4; ++k) {
                int new_x = i + dx[k];
                int new_y = j + dy[k];
                if (new_x < 0 || new_x >= n || new_y < 0 || new_y >= m) {
                    continue;
                }
                if (b[i][j] == b[new_x][new_y]) {
                    another[i][j] = make_pair(new_x, new_y);
                }
            }
        }
    }

//    for (int i = 0; i < n; ++i) {
//        for (int j = 0; j < m; ++j) {
//            cout << b[i][j];
//        }
//        cout << endl;
//    }

    long long ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (!b[i][j]) {
                continue;
            }
            for (auto [x, y] : frees) {
                used[x][y] = false;
            }
            auto [new_x, new_y] = another[i][j];

            cur_ans = 0;
            Dfs(new_x, new_y, n, m);
//            cout << i << ' ' << j << ' ' << new_x << ' ' << new_y << ' ' << cur_ans << endl;
//            return 0;
//            assert((free - 1 - cur_ans) % 2 == 0);
            ans += free - 1 - cur_ans;
        }
    }

    cout << min(1000000LL, ans / 2) << endl;
}
