#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <numeric>

#define ff first
#define ss second
using namespace std;
using pii = pair<int, int>;

void Solve() {
  int n;
  cin >> n;

  vector<int> p(n);
  for (int &x: p) {
    cin >> x;
    --x;
  }

  set<int> s;
  for (int i = 0; i < n; ++i) {
    int pos = p[i] - i;
    if (pos < 0) {
      pos += n;
    }
    s.insert(pos);
  }

  int shift = -1;
  for (int i = 1; i < n && shift == -1; ++i) {
    if (s.find(i) == s.end()) {
      shift = i;
    }
  }

  if (shift == -1) {
    cout << "Impossible\n";
    return;
  }

  std::vector <int> aux(n);
  std::iota(aux.begin(), aux.end(), 0);

  std::vector <int> answer(n);
  for (int i = 0; i < n; ++i) {
    answer[(i + shift >= n ? i + shift - n : i + shift)] = aux[i];
  }

  std::vector <int> new_p(n);
  for (int i = 0; i < n; ++i) {
    new_p[i] = p[answer[i]];
  }

  std::vector <int> inverse(n);
  for (int i = 0; i < n; ++i) {
    inverse[new_p[i]] = i;
  }

  cout << "Possible\n";
  for (int &x: answer) {
    cout << x + 1 << " ";
  }

  cout << "\n";

  for (int& x : inverse) {
    cout << x + 1 << " ";
  }

  cout << "\n";
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  cin >> tt;
  while (tt--) {
    Solve();
  }
  return 0;
}
