#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

#define ff first
#define ss second
using namespace std;
using pii = pair<int, int>;

void Solve() {
  int n;
  cin >> n;

  int total_size = 0;
  vector <vector <int>> towers(n);

  for (int i = 0; i < n; ++i) {
    int m;
    cin >> m;
    total_size += m;
    towers[i].resize(m);
    for (int& x : towers[i]) {
      cin >> x;
    }
  }

  vector <int> all_numbers;
  all_numbers.reserve(total_size);

  for (const auto& v : towers) {
    for (const int& x : v) {
      all_numbers.emplace_back(x);
    }
  }

  map <int, int> position;
  sort(all_numbers.begin(), all_numbers.end());

  for (int i = 0; i < total_size; ++i) {
    position[all_numbers[i]] = i;
  }

  int splits_count = 0;

  for (const std::vector <int>& tower : towers) {
    int previous = tower.front();
    for (auto it = tower.begin() + 1; it != tower.end(); ++it) {
      int current = *it;
      if (position[previous] + 1 != position[current]) {
        splits_count += 1;
      }
      previous = current;
    }
  }

  cout << splits_count << " " << n + splits_count - 1 << "\n";
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
//  cin >> tt;
  while (tt--) {
    Solve();
  }
  return 0;
}
