#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <numeric>
#include <queue>

#define ff first
#define ss second
using namespace std;
using pii = pair<int, int>;

void Solve() {
  int n, k;
  cin >> n >> k;

  if (k == n) {
    cout << "NO\n";
    return;
  }

  int edges = (n * (n - 1)) >> 1;

  std::set <std::pair <int, int>> nodes;
  for (int i = 0; i < n; ++i) {
    nodes.insert(std::make_pair(n - 1, i));
  }

  std::vector <int> degree(n, n - 1);
  vector <set <pair <int, int>>> adj(n);
  for (int i = 0; i < n; ++i) {
    for (int j = i + 1; j < n; ++j) {
      adj[i].insert({n - 1, j});
      adj[j].insert({n - 1, i});
    }
  }

  for (int i = 1; i < k; ++i) {
    auto [lowest_degree, node] = *nodes.begin();
    nodes.erase(*nodes.begin());

    --edges;
    auto [lowest_neighbour_degree, neighbour] = *adj[node].begin();
    adj[neighbour].erase(std::make_pair(degree[node], node));
    adj[node].erase(std::make_pair(degree[neighbour], neighbour));

    nodes.erase(std::make_pair(degree[neighbour], neighbour));
    --degree[node];
    --degree[neighbour];

    nodes.insert(std::make_pair(degree[node], node));
    nodes.insert(std::make_pair(degree[neighbour], neighbour));
  }

  cout << "YES\n" << edges << "\n";
  for (int i = 0; i < n; ++i) {
    for (const auto& [deg, to] : adj[i]) {
      if (to < i) {
        continue;
      }
      cout << i + 1 << " " << to + 1 << "\n";
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  //cin >> tt;
  while (tt--) {
    Solve();
  }
  return 0;
}
