#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <random>
#include <ctime>
#include <cstdlib>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;

void printv(vector<set<int> > &v) {
	for (int i = 0; i < v.size(); ++i) {
		cout << i << ": ";
		for (auto& el : v[i])
			cout << el << " ";
		cout << endl;
	}
}

vector<int> inverse(vector<int>& v) {
	vector<int> ans(v.size());

	for (int i = 0; i < v.size(); ++i) {
		ans[v[i] - 1] = i + 1;
	}
	return ans;
}

vector<int> find_q(vector<int>& p, vector<int>& a) {
	vector<int> ans(p.size());

	for (int i = 0; i < p.size(); ++i) {
		ans[p[i] - 1] = a[i];
	}
	return ans;
}

int main() 
{
	srand(time(NULL));

	int t;
	cin >> t;

	while (t--) {
		int n;
		cin >> n;
		vector<int> v(n);
		for (int i = 0; i < n; ++i) {
			cin >> v[i];
		}
		vector<int> inv = inverse(v);
		bool found = false;
		vector<int> p(n), q(n);
		for (int k = 0; k < 100; ++k) {
			for (int i = 0; i < n; ++i)
				p[i] = i + 1;
			random_shuffle(p.begin(), p.end());
			
			bool isValid = true;
			for (int i = 0; i < n; ++i) {
				if (p[i] == i + 1) {
					isValid = false;
					break;
				}
			}
			if (!isValid)
				continue;
			
			// q...
			q = find_q(p, inv);


			isValid = true;
			for (int i = 0; i < n; ++i) {
				if (q[i] == i + 1) {
					isValid = false;
					break;
				}
			}
			if (isValid) {
				found = true;
				break;
			}
		}

		if (found) {
			cout << "Possible" << endl;
			for (int i = 0; i < n; ++i)
				cout << q[i] << " ";
			cout << endl;
			for (int i = 0; i < n; ++i)
				cout << p[i] << " ";
			cout << endl;
		}
		else {
			cout << "Impossible" << endl;
		}
	}
}
/*
2
3 3 5 8
2 9 2
*/
