#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

std::vector<int> perm_reverse(const std::vector<int>& p) {
	std::vector<int> rev(p.size());
	for (int i = 1; i < p.size(); ++i) {
		rev[p[i]] = i;
	}
	return rev;
}

std::vector<int> perm_modify(const std::vector<int>& p) {
	std::vector<bool> used(p.size(), false);
	//std::vector<int> up;
	//up.reserve(p.size() - 1);
	std::vector<int> down;
	down.reserve(p.size() - 1);
	for (int i = 1; i < p.size(); ++i) {
		if (used[i]) continue;
		int parent = i;
		do {
			used[parent] = true;
			int child = p[parent];
			//up.push_back(parent);
			down.push_back(child);
			parent = child;
		} while (parent != i);
	}

	auto up = down;
	assert(down.size() >= 2);
	int f = down.back();
	down.pop_back();
	int ff = down.back();
	down.emplace_back();
	for (int i = down.size() - 1; i >= 2; --i) {
		down[i] = down[i - 2];
	}
	down[0] = ff;
	down[1] = f;

	std::vector<int> res(p.size());
	for (int i = 0; i < up.size(); ++i) {
		res[up[i]] = down[i];
	}
	return res;
}

std::vector<int> mult(const std::vector<int>& perm1, const std::vector<int>& perm2) {
	std::vector<int> res(perm1.size());
	for (int i = 1; i < perm1.size(); ++i) {
		res[i] = perm2[perm1[i]];
	}
	return res;
}

void solve_for_three(const std::vector<int>& perm) {
	for (int i1 = 1; i1 <= 3; ++i1) {
		for (int i2 = 1; i2 <= 3; ++i2) {
			if (i1 == i2) continue;
			for (int i3 = 1; i3 <= 3; ++i3) {
				if (i1 == i3 || i2 == i3) continue;
				for (int i4 = 1; i4 <= 3; ++i4) {
					for (int i5 = 1; i5 <= 3; ++i5) {
						if (i4 == i5) continue;
						for (int i6 = 1; i6 <= 3; ++i6) {
							if (i4 == i6 || i6 == i5) continue;
							std::vector<int> v1{ 0, i1, i2, i3 };
							std::vector<int> v2{ 0, i4, i5, i6 };
							bool flag = true;
							for (int i = 1; i <= 3; ++i) {
								if (i == v1[i]) flag = false;
								if (i == v2[i]) flag = false;
								if (perm[v1[v2[i]]] != i) flag = false;
							}
							if (!flag) continue;
							cout << "Possible\n";
							for (int i = 1; i <= 3; ++i) {
								cout << v1[i] << ' ';
							}
							cout << endl;
							for (int i = 1; i <= 3; ++i) {
								cout << v2[i] << ' ';
							}
							cout << endl;
							return;
						}
					}
				}
			}
		}
	}
	cout << "Impossible\n";
}

void solve() {
	int n;
	cin >> n;
	vector<int> p(n + 1);
	for (int i = 1; i <= n; ++i) {
		cin >> p[i];
	}
	if (n == 1) {
		cout << "Impossible\n";
		return;
	}
	if (n == 2 && p[1] == 2 && p[2] == 1) {
		cout << "Impossible\n";
		return;
	}
	if (n == 3) {
		solve_for_three(p);
		return;
	}
	std::cout << "Possible\n";
	if (n == 2) {
		std::cout << "2 1" << endl;
		std::cout << "2 1" << endl;
		return;
	}
	p = perm_reverse(p);
	auto modif = perm_modify(p);
	auto rev_modif = perm_reverse(modif);
	for (int i = 1; i <= n; ++i) {
		cout << rev_modif[i] << ' ';
	}
	cout << endl;
	auto mul = mult(p, modif);
	for (int i = 1; i <= n; ++i) {
		cout << mul[i] << ' ';
	}
	cout << endl;
}

int main() {
	int tests;
	cin >> tests;
	while (tests--) {
		solve();
	}
	return 0;
}

/**
10
10
2 3 1 5 6 7 8 4 10 9
*/