#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

std::vector<int> perm_reverse(const std::vector<int>& p) {
	std::vector<int> rev(p.size());
	for (int i = 1; i < p.size(); ++i) {
		rev[p[i]] = i;
	}
	return rev;
}

std::vector<int> perm_modify(const std::vector<int>& p) {
	std::vector<bool> used(p.size(), false);
	//std::vector<int> up;
	//up.reserve(p.size() - 1);
	std::vector<int> down;
	down.reserve(p.size() - 1);
	for (int i = 1; i < p.size(); ++i) {
		if (used[i]) continue;
		int parent = i;
		do {
			used[parent] = true;
			int child = p[parent];
			//up.push_back(parent);
			down.push_back(child);
			parent = child;
		} while (parent != i);
	}

	auto up = down;
	assert(down.size() >= 2);
	int f = down.back();
	down.pop_back();
	int ff = down.back();
	down.emplace_back();
	for (int i = down.size() - 1; i >= 2; --i) {
		down[i] = down[i - 2];
	}
	down[0] = ff;
	down[1] = f;

	std::vector<int> res(p.size());
	for (int i = 0; i < up.size(); ++i) {
		res[up[i]] = down[i];
	}
	return res;
}

std::vector<int> mult(const std::vector<int>& perm1, const std::vector<int>& perm2) {
	std::vector<int> res(perm1.size());
	for (int i = 1; i < perm1.size(); ++i) {
		res[i] = perm2[perm1[i]];
	}
	return res;
}

void answer(const std::vector<int>& perm1, const std::vector<int>& perm2, bool f = true) {
	cout << "Possible\n";
	for (int i = f; i < perm1.size(); ++i) {
		cout << perm1[i] << ' ';
		assert(perm1[i] != i + !f);
	}
	cout << endl;
	for (int i = f; i < perm2.size(); ++i) {
		cout << perm2[i] << ' ';
		assert(perm2[i] != i + !f);
	}
	cout << endl;
}

void solve_for(const std::vector<int>& perm, int x = 3) {
	std::vector<int> v1(x);
	std::vector<int> v2(x);
	for (int i = 0; i < x; ++i) {
		v1[i] = v2[i] = i + 1;
	}
	do {
		for (int i = 0; i < x; ++i) {
			v2[i] = i + 1;
		}
		do {
			bool flag = true;
			for (int i = 0; i < x; ++i) {
				if (i + 1 == v1[i]) flag = false;
				if (i + 1 == v2[i]) flag = false;
				if (perm[v1[v2[i] - 1]] != i + 1) flag = false;
			}
			if (!flag) continue;
			answer(v1, v2, false);
			return;
		} while (next_permutation(v2.begin(), v2.end()));
	} while (next_permutation(v1.begin(), v1.end()));
	cout << "Impossible\n";
}

void solve() {
	int n;
	cin >> n;
	vector<int> p(n + 1);
	for (int i = 1; i <= n; ++i) {
		cin >> p[i];
	}
	if (n <= 6) {
		solve_for(p, n);
		return;
	}
	p = perm_reverse(p);
	auto modif = perm_modify(p);
	auto rev_modif = perm_reverse(modif);
	auto mul = mult(p, modif);
	answer(rev_modif, mul);
}

int main() {
	int tests;
	cin >> tests;
	while (tests--) {
		solve();
	}
	return 0;
}

/**
10
10
2 3 1 5 6 7 8 4 10 9
*/