#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <map>
#include <random>
#include <vector>
using namespace std;


using ll = long long;
using ull = unsigned long long;

void shuf(vector<pair<int, int> >& v)
{
	std::random_device rd;
	std::mt19937 g(rd());

	std::shuffle(v.begin(), v.end(), g);
}


void solve_a()
{
	int n; cin >> n;
	vector<pair<int, int> > v(n);
	vector<pair<int, int> > w(n);
	for (size_t i = 0; i < n; i++)
	{
		v[i].first = i + 1;
		w[i].first = i + 1;
		cin >> v[i].second;
	}
	sort(v.begin(), v.end(), 
		[](pair<int, int> const& a, pair<int, int> const& b) {return a.second < b.second; });
	
	for (size_t i = 0; i < 100; i++)
	{
		shuf(w);
		bool fail = 0;

		for (size_t j = 0; j < n; j++)
		{
			if (w[j].first == j + 1 || w[j].first == v[j].first)
			{
				fail = 1;
				break;
			}
		}
		if (fail) continue;

		cout << "Possible\n";
		auto xx = w;
		
		for (size_t j = 0; j < n; j++)
		{
			w[j].second = v[j].first;
		}
		sort(w.begin(), w.end()
			);
		for (size_t j = 0; j < n; j++)
		{
			cout << w[j].second << ' ';
		}
		cout << '\n';
		for (size_t j = 0; j < n; j++)
		{
			cout << xx[j].first << ' ';
		}
		cout << '\n';
		return;
	}
	
	cout << "Impossible\n";
};

void solve() {
	int n, k;
	cin >> n >> k;
	if (k + 1 > n) {
		cout << "NO" << endl;
		return;
	}
	vector<pair<int, int>> edges;
	for (int i = 1; i <= k + 1; ++i) {
		int count = i;
		for (int j = k + 1; j > i; --j) {
			edges.push_back(make_pair(i, j));
			--count;
			if (count <= 0) {
				break;
			}
		}
	}

	int left = n - k - 1;
	for (int i = n - left + 1; i <= n; ++i) {
		for (int j = 1; j < i; ++j) {
			edges.push_back(make_pair(i, j));
		}
	}
	
	cout << "YES" << endl;
	cout << edges.size() << endl;
	for (auto& x : edges) {
		cout << x.first << ' ' << x.second << endl;
	}
}

int main(int, char **) 
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _LOCAL_
	freopen("in.txt", "r", stdin);
#endif
	constexpr int mult = 0;
	int x = 1;
	if (mult) cin >> x;
	while (x --> 0) solve();
	return 0;
}