#pragma optimize("Ofast")

#include <bits/stdc++.h>

#define fi first
#define se second

const int N = 1002;

using namespace std;

int n;
int m;
int A;
int a[N * N];
vector<int> v[N * N];
int c[N * N];
bool used[N];
queue<int> q;
vector<pair<vector<int>, vector<int>>> all;
int f[N * N];

int adj(int x)
{
    if (!a[x]) return 0;
    int res = 0;
    for (int y : v[x]) {
        res += a[y];
    }
    return res;
}

void del(int x)
{
    for (int y : v[x]) {
        if (!used[y] && a[y]) {
            f[y] -= 1;
            if (f[y] == 1) {
                q.push(y);
            }
        }
    }
}

int works(int X, int Y, const vector<int> &A, const vector<int>& B)
{
    a[X] = a[Y] = 0;
    for (int x : A) {
        used[x] = 0;
        f[x] = adj(x);
    }
    for (int x : B) {
        f[x] = adj(x);
        used[x] = 0;
    }

    int good = 1;

    for (int x : A) {
        int bal = 0;
        if (!used[x] && a[x]) {
            q.push(x);
            used[x] = true;
            while (!q.empty()) {
                int x = q.front();
                q.pop();
                bal += (c[x] == 0 ? 1 : -1);
                for (int y : v[x]) {
                    if (!used[y] && a[y]) {
                        q.push(y);
                        used[y] = true;
                    }
                }
            }
            if (bal) {
                good = 0;
                break;
            }
        }
    }

    if (!good) {
        a[X] = a[Y] = 1;
        return 0;
    }

    for (int x : B) {
        int bal = 0;
        if (!used[x] && a[x]) {
            q.push(x);
            used[x] = true;
            while (!q.empty()) {
                int x = q.front();
                q.pop();
                bal += (c[x] == 0 ? 1 : -1);
                for (int y : v[x]) {
                    if (!used[y] && a[y]) {
                        q.push(y);
                        used[y] = true;
                    }
                }
            }
            if (bal) {
                good = 0;
                break;
            }
        }
    }

    for (int x : A) {
        if (f[x] == 1) {
            q.push(x);
        }
        used[x] = 0;
    }
    for (int x : B) {
        if (f[x] == 1) {
            q.push(x);
        }
        used[x] = 0;
    }
    while (!q.empty()) {
        int x = q.front();
        q.pop();
        if (used[x]) {
            continue;
        } else if (f[x] == 0) {
            good = 0;
            break;
        }
        used[x] = true;
        int y = -1;
        for (int z : v[x]) {
            if (!used[z] && a[z]) {
                y = z;
            }
        }
        assert(y != -1);
        used[y] = true;
        del(x);
        del(y);
    }
    while (!q.empty()) {
        q.pop();
    }

    a[X] = a[Y] = 1;
    return good;
}

int main() {
    #ifdef zxc
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    ios_base::sync_with_stdio(0);

    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char x;
            cin >> x;
            a[i * m + j] = (x == '.');
            c[i * m + j] = (i + j) % 2;
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (!a[i * m + j]) {
                continue;
            }
            if (i + 1 < n && a[(i + 1) * m + j]) {
                v[i * m + j].push_back((i + 1) * m + j);
                v[(i + 1) * m + j].push_back(i * m + j);
            }
            if (j + 1 < m && a[i * m + j]) {
                v[i * m + j].push_back(i * m + j + 1);
                v[i * m + j + 1].push_back(i * m + j);
            }
        }
    }

    A = n * m;
    long long tot = 0;
    long long best_case = 0;
    vector<vector<int>> alones;
    vector<vector<int>> doubles;
    int super_bad = 0;
    for (int i = 0; i < A; i++) {
        if (!a[i] || used[i]) {
            continue;
        }
        q.push(i);
        used[i] = true;
        all.push_back({});
        while (!q.empty()) {
            int x = q.front();
            q.pop();
            if (c[x]) {
                all.back().fi.push_back(x);
            } else {
                all.back().se.push_back(x);
            }
            for (int y: v[x]) {
                if (!used[y] && a[y]) {
                    q.push(y);
                    used[y] = true;
                }
            }
        }

        long long a = all.back().fi.size();
        long long b = all.back().se.size();

        if (a > b) {
            swap(a, b);
            swap(all.back().fi, all.back().se);
        }

        tot += a + b;
        if (a == b) {
            best_case += a * b;
        } else if (a + 1 == b) {
            alones.push_back(all.back().se);
        } else if (a + 2 == b) {
            doubles.push_back(all.back().se);
            best_case += b * (b - 1) / 2;
        } else {
            super_bad = 1;
        }
    }

    int g = alones.size() + doubles.size() * 2;
    if (super_bad || (g && g != 2)) {
        cout << tot * (tot - 1) / 2 << "\n";
        return 0;
    }

    long long lim = 1e6;

    if (!alones.empty()) {
        best_case += 1ll * alones[0].size() * alones[1].size();
    }
    if (tot * (tot - 1) / 2 - best_case >= lim) {
        cout << lim << "\n";
        return 0;
    }

    for (int i = 0; i < A; i++) {
        used[i] = 0;
    }

    int real_case = 0;
    if (!alones.empty()) {
        for (int x : alones[0]) {
            for (int y : alones[1]) {
                real_case += works(x, y, alones[0], alones[1]);
            }
        }
    } else if (!doubles.empty()) {
        for (int x : doubles[0]) {
            for (int y : doubles[0]) {
                if (x <= y) {
                    continue;
                }
                real_case += works(x, y, doubles[0], doubles[0]);
            }
        }
    } else {
        for (auto p : all) {
            for (int x : p.fi) {
                for (int y : p.se) {
                    real_case += works(x, y, p.fi, p.se);
                }
            }
        }
    }

    cout << min(lim, tot * (tot - 1) / 2 - real_case) << "\n";
}
