#include <bits/stdc++.h>

#define f first
#define s second

using namespace std;
using li = long long;
using ld = long double;
using pii = pair<int, int>;

const int N = 1013;

string a[N];
mt19937 rnd(454);
int n, m;

int di[] = {-1, 0, 1, 0};
int dj[] = {0, -1, 0, 1};

bool isin(int i, int j) {
    return (0 <= i && i < n && 0 <= j && j < m);
}

int get(int i, int j) {
    return i * m + j;
}

vector<int> g[N * N];
int used[N * N];
int T = 0;
bool is[N * N];

int used_mt[N * N];
int TMT = 0;
int mt[N * N];

bool kuhn(int v) {
//    cout << "kuhn " << v << endl;
    if(is[v])
        return true;
    if(used[v] == T)
        return false;
    used[v] = T;

    for(int u : g[v]) {
        if(!is[u] && used_mt[u] < TMT) {
            used_mt[u] = TMT;
            mt[u] = v;
            return true;
        }
    }

    for(int u : g[v]) {
        if(!is[u] && kuhn(mt[u])) {
            mt[u] = v;
            return true;
        }
    }
}

void dfs(int v) {
    used[v] = T;

    for(int u : g[v]) {
        int w = mt[u];
        if(used[w] < T)
            dfs(w);
    }

}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);


    cin >> n >> m;

    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }

    int w = 0, b = 0;
    vector<int> vb, vw;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            if(a[i][j] == '.') {
                if((i + j) % 2 == 0) {
                    b++;
                    int v = get(i, j);
                    vb.push_back(v);
                    for(int k = 0; k < 4; k++) {
                        int ni = i + di[k], nj = j + dj[k];
                        if(!isin(ni, nj) || a[ni][nj] == '#')
                            continue;

//                        cout << "add edge " << i << ' ' << j << ' ' << ni << ' ' << nj << ' ' << v << ' ' << get(ni, nj) << endl;

                        g[v].push_back(get(ni, nj));
                    }
                } else {
                    w++;
                    vw.push_back(get(i, j));
//                    cout << get(i, j) << endl;
                }
            }
        }
    }

//    for(auto x : vw)
//        cout << x << endl;

    li ans = w * 1ll * (w - 1) / 2 + b * 1ll * (b - 1) / 2;

    if(ans >= 1000000) {
        cout << 1000000 << endl;
        return 0;
    }

//    for(int i = 0; i < n; i++) {
//        swap(vb[i], vb[rnd() % (i + 1)]);
//        swap(vw[i], vw[rnd() % (i + 1)]);
//    }

//    cout << w << ' ' << b << ' ' << ans << endl;
//
//    for(int v : vb) {
//        cout << "v " << v << " : ";
//        for(int u : g[v])
//            cout << u << ' ';
//        cout << endl;
//    }

//    for(int v : vb) {
//        for(int u : vw) {
////            cout << v << ' ' << u  << endl;
////            if(v != 4 || u != 6)
////                continue;
//            is[v] = is[u] = true;

    TMT++;
    bool res = false;
    for(int i : vb) {
        if(!kuhn(i)) {
            T++;
            if(!kuhn(i)) {
                res = true;
                break;
            }

        }

    }


    for(int v : vw) {
//        cout << v << endl;
        T++;
        dfs(mt[v]);
//        cout << v << ' ' << mt[v] << endl;
        for(int u : vb)
            ans += (used[u] < T);
    }

//            is[v] = false;
//            is[u] = false;
//
//            if(res) {
//                cout << v << ' ' << u << endl;
//            }
//
//            ans += res;
//            if(ans >= 1000000) {
//                cout << 1000000 << endl;
//                return 0;
//            }
//        }
//    }

    cout << min(ans, 1000000ll) << endl;

//    int t = 1;
//    cin >> t;
//
//    while(t--)
//        solve();
}
