#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <bitset>
#include <array>

using namespace std;

int n;
vector<int> av(100'001), av2(100'001);
vector<int> ans(100'001);
vector<int> mt(200'001);
vector<bool> used(200'001);

bool try_kuhn(int v) {
	if (used[v]) {
		return false;
	}
	used[v] = true;
	if (v < n) {
		for (int i = 0; i < n; ++i) {
			if (i != v && i != av[v]) {
				if (mt[i + n] == -1 || try_kuhn(mt[i + n])) {
					mt[i + n] = v;
					return true;
				}
			}
		}
	}
	else {
		for (int i = 0; i < n; ++i) {
			if (i != v - n && i != av2[v - n]) {
				if (mt[i] == -1 || try_kuhn(mt[i])) {
					mt[i] = v;
					return true;
				}
			}
		}
	}
	return false;
}

int main()
{
	int t;
	cin >> t;
	for (int i = 0; i < t; ++i) {
		cin >> n;
		av.resize(n);
		for (int j = 0; j < n; ++j) {
			cin >> av[j];
			--av[j];
			av2[av[j]] = j;
		}
		/*for (int v = 0; v < n; ++v) {
			cout << v << ":";
			for (int m = 0; m < n; ++m) {
				if (m != v && m != av[v]) {
					cout << " " << m + n;
				}
			}
			cout << endl;
		}
		for (int v = 0; v < n; ++v) {
			cout << v + n << ":";
			for (int m = 0; m < n; ++m) {
				if (m != v && m != av2[v]) {
					cout << " " << m;
				}
			}
			cout << endl;
		}*/
		mt.assign(2 * n, -1);
		for (int v = 0; v < 2 * n; ++v) {
			used.assign(2 * n, false);
			try_kuhn(v);
		}
		bool fail = false;
		for (int j = 0; j < n; ++j) {
			if (mt[n + j] == -1) {
				fail = true;
				break;
			}
			else {
				ans[av[mt[n + j]]] = j;
			}
		}
		if (fail) {
			cout << "Impossible" << endl;
		}
		else {
			cout << "Possible" << endl;
			for (int j = 0; j < n; ++j) {
				cout << mt[n + j] + 1 << " ";
			}
			cout << endl;
			for (int j = 0; j < n; ++j) {
				cout << ans[j] + 1 << " ";
			}
			cout << endl;
		}
	}
}