#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <bitset>
#include <array>

using namespace std;

int n;
vector<int> av(100'001), av2(100'001);
vector<int> ans(100'001);
vector<int> mt(200'001);
vector<bool> used(200'001);

bool try_kuhn(int v) {
	used[v] = true;
	if (v < n) {
		int t = av[v];
		for (int i = 0; i < n; ++i) {
			if (i != v && i != t) {
				if (mt[i + n] == -1 || (!used[mt[i + n]] && try_kuhn(mt[i + n]))) {
					mt[i + n] = v;
					return true;
				}
			}
		}
	}
	else {
		int t = av2[v - n];
		for (int i = 0; i < n; ++i) {
			if (i != v - n && i != t) {
				if (mt[i] == -1 || (!used[mt[i]] && try_kuhn(mt[i]))) {
					mt[i] = v;
					return true;
				}
			}
		}
	}
	used[v] = false;
	return false;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t;
	cin >> t;
	for (int i = 0; i < t; ++i) {
		cin >> n;
		av.resize(n);
		av2.resize(n);
		for (int j = 0; j < n; ++j) {
			cin >> av[j];
			--av[j];
			av2[av[j]] = j;
		}
		mt.assign(2 * n, -1);
		used.assign(2 * n, false);
		for (int v = 0; v < 2 * n; ++v) {
			if (!used[v]) {
				try_kuhn(v);
			}
		}
		bool fail = false;
		for (int j = 0; j < n; ++j) {
			if (mt[n + j] == -1) {
				fail = true;
				break;
			}
			else {
				ans[av[mt[n + j]]] = j;
			}
		}
		if (fail) {
			cout << "Impossible" << endl;
		}
		else {
			cout << "Possible" << endl;
			for (int j = 0; j < n; ++j) {
				cout << mt[n + j] + 1 << " ";
			}
			cout << endl;
			for (int j = 0; j < n; ++j) {
				cout << ans[j] + 1 << " ";
			}
			cout << endl;
		}
	}
}