#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <random>
#include <chrono>

using namespace std;
mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

pair<vector<int>, vector<int>> iter(vector<int>& a) {
	int n = a.size();

	vector<int> p1(n);
	for (int i = 0; i < n; i++) {
		p1[i] = i;
	}

	shuffle(p1.begin(), p1.end(), rng);

	for (int i = 0; i < n; i++) {
		if (i == p1[i]) {
			return { {}, {} };
		}
	}

	vector<int> a1(n);

	for (int i = 0; i < n; i++) {
		a1[i] = a[p1[i]];
	}

	vector<int> p2(n);

	for (int i = 0; i < n; i++) {
		p2[a1[i]] = i;
	}

	for (int i = 0; i < n; i++) {
		if (i == p2[i]) {
			return { {}, {} };
		}
	}

	return { p1, p2 };

}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int iter_cnt = 500;

	int test_cnt;
	cin >> test_cnt;

	for (int test = 0; test < test_cnt; test++) {
		int n;
		cin >> n;
		vector<int> a(n);
		for (int i = 0; i < n; i++) {
			cin >> a[i];
			a[i]--;
		}

		bool ok = 0;
		for (int i = 0; i < iter_cnt; i++) {
			auto res = iter(a);
			if (res.first.empty()) {
				continue;
			}

			//cout << "--deb\n";
			//for (int j = 0; j < n; j++) {
			//	cout << a[res.first[res.second[j]]] << ' ';
			//}
			//cout << '\n';
			//cout << "--\n";

			cout << "Possible\n";
			
			for (int j = 0; j < n; j++) {
				cout << res.first[j] + 1 << ' ';
			}
			cout << '\n';
			for (int j = 0; j < n; j++) {
				cout << res.second[j] + 1 << ' ';
			}
			cout << '\n';
			ok = 1;
			break;
		}

		if (!ok) {
			cout << "Impossible\n";
		}

	}

	return 0;
}