#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <random>
#include <chrono>
#include <set>

typedef unsigned long long ull;

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, k;
	cin >> n >> k;

	if (k == 1) {
		cout << "YES\n";
		if (n == 1) {
			cout << 0;
			return 0;
		}
		if (n == 2) {
			cout << 1 << '\n';
			cout << 1 << ' ' << 2 << '\n';
			return 0;
		}
		cout << n << '\n';
		for (int i = 0; i < n; i++) {
			int f = i + 1;
			int t = (i + 1) % n + 1;
			cout << f << ' ' << t << '\n';
		}
		return 0;
	}

	if (n == 2) {
		cout << "NO\n";
		return 0;
	}

	vector<pair<int, int>> edges;
	vector<int> in(n);

	multiset<int> st;

	for (int i = 0; i < n - 1; i++) {
		edges.emplace_back(i, i + 1);
		in[i]++;
		in[i + 1]++;
	}

	for (int i = 0; i < n; i++) {
		st.insert(in[i]);
	}

	for (int i = 1; i < n; i += 2) {
		int cnt = 0;
		for (int j = i + 2; j < n; j++) {
			cnt++;
		}

		multiset<int> st2 = st;

		for (int j = i + 2; j < n; j++) {
			st2.erase(st2.find(in[j]));
			st2.insert(in[j] + 1);
		}

		st2.erase(st2.find(in[i]));
		st2.insert(in[i] + cnt);

		if (set<int>(st2.begin(), st2.end()).size() > set<int>(st.begin(), st.end()).size() && set<int>(st2.begin(), st2.end()).size() <= k) {
			for (int j = i + 2; j < n; j++) {
				edges.emplace_back(i, j);
				in[i]++;
				in[j]++;
			}
			st = st2;
		}
		else {
			break;
		}
	}

	if (k != set<int>(st.begin(), st.end()).size()) {
		cout << "NO\n";
		return 0;
	}

	cout << "YES\n";
	cout << edges.size() << '\n';
	for (auto e : edges) {
		cout << e.first + 1 << ' ' << e.second + 1 << '\n';
	}

	return 0;
}