#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <random>
#include <chrono>
#include <set>

typedef unsigned long long ull;

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, k;
	cin >> n >> k;

	if (k == 1) {
		cout << "YES\n";
		if (n == 1) {
			cout << 0;
			return 0;
		}
		if (n == 2) {
			cout << 1 << '\n';
			cout << 1 << ' ' << 2 << '\n';
			return 0;
		}
		cout << n << '\n';
		for (int i = 0; i < n; i++) {
			int f = i + 1;
			int t = (i + 1) % n + 1;
			cout << f << ' ' << t << '\n';
		}
		return 0;
	}

	if (n == 2) {
		cout << "NO\n";
		return 0;
	}

	if (n == k) {
		cout << "NO\n";
		return 0;
	}

	set<pair<int, int>> edges;
	vector<int> in(n);

	multiset<int> st;

	for (int i = 0; i < n - 1; i++) {
		edges.insert({ i, i + 1 });
		in[i]++;
		in[i + 1]++;
	}

	for (int i = 0; i < n; i++) {
		st.insert(in[i]);
	}

	for (int i = 1; i < n; i += 2) {
		int cnt = 0;
		for (int j = i + 2; j < n; j++) {
			cnt++;
		}

		multiset<int> st2 = st;

		for (int j = i + 2; j < n; j++) {
			st2.erase(st2.find(in[j]));
			st2.insert(in[j] + 1);
		}

		st2.erase(st2.find(in[i]));
		st2.insert(in[i] + cnt);

		if (set<int>(st2.begin(), st2.end()).size() > set<int>(st.begin(), st.end()).size()) {
			for (int j = i + 2; j < n; j++) {
				edges.insert({ i, j });
				in[i]++;
				in[j]++;
			}
			st = st2;
		}
		else {
			break;
		}
	}

	int kk = set<int>(st.begin(), st.end()).size();

	while (kk > k) {
		set<pair<int, int>> r;
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				if (edges.count({ i, j }) == 0 && edges.count({ j, i }) == 0) {
					r.insert({ i, j });
				}
			}
		}

		map<int, int> mp;
		for (int x : st) {
			mp[x]++;
		}

		while (kk > k) {
			auto e = *r.begin();
			r.erase(r.begin());

			mp[in[e.first]]--;
			mp[in[e.second]]--;

			edges.insert(e);
			in[e.first]++;
			in[e.second]++;

			mp[in[e.first]]++;
			mp[in[e.second]]++;

			if (mp[in[e.first] - 1] == 0) {
				mp.erase(in[e.first] - 1);
			}
			if (mp[in[e.second] - 1] == 0) {
				mp.erase(in[e.second] - 1);
			}

			kk = mp.size();
		}
	}

	cout << "YES\n";
	cout << edges.size() << '\n';
	for (auto e : edges) {
		cout << e.first + 1 << ' ' << e.second + 1 << '\n';
	}

	return 0;
}