#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <iomanip>
#include <cstdlib>

using namespace std;

using ll = long long;

int main()
{
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

#endif

	int n, k;
	cin >> n >> k;

	vector<vector<int>> g(n, vector<int>(n, 1));
	for (int i = 0; i < n; i++)
	{
		g[i][i] = 0;
	}

	int steps = 1;
	int last_i = n - 1;
	while (steps < k && last_i > n / 2)
	{
		for (int i = 0, j = last_i; i < n && j < n; i++, j++)
		{
			g[i][j] = 0;
			g[j][i] = 0;
		}
		steps++;
		last_i--;
	}

	set<int> vals;
	for (int i = 0; i < n; i++)
	{
		int c = 0;
		for (int j = 0; j < n; j++)
		{
			c += g[i][j];
		}
		vals.insert(c);
	}

	if (n % 2 == 0 && vals.size() < k)
	{
		g[n - 1][n / 2] = 0;
		g[n / 2][n - 1] = 0;
	}

	//for (int i = 0; i < n; i++)
	//{
	//	for (int j = 0; j < n; j++)
	//	{
	//		cout << g[i][j] << " ";
	//	}
	//	cout << "\n";
	//}

	vals.clear();
	for (int i = 0; i < n; i++)
	{
		int c = 0;
		for (int j = 0; j < n; j++)
		{
			c += g[i][j];
		}
		//cout << c << " ";
		vals.insert(c);
	}
	//cout << "\n\n";

	if (vals.size() < k)
	{
		cout << "NO";
		return 0;
	}

	int cnt = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < i; j++)
		{
			cnt += g[i][j];
		}
	}
	cout << "YES\n";
	cout << cnt << "\n";
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < i; j++)
		{
			if (g[i][j]) {
				cout << i + 1 << " " << j + 1 << "\n";
			}
		}
	}

	return 0;
}