#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <algorithm>
#include <cmath>
using namespace std;
typedef long long ll;

vector<vector<int>> cycles;
vector<int> good_cycle;

void dfs(vector<char>& used, vector<int>& pr, vector<int>& son, int s)
{
	used[s] = 1;
	vector<int> cycle;
	cycle.push_back(s);
	
	while (!used[son[s]])
	{
		s = son[s];
		used[s] = 1;
		cycle.push_back(s);
	}

	if (cycle.size() > 2 && good_cycle.empty())
		good_cycle = cycle;
	cycles.push_back(cycle);
}

int main()
{
	int t;
	cin >> t;

	while (t--)
	{
		cycles.clear();
		good_cycle.clear();
		int n;
		cin >> n;
		vector <int> a(n + 1);
		
		for (int i = 1; i <= n; i++)
			cin >> a[i];

		if (n == 1)
		{
			cout << "Impossible\n";
			continue;
		}

		if (n == 2)
		{
			if (a[1] == 2)
				cout << "Impossible\n";
			else
			{
				cout << "Possible\n";
				cout << "2 1\n2 1\n";
			}
			continue;
		}

		vector <int> b(n + 1);
		for (int i = 1; i <= n; i++)
			b[a[i]] = i;

		vector <int> pr_anti(n + 1);
		vector <int> son_anti(n + 1);

		for (int i = 1; i <= n; i++)
		{
			pr_anti[i] = b[i];
			son_anti[b[i]] = i;
		}

		vector <char> used(n + 1);
		for (int i = 1; i <= n; i++)
		{
			if (!used[i])
				dfs(used, pr_anti, son_anti, i);
		}

		vector <int> pr(n + 1);
		vector <int> son(n + 1);
		for (int i = 1; i <= n; i++)
		{
			pr[i] = i;
			son[i] = i;
		}
		
		if (good_cycle.empty())
		{
			if (cycles.size() > 2)
				good_cycle = { cycles[0][0], cycles[1][0], cycles[2][0] };
			else
			{
				if (n >= 4)
				{
					good_cycle = { cycles[0][0], cycles[1][0], cycles[0][1], cycles[1][1] };
				}
				else if (n == 3)
				{
					cout << "Impossible\n";
					continue;
				}
			}
		}

		if (!good_cycle.empty())
		{
			vector <char> ingood(n + 1);
			int m = good_cycle.size();
			for (int i = 0; i < m; i++)
			{
				ingood[good_cycle[i]] = 1;
				int num = good_cycle[i];
				int next = good_cycle[(i + 1) % m];

				pr[next] = num;
				son[num] = next;
			}

			for (int i = 1; i <= n; i++)
			{
				if (ingood[i]) continue;
				int v0 = good_cycle[0];
				int v = v0;

				while (true)
				{
					int next = son[v];
					if (pr_anti[v] == i || pr_anti[i] == next) continue;
					son[v] = i;
					pr[i] = v;
					son[i] = next;
					pr[next] = i;
				}
			}

			vector <int> p(n + 1);
			vector <int> q(n + 1);
			for (int i = 1; i <= n; i++)
				q[i] = son[i];

			for (int i = 1; i <= n; i++)
				p[q[i]] = b[i];

			cout << "Possible\n";
			for (int i = 1; i <= n; i++)
				cout << p[i] << ' ';
			cout << '\n';
			for (int i = 1; i <= n; i++)
				cout << q[i] << ' ';
			cout << '\n';
		}
	}

	
}
