#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <algorithm>
#include <cmath>
using namespace std;
typedef long long ll;

vector<vector<int>> cycles;
vector<int> good_cycle;
int vertex = -1;
vector <int> for_cycle;

void dfs(vector<char>& used, vector<int>& pr_anti, vector<int>& son_anti, vector<int> &pr, vector<int> &son, vector<char> &ingood,  int s)
{
	used[s] = 1;
	
	int sz = 1;

	while (!used[son_anti[s]])
	{
		son[s] = son_anti[s];
		ingood[s] = 1;
		pr[son_anti[s]] = son[s];
		s = son_anti[s];
		
		used[s] = 1;
		sz++;
	}

	son[s] = son_anti[s];
	ingood[s] = 1;
	pr[son_anti[s]] = son[s];

	if (sz > 2 && vertex == -1)
		vertex = s;
	if (for_cycle.size() < 3)
		for_cycle.push_back(s);
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;

	while (t--)
	{
		vertex = -1;
		for_cycle.clear();

		int n;
		cin >> n;
		vector <int> a(n + 1);

		for (int i = 1; i <= n; i++)
			cin >> a[i];

		if (n == 1)
		{
			cout << "Impossible\n";
			continue;
		}

		if (n == 2)
		{
			if (a[1] == 2)
				cout << "Impossible\n";
			else
			{
				cout << "Possible\n";
				cout << "2 1\n2 1\n";
			}
			continue;
		}

		vector <int> b(n + 1);
		for (int i = 1; i <= n; i++)
			b[a[i]] = i;

		vector <int> pr_anti(n + 1);
		vector <int> son_anti(n + 1);

		for (int i = 1; i <= n; i++)
		{
			pr_anti[i] = b[i];
			son_anti[b[i]] = i;
		}

		vector <int> pr(n + 1);
		vector <int> son(n + 1);
		for (int i = 1; i <= n; i++)
		{
			pr[i] = i;
			son[i] = i;
		}

		vector <char> ingood(n + 1);
		vector <char> used(n + 1);
		for (int i = 1; i <= n; i++)
		{
			if (!used[i])
				dfs(used, pr_anti, son_anti, pr, son, ingood, i);
		}

		
		

		
		if (vertex == -1)
		{
			if (for_cycle.size() > 2)
			{
				for (int j = 0; j < for_cycle.size(); j++)
				{
					son[for_cycle[j]] = for_cycle[(j + 1) % 3];
					pr[for_cycle[(j + 1) % 3]] = for_cycle[j];
					ingood[for_cycle[j]] = 1;
				}
				vertex = for_cycle[0];
			}
			else
			{
				if (n >= 4)
				{

					//good_cycle = { cycles[0][0], cycles[1][0], cycles[0][1], cycles[1][1] };
					if (son_anti[1] == 2)
					{
						son[1] = 3;
						pr[3] = 1;
						son[3] = 2;
						pr[2] = 3;
						son[2] = 4;
						pr[4] = 2;
						son[4] = 1;
						pr[1] = 4;
					}
					else if (son_anti[1] == 3)
					{
						son[1] = 1;
						pr[2] = 1;
						son[2] = 3;
						pr[3] = 2;
						son[3] = 4;
						pr[4] = 3;
						son[4] = 1;
						pr[1] = 4;
					}
					else
					{
						son[1] = 3;
						pr[3] = 1;
						son[3] = 4;
						pr[4] = 3;
						son[4] = 2;
						pr[2] = 4;
						son[2] = 1;
						pr[1] = 2;
					}
					vertex = 1;

					for (int j = 1; j <= 4; j++)
						ingood[j] = 1;
				}
				else if (n == 3)
				{
					cout << "Impossible\n";
					continue;
				}
			}
		}

		if (vertex != -1)
		{
			for (int i = 1; i <= n; i++)
			{
				if (ingood[i]) continue;
				int v0 = vertex;
				int v = v0;

				while (true)
				{
					int next = son[v];
					if (pr_anti[v] == i || pr_anti[i] == next) continue;
					son[v] = i;
					pr[i] = v;
					son[i] = next;
					pr[next] = i;
					break;
				}
			}

			vector <int> p(n + 1);
			vector <int> q(n + 1);
			for (int i = 1; i <= n; i++)
				q[i] = son[i];

			for (int i = 1; i <= n; i++)
				p[q[i]] = b[i];

			cout << "Possible\n";
			for (int i = 1; i <= n; i++)
				cout << p[i] << ' ';
			cout << '\n';
			for (int i = 1; i <= n; i++)
				cout << q[i] << ' ';
			cout << '\n';
		}
	}


}
