#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

pair<vector<int>, vector<int> > impossible = make_pair(vector<int>(),vector<int>());

bool check(vector<int> &v, vector<int> &q) {
    for (int i = 0; i < v.size(); i++)
        if (q[i] == i || q[i] == v[i])
            return false;
    return true;
}

pair<vector<int>, vector<int> > solve(vector<int> &a) {
    int n = a.size();
    vector<int> v(n);
    for (int i = 0; i < n; i++)
        v[a[i]] = i;
    vector<int> q(n);
    copy(a.begin(), a.end(), q.begin());
    sort(q.begin(), q.end());
    do {
        if (check(v,q)) {
            vector<int> p(n);
            for (int i = 0; i < n; i++)
                p[q[i]] = v[i];
            return make_pair(p,q);
        }
    } while (next_permutation(q.begin(), q.end()));
    return impossible;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t; cin >> t;
    while (t--) {
        int n; cin >> n;
        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
            a[i]--;
        }
        auto ans = solve(a);
        if (ans.first.empty())
            cout << "Impossible\n";
        else {
            cout << "Possible\n";
            for (int i : ans.first)
                cout << i+1 << ' ';
            cout << '\n';
            for (int i : ans.second)
                cout << i+1 << ' ';
            cout << '\n';
        }
    }
    return 0;
}

//1 4 1 3 4 2
