#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

int main() {
    std::ios_base::sync_with_stdio(false);

    int n;
    std::cin >> n;

    std::vector<std::vector<int>> values(n);
    std::vector<int> order;
    for (int i = 0; i < n; ++i) {
        int k;
        std::cin >> k;
        values[i].resize(k);
        for (int& x : values[i]) {
            std::cin >> x;
            order.push_back(x);
        }
    }

    std::sort(order.begin(), order.end());
    std::map<int, int> index;

    for (int i = 0; i < order.size(); ++i) {
        index[order[i]] = i;
    }

    int splits = 0;
    for (int i = 0; i < n; ++i) {
        int prev_number = -100;
        for (int x : values[i]) {
            x = index[x];
            if (prev_number >= 0 && x != prev_number + 1) {
                splits++;
            }
            prev_number = x;
        }
    }

    std::cout << splits << " " << n + splits - 1;

    return 0;
}
