#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("sse4.2")

#include <bits/stdc++.h>
using namespace std;

void initIO() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

using graph = vector<vector<int>>;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back

const int mod = 1000000007;
const ld eps = 1e-9;
const ll inf = 3000000000000000007ll;

template<class T> inline int sz(const T &x) { return x.size(); }

template<class T> void read(T &x) {
    cin >> x;
}
template<class T> void print(const T &x) {
    cout << x;
}
void println() { cout << '\n'; }

template<class T, class ...U> void read(T &x, U&... u) {
    read(x);
    read(u...);
}

template<class T, class ...U> void print(const T &x, const U&... u) {
    print(x);
    print(u...);
}

template<class T, class ...U> void println(const T &x, const U&... u) {
    print(x);
    println(u...);
}

template<class T, class U> inline bool chmin(T &x, const U &y) { return y < x ? x = y, 1 : 0; }
template<class T, class U> inline bool chmax(T &x, const U &y) { return y < x ? x = y, 1 : 0; }
template<class T> inline void sort(T &x) { sort(all(x)); }
template<class T> inline void reverse(T &x) { reverse(all(x)); }

#ifdef DEBUG
    template<class T> string pdbg(const T&x) {
        return to_string(x);
    }
    template<class T> string dbgout(const T &x) {
        return pdbg(x);
    }
    template<class T, class ...U> string dbgout(const T &x, const U&... u) {
        return pdbg(x) + ", " + pdbg(u...);
    }
    #define dbg(...) print("[", #__VA_ARGS__, "] = ", dbgout(__VA_ARGS__))
#else

#endif

int n;
vector<int> a;

bool check_ii(vector<int> p) {
    for (int i = 0; i < n; i++)
        if (p[i] == i)
            return false;
    return true;
}
bool check_nice(vector<int> p, vector<int> q) {
    vector<int> res(n);
    for (int i = 0; i < n; i++)
        res[i] = a[p[q[i]]];

    for (int i = 0; i < n; i++)
        if (res[i] != i)
            return false;
    return true;
}

void print_p(vector<int> p) {
    for (auto i : p)
        cout << i + 1 << ' ';
    cout << '\n';
}
void print_yes(vector<int> p, vector<int> q) {
    assert(check_ii(p));
    assert(check_nice(p, q));
    cout << "Possible\n";
    print_p(p);
    print_p(q);
}
void print_no() {
    cout << "Impossible\n";
}

vector<vector<int>> make_cycles() {
    vector<vector<int>> res;
    vector<vector<int>> res2;

    vector<bool> used(n, false);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            vector<int> c;
            c.push_back(i);
            used[c.back()] = true;
            while (a[c.back()] != i) {
                c.push_back(a[c.back()]);
                used[c.back()] = true;
            }
            if (c.size() == 2)
                res2.push_back(c);
            else
                res.push_back(c);
        }
    }
    for (auto c : res2)
        res.push_back(c);
    return res;
}

vector<int> inv(vector<int> p) {
    vector<int> res(n);
    for (int i = 0; i < n; i++)
        res[p[i]] = i;
    return res;
}

void solve() {
    cin >> n;
    a.resize(n);
    for (auto &i : a)
        cin >> i, i--;

    if (n == 1 || (n == 2 && a == vector<int>{1, 0})) {
        print_no();
        return;
    }

    auto cc = make_cycles();

    vector<int> p_ord;
    for (auto c : cc) {
        reverse(c.begin(), c.end());
        if (c.size() == 2 && p_ord.size()) {
            int add = p_ord.back();
            p_ord.pop_back();
            p_ord.push_back(c[0]);
            p_ord.push_back(add);
            p_ord.push_back(c[1]);
        } else {
            for (auto i : c)
                p_ord.push_back(i);
        }
    }
    vector<int> p(n);
    for (int i = 0; i < n; i++) {
        p[p_ord[i]] = p_ord[(i + 1) % n];
    }

    vector<int> ap(n);
    for (int i = 0; i < n; i++)
        ap[i] = a[p[i]];

    auto q = inv(ap);

    print_yes(p, q);
}


signed main() {
    initIO();
    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    #ifdef DEBUG
        cerr << "Runtime is: " << fixed << setprecision(5) << clock() * 1.0 /  CLOCKS_PER_SEC << endl;
    #endif
}