#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("sse4.2")
 
#include <bits/stdc++.h>
using namespace std;
 
void initIO() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(12);
}
 
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
 
using graph = vector<vector<int>>;
 
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define f first
#define s second
 
const int mod = 1000000007;
const ld eps = 1e-9;
const ll inf = 3000000000000000007ll;
 
template<class T> inline int sz(const T &x) { return x.size(); }
 
template<class T> void read(T &x) {
    cin >> x;
}
template<class T> void print(const T &x) {
    cout << x;
}
void println() { cout << '\n'; }
 
template<class T, class ...U> void read(T &x, U&... u) {
    read(x);
    read(u...);
}
 
template<class T, class ...U> void print(const T &x, const U&... u) {
    print(x);
    print(u...);
}
 
template<class T, class ...U> void println(const T &x, const U&... u) {
    print(x);
    println(u...);
}
 
template<class T, class U> inline bool chmin(T &x, const U &y) { return y < x ? x = y, 1 : 0; }
template<class T, class U> inline bool chmax(T &x, const U &y) { return y < x ? x = y, 1 : 0; }
template<class T> inline void sort(T &x) { sort(all(x)); }
template<class T> inline void reverse(T &x) { reverse(all(x)); }
 
#ifdef DEBUG
    string pdbg(const string &x) {
        return "\"" + x + "\"";
    }
    template<class T> string pdbg(const T&x) {
        return to_string(x);
    }
    template<class T> string dbgout(const T &x) {
        return pdbg(x);
    }
    template<class T, class ...U> string dbgout(const T &x, const U&... u) {
        return pdbg(x) + ", " + dbgout(u...);
    }
    #define dbg(...) println("[", #__VA_ARGS__, "] = ", dbgout(__VA_ARGS__)), cout << flush
#else
    #define dbg(...) 0
#endif
 
bool onpc = false;
const int P = 4;
int ansx = 1e6, ansy = 1e6 - 2;
int px = -1, py = -1;
int ppx = -1, ppy = -1;
int cquery = 0;
 
ll dist2(pii a, pii b) {
    a.f -= b.f;
    a.s -= b.s;
    return a.f * ll(a.f) + a.s * ll(a.s);
}
 
string query(int x, int y) {
    ++cquery;
    assert(cquery <= 64);
    println(x, ' ', y);
    cout << flush;
    string ans = "";
    if (onpc) {
        if (x == ansx && y == ansy) {
            ans = "Znaydeno!";
        } else if (px == -1) {
            ans = "Tabilmadi";
        } else {
            auto dwas = dist2({ansx, ansy}, {px, py});
            auto dnow = dist2({ansx, ansy}, {x, y});
            if (dwas == dnow) {
                ans = "Sama distanco";
            } else if (dwas < dnow) {
                ans = "Dalej";
            } else {
                ans = "Daha yakin";
            }
        }
        px = x;
        py = y;
    } else {
        getline(cin, ans);
        if (sz(ans) && ans.back() == '\n') {
            ans.pop_back();
        }
    }
    if (ans.back() == '!') {
        exit(0);
    }
    ppx = px;
    ppy = py;
    px = x;
    py = y;
    return ans;
}
 
signed main() {
    initIO();
    const int C = 1e6;
    vector<string> ans;
    ans.pb(query(C - 1, C - 1));
    ans.pb(query(C, C));
    ans.pb(query(1, 1));
    ans.pb(query(0, 0));
    ans.pb(query(0, 0));
    string notfound = ans[0];
    string further;
    if (ans[1] == ans[3]) {
        further = ans[1];
    } else {
        for (int i = 0; i <= 1; ++i) {
            for (int j = 0; j <= 1; ++j) {
                query(i, j);
                query(C - i, C - j);
            }
        }
        assert(false);
    }
    string same = ans[4];
 
    // dbg(notfound);
    // dbg(further);
    int lx = 0, rx = C;
    int ly = 0, ry = C;
    bool flag = true;
    while (lx != rx || ly != ry) {
        // dbg(lx, ly, rx, ry);
        // dbg(rx - lx + 1, ry - ly + 1);
        int mx = lx + rx >> 1;
        int my = ly + ry >> 1;
        if (flag) {
            flag = false;
        } else {
            query(lx, ly);
        }
        auto ans1 = query(rx, ly);
        auto ans2 = query(rx, ry);
        // dbg(lx, rx, ans1);
        if (lx != rx) {
            if (ans1 == same) {
                lx = rx = mx;
            } else if (ans1 == further) {
                if (lx % 2 == rx % 2) {
                    rx = (lx + rx) / 2 - 1;
                } else {
                    rx = (lx + rx) / 2;
                }
            } else {
                if (lx % 2 == rx % 2) {
                    lx = (lx + rx) / 2 + 1;
                } else {
                    lx = (lx + rx + 1) / 2;
                }
            }
        }
        // dbg(lx, rx);
        // dbg(ly, ry, ans2);
        if (ly != ry) {
            if (ans2 == same) {
                ly = ry = my;
            } else  if (ans2 == further) {
                if (ly % 2 == ry % 2) {
                    ry = (ly + ry) / 2 - 1;
                } else {
                    ry = (ly + ry) / 2;
                }
            } else {
                if (ly % 2 == ry % 2) {
                    ly = (ly + ry) / 2 + 1;
                } else {
                    ly = (ly + ry + 1) / 2;
                }
            }
        }
        // dbg(ly, ry);
    }
    query(lx, ly);
    #ifdef DEBUG
        cerr << "Runtime is: " << fixed << setprecision(5) << clock() * 1.0 /  CLOCKS_PER_SEC << endl;
    #endif
}