#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("sse4.2")

#include <bits/stdc++.h>
using namespace std;

void initIO() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(12);
}

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

using graph = vector<vector<int>>;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define f first
#define s second

const int mod = 1000000007;
const ld eps = 1e-9;
const ll inf = 3000000000000000007ll;

template<class T> inline int sz(const T &x) { return x.size(); }

template<class T> void read(T &x) {
    cin >> x;
}
template<class T> void print(const T &x) {
    cout << x;
}
void println() { cout << '\n'; }

template<class T, class ...U> void read(T &x, U&... u) {
    read(x);
    read(u...);
}

template<class T, class ...U> void print(const T &x, const U&... u) {
    print(x);
    print(u...);
}

template<class T, class ...U> void println(const T &x, const U&... u) {
    print(x);
    println(u...);
}

template<class T, class U> inline bool chmin(T &x, const U &y) { return y < x ? x = y, 1 : 0; }
template<class T, class U> inline bool chmax(T &x, const U &y) { return y < x ? x = y, 1 : 0; }
template<class T> inline void sort(T &x) { sort(all(x)); }
template<class T> inline void reverse(T &x) { reverse(all(x)); }

#ifdef DEBUG
    string pdbg(const string &x) {
        return "\"" + x + "\"";
    }
    template<class T> string pdbg(const T&x) {
        return to_string(x);
    }
    template<class T> string dbgout(const T &x) {
        return pdbg(x);
    }
    template<class T, class ...U> string dbgout(const T &x, const U&... u) {
        return pdbg(x) + ", " + pdbg(u...);
    }
    #define dbg(...) println("[", #__VA_ARGS__, "] = ", dbgout(__VA_ARGS__)), cout << flush
#else
    #define dbg(...) 0
#endif

signed main() {
    initIO();

    int n, k;
    cin >> n >> k;

    if (n == 1) {
        if (k == 1) {
            cout << "YES" << endl;
            cout << 0 << endl;
        } else {
            cout << "NO" << endl;
        }
        return 0;
    }

    if (k == 1) {
        cout << "YES" << endl;
        cout << n << endl;
        for (int i = 0; i < n - 1; ++i) {
            cout << i + 1 << ' ' << i + 2 << '\n';
        }
        cout << n << ' ' << 1 << endl;
        return 0;
    }

    if (k > n - 1) {
        cout << "NO" << endl;
        return 0;
    }

    vector<int> p(n);
    int cur = 0;
    int first = 0;
    int last = n;
    vector<pair<int, int>> ans;
    while (cur != k && cur != k - 1) {
        for (int i = first + 1; i < last; ++i) {
            ans.push_back({first, i});
            p[first]++;
            p[i]++;
        }
        cur += 2;
        first++;
        last--;
    }
    if (cur == k - 1) {
        ans.push_back({first, first + 1});
        p[first]++;
        p[first + 1]++;
    }

    cout << "YES" << endl;
    cout << ans.size() << endl;
    for (auto p : ans) {
        cout << p.first + 1 << ' ' << p.second + 1 << '\n';
    }

    #ifdef DEBUG
        cerr << "Runtime is: " << fixed << setprecision(5) << clock() * 1.0 /  CLOCKS_PER_SEC << endl;
    #endif
}