import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class Main {
    static class Reader
    {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer st;

        String read()
        {
            if (st == null || !st.hasMoreElements()) {
                try {
                    st = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return st.nextToken();
        }

        int i()
        {
            return Integer.parseInt(read());
        }
    }

    static List<List<Integer>> towers;
    static Map<Integer, Integer> zip = new HashMap<>();

    public static void main(String[] args) {
        Reader r = new Reader();
        int n = r.i();
        towers = Stream.generate(() -> new ArrayList<Integer>())
                .limit(n).collect(Collectors.toList());
        ArrayList<Integer> allNumbers = new ArrayList<>();

        int splits = 0;

        for (int i = 0; i < n; ++i) {
            int k = r.i();

            for (int j = 0; j < k; ++j) {
                int b = r.i();
                towers.get(i).add(b);
                allNumbers.add(b);
            }
        }
        allNumbers.sort(Comparator.naturalOrder());

        for (int i = 0; i < allNumbers.size(); ++i) {
            zip.put(allNumbers.get(i), i);
        }

        for (int i = 0; i < n; ++i) {

            int last = -1;
            for (int j = 0; j < towers.get(i).size(); ++j) {
                int zipped = zip.get(towers.get(i).get(j));

                if (last != -1 && zipped - last != 1)
                    ++splits;

                last = zipped;
            }
        }

        System.out.print(splits + " " + (n - 1 + splits));
    }
}