#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
using namespace std;

vector<int> leftv;
vector<pair<int, int>> ans;

void solve(int k) {
	if (k == 0) {
		return;
	}
	if (k == 1) {
		for (int i = 0; i < leftv.size() - 1; ++i) {
			ans.emplace_back(leftv[i], leftv[i + 1]);
		}
		ans.emplace_back(leftv[leftv.size() - 1], leftv[0]);
		return;
	}
	for (int i = 0; i < leftv.size() - 1; ++i) {
		ans.emplace_back(leftv[leftv.size() - 1], leftv[i]);
	}
	leftv.pop_back();
	leftv.pop_back();
	solve(k - 2);
}

int check(int n) {
	vector<int> degs(n, 0);
	set<int> diff_deg;
	for (auto p : ans) {
		degs[p.first - 1]++;
		degs[p.second - 1]++;
	}
	for (auto i : degs) {
		diff_deg.insert(i);
	}
	return diff_deg.size();
}

int main() {
	ios_base::sync_with_stdio(false);

	int n, k;
	cin >> n >> k;

	if (k >= n) {
		cout << "NO\n";
		return 0;
	}

	for (int i = 0; i < n; ++i) {
		leftv.push_back(i + 1);
	}
	solve(k);

	cout << "YES\n" << ans.size() << "\n";

	for (auto p : ans) {
		cout << p.first << " " << p.second << "\n";
	}
	//cout << check(n);

	return 0;
}