#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <set>
#include <time.h>

using namespace std;

void solve() {
    int n;
    cin >> n;
    srand(time(nullptr));

    vector<int> A(n);
    vector<int> A_idx(n);

    for (int i = 0; i < n; ++i) {
        cin >> A[i];
        A_idx[A[i] - 1] = i;
    }

    if (n == 1 || (n == 2 && A[0] == 2)) {
        printf("Impossible\n");
        fflush(stdout);
        return;
    }

    vector<int> P(n);
    vector<int> Q(n);

    set<int> free_q;

    for (int i = 0; i < n; ++i) {
        free_q.insert(i + 1);
    }

    for (int i = 0; i < n; ++i) {
        bool is_found = false;
        auto it = free_q.lower_bound(rand() % n);
        while (!is_found) {
            if (it == free_q.end()) it = free_q.begin();

            if (*it == i + 1) {
                it++;
                continue;
            }

            if (A_idx[i] + 1 == *it){
                it++;
                continue;
            }

            is_found = true;
            Q[i] = *it;
            P[Q[i] - 1] = A_idx[i] + 1;
            free_q.erase(*it);
        }
    }

    cout << "Possible\n";

    for (int i = 0; i < n; ++i) {
        cout << P[i] << " ";
    }

    cout << endl;

    for (int i = 0; i < n; ++i) {
        cout << Q[i] << " ";
    }
    cout << endl;

    fflush(stdout);
}


int main() {
#ifdef DEBUG

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int test_count = 1;
    scanf("%d", &test_count);

    for (int i = 0; i < test_count; ++i) {
        solve();
    }

    return 0;
}
