#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

bool is_good_permut(vector<int> *A, vector<int> *permut) {
    for (int i = 0; i < A->size(); ++i) {
        if (A->at(i) == permut->at(i)) return false;
    }
    return true;
}

void solve() {
    int n;
    scanf("%d", &n);

    vector<int> A(n);
    vector<int> A_idx(n);
    for (int i = 0; i < n; ++i) {
        scanf("%d", &A[i]);
        A_idx[A[i] - 1] = i;
    }

    if (n == 1 || (n == 2 && A[0] == 2)) {
        printf("Impossible\n");
        return;
    }

    printf("Possible\n");

    vector<int> permut(n);
    vector<int> permut_idx(n);
    for (int i = 2; i <= n; ++i) {
        for (int j = 0; j < n; ++j) {
            permut[j] = i + j == n ? n : (i + j) % n;
            permut_idx[permut[j] - 1] = j;
        }
        if (is_good_permut(&A, &permut)) break;
    }

    for (int i = 0; i < n; ++i) {
        printf("%d ", permut_idx[i] + 1);
    }

    vector<int> As(n);
    for (int i = 0; i < n; ++i) {
        As[permut_idx[i]] = A[i];
    }

    printf("\n");

    for (int i = 0; i < n; ++i) {
        printf("%d ", As[i]);
    }
    printf("\n");
}


int main() {
#ifdef DEBUG

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int test_count = 1;
    scanf("%d", &test_count);

    for (int i = 0; i < test_count; ++i) {
        solve();
    }

    return 0;
}
