#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

bool is_good_permut(vector<int> *permut) {
    for (int i = 0; i < permut->size(); ++i) {
        if (i + 1 == permut->at(i)) return false;
    }
    return true;
}

void solve() {
    int n;
    scanf("%d", &n);

    vector<int> A(n);
    vector<int> A_idx(n);
    vector<int> res_seq(n);
    for (int i = 0; i < n; ++i) {
        scanf("%d", &A[i]);
        A_idx[A[i] - 1] = i;
        res_seq[i] = i + 1;
    }

    if (n == 1 || (n == 2 && A[0] == 2)) {
        printf("Impossible\n");
        return;
    }

    vector<int> permut(n);
    vector<int> permut_idx(n);
    vector<int> As(n);
    bool is_good_permut_found = false;

    for (int i = 2; i <= n; ++i) {
        for (int j = 0; j < n; ++j) {
            permut[j] = i + j == n ? n : (i + j) % n;
            permut_idx[permut[j] - 1] = j;
        }

        for (int j = 0; j < n; ++j) {
            As[permut_idx[j]] = A[j];
        }

        if (is_good_permut(&permut) && is_good_permut(&As)) {
            is_good_permut_found = true;
            break;
        }
    }

    for (int i = n; i >= 2 && !is_good_permut_found; --i) {
        for (int j = 0; j < n; ++j) {
            permut[j] = (i - j + n) % n;
            if (permut[j] == 0) permut[j] = n;
            permut_idx[permut[j] - 1] = j;
        }

        for (int j = 0; j < n; ++j) {
            As[permut_idx[j]] = A[j];
        }

        if (is_good_permut(&A) && is_good_permut(&As)) {
            is_good_permut_found = true;
            break;
        }
    }

    if (!is_good_permut_found) {
        printf("Impossible\n");
        return;
    }

    printf("Possible\n");


    for (int i = 0; i < n; ++i) {
        printf("%d ", permut_idx[i] + 1);
    }

    printf("\n");

    for (int i = 0; i < n; ++i) {
        printf("%d ", As[i]);
    }
    printf("\n");
}


int main() {
#ifdef DEBUG

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int test_count = 1;
    scanf("%d", &test_count);

    for (int i = 0; i < test_count; ++i) {
        solve();
    }

    return 0;
}
