#pragma warning (disable : 4996)

#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>

using namespace std;

using ll = long long;

int main()
{
	//freopen("input.txt", "r", stdin);

	int t;
	cin >> t;
	for (int z = 0; z < t; z++) {
		int n;
		cin >> n;
		vector<int> cards(n);
		for (int i = 0; i < n; i++) {
			cin >> cards[i];
			cards[i]--;
		}

		vector<int> composition(n);
		for (int i = 0; i < n; i++) {
			int card = cards[i];
			composition[card] = i;
		}

		vector<int> p(n);
		vector<int> q(n);

		for (int i = 0; i < n; i++) {
			p[i] = q[i] = -1;
		}

		int pos = 0;
		for (int i = 4; i < n; i++) {
			int compCard = composition[i];

			while (pos == i || pos == compCard || p[pos] != -1) pos = (pos + 1) % n;
			
			p[pos] = compCard;
			q[i] = pos;
		}

		vector<int> pLastPos;
		for (int i = 0; i < n; i++) {
			if (p[i] == -1) {
				pLastPos.push_back(i);
			}
		}

		bool isFound = false;
		int permSize = min(n, 4);
		vector<int> permutations;
		int fact = 1;
		for (int i = 0; i < permSize; i++) {
			permutations.push_back(0);
			fact *= i + 1;
		}

		permutations[0] = -1;

		bool found = false;
		while (!found && fact > 0) {
			for (int i = 0; i < permSize; i++) {
				permutations[i]++;
				if (permutations[i] == permSize) {
					permutations[i] = 0;
				}
				else break;
			}

			bool check = true;
			for (int i = 0; i < permSize; i++) {
				for (int j = i + 1; j < permSize; j++) {
					if (permutations[i] == permutations[j]) {
						check = false;
						break;
					}
				}
			}

			if (!check) continue;
			fact--;

			check = true;
			for (int i = 0; i < permSize; i++) {
				int perm = permutations[i];
				int pos = pLastPos[perm];
				int val = composition[i];

				if (i == pos || pos == val) {
					check = false;
					break;
				}

				p[pos] = val;
				q[i] = pos;
			}

			if (check) {
				found = true;
			}
		}

		if (!found) {
			cout << "Impossible" << endl;
		}
		else {
			cout << "Possible" << endl;
			cout << p[0] + 1;
			for (int i = 1; i < n; i++) {
				cout << " " << p[i] + 1;
			}
			cout << endl;

			cout << q[0] + 1;
			for (int i = 1; i < n; i++) {
				cout << " " << q[i] + 1;
			}
			cout << endl;
		}
	}

	return 0;
}
