import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Comparator;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class Main {

    private static BufferedReader br=new BufferedReader(new InputStreamReader(System.in));
    private static StringTokenizer st=null;

    private static String readLine() throws IOException {
        st=null;
        return br.readLine();
    }

    private static String readToken() throws IOException {
        if(st==null||!st.hasMoreTokens())
            st=new StringTokenizer(br.readLine());
        return st.nextToken();
    }

    private static int readInt() throws IOException {
        return Integer.parseInt(readToken());
    }

    private static long readLong() throws IOException {
        return Long.parseLong(readToken());
    }

    private static double readDouble() throws IOException {
        return Double.parseDouble(readToken());
    }


    public static void main(String[] args) throws IOException {
        int tests=readInt();
        for(int test=0;test<tests;test++) {
            int length=readInt();
            int[] valuesA=new int[length];
            int[] reversesA=new int[length];
            for(int i=0;i<length;i++) {
                valuesA[i]=readInt()-1;
                reversesA[valuesA[i]]=i;
            }
            if(length==1 || (length==2 && valuesA[0]==1))
                System.out.println("Impossible");
            else if(length==3 && (valuesA[0]+2*valuesA[1])%3==1)
                System.out.println("Impossible");
            else {
                System.out.println("Possible");
                int[] moves=new int[length];
                int[] moveCounts=new int[length];
                int[] lastMoveId=new int[length];
                for(int i=0;i<length;i++) {
                    int move = (valuesA[i] + length - i) % length;
                    moves[i]= move;
                    moveCounts[move]++;
                    lastMoveId[move]=i;
                }
                int move=-1;
                int bestMove=2;
                for(int i=1;i<length&&bestMove>=1;i++) {
                    if(moveCounts[i]<bestMove) {
                        bestMove=moveCounts[i];
                        move=i;
                    }
                }

                int[] reversesP=new int[length];
                int[] valuesP=new int[length];
                int[] reversesQ=new int[length];
                int[] valuesQ=new int[length];
                for(int i=0;i<length;i++) {
                    reversesP[i]=(i+move)%length;
                }

                if (bestMove==1) {
                    int swap1=valuesP[lastMoveId[move]];
                    int swap2=-1;
                    for(int i=0;i<length&&swap2==-1;i++) {
                        if(reversesP[swap1]!=i&&i!=lastMoveId[move])
                            swap2=i;
                    }

                    int temp=reversesP[swap1];
                    reversesP[swap1]=reversesP[swap2];
                    reversesP[swap2]=temp;
                }

                for(int i=0;i<length;i++) {
                    valuesP[reversesP[i]]=i;
                }

                for(int i=0;i<length;i++) {
                    valuesQ[i]=reversesP[reversesA[i]];
                }

                for(int i=0;i<length;i++) {
                    System.out.print((valuesP[i])+1+" ");
                }
                System.out.println();


                for(int i=0;i<length;i++) {
                    System.out.print((valuesQ[i]+1)+" ");
                }
                System.out.println();
            }
        }
    }
}