import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Comparator;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class Main {

    private static BufferedReader br=new BufferedReader(new InputStreamReader(System.in));
    private static StringTokenizer st=null;

    private static String readLine() throws IOException {
        st=null;
        return br.readLine();
    }

    private static String readToken() throws IOException {
        if(st==null||!st.hasMoreTokens())
            st=new StringTokenizer(br.readLine());
        return st.nextToken();
    }

    private static int readInt() throws IOException {
        return Integer.parseInt(readToken());
    }

    private static long readLong() throws IOException {
        return Long.parseLong(readToken());
    }

    private static double readDouble() throws IOException {
        return Double.parseDouble(readToken());
    }

    static class Cube implements Comparable<Cube> {
        int value;
        int towerId;

        int lastValue;
        public Cube(int value, int towerId, int lastValue) {
            this.value = value;
            this.towerId = towerId;
            this.lastValue=lastValue;
        }

        @Override
        public int compareTo(Cube o) {
            return value-o.value;
        }
    }

    public static void main(String[] args) throws IOException {
        int towers=readInt();
        TreeSet<Cube> set=new TreeSet<>();
        for(int i=0;i<towers;i++) {
            int towerSize=readInt();
            int lastValue=2_000_000_000;
            for(int j=0;j<towerSize;j++) {
                int value=readInt();
                set.add(new Cube(value,i,lastValue));
                lastValue=value;
            }
        }
        int lastTower=-1;
        int fragments=0;
        int lastValue=-2_000_000_000;
        for(Cube cube:set) {
            if(lastTower!=cube.towerId||lastValue!=cube.lastValue) {
                lastTower=cube.towerId;
                fragments++;
            }
            lastValue=cube.value;
        }
        System.out.print(fragments-towers);
        System.out.print(" ");
        System.out.println(fragments-1);
    }
}