import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {

        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        long n = Long.parseLong(reader.readLine());
        List<List<Long>> lists = new LinkedList<>();
        for (int i = 0; i < n; i++) {
            lists.add(new ArrayList<>( Arrays.stream(reader.readLine().split(" ")).map(Long::parseLong).toList() ));
            lists.set(i, lists.get(i).subList(1, lists.get(i).size()));
        }
        Towers towers = new Towers(lists);

        long splitsCount = 0;
        long combinesCount = 0;

        splitsCount += towers.normalize();

        Set<Long> sdelal = new HashSet<>();
        while (true) {
            long minFloor = 0;
            int minFloorTowerIndex = -1;

            if (sdelal.size() == towers.size())
                break;

            for (int i = 0; i < towers.size(); i++) {
                List<Long> tower = towers.get(i);
                if (!sdelal.contains(tower.get(tower.size() - 1))) {
                    sdelal.add(tower.get(tower.size() - 1));
                    minFloor = tower.get(tower.size() - 1);
                    minFloorTowerIndex = i;
                    break;
                }
            }

            /*
            for (int i = 0; i < towers.size(); i++) { // ищу минимальный пол
                // Если разделил то i - 1;

                List<Long> tower = towers.get(i);
                if (tower.get(tower.size() - 1) < minFloor) {
                    minFloor = tower.get(tower.size() - 1);
                    minFloorTowerIndex = i;
                }
            }*/

            long closestToMinFloor = 0;
            int closestToMinFloorIndex = -1;
            int closestTowerIndex = -1;
            for (int i = 0; i < towers.size(); i++) { // ищу минимальный пол
                List<Long> tower = towers.get(i);
                for (int j = 0; j < tower.size(); j++) {
                    if (tower.get(j) < minFloor && tower.get(j) > closestToMinFloor && minFloorTowerIndex != i) {
                        closestToMinFloor = tower.get(j);
                        closestToMinFloorIndex = j;
                        closestTowerIndex = i;
                    }
                }
            }

            if (closestTowerIndex != -1) {
                if (closestToMinFloorIndex == towers.get(closestTowerIndex).size() - 1) { // не разделяем в конце а соединяем
                    //towers.combine(minFloorTowerIndex, closestTowerIndex);
                    //splitsCount += towers.normalize();
                    //combinesCount++;
                } else {
                    splitsCount += towers.split(closestTowerIndex, closestToMinFloorIndex + 1);
                }
            }
        }

        while (towers.size() > 1) { // соединяю
            long minFloor = towers.get(0).get(towers.get(0).size() - 1);
            //int minFloorTowerIndex = -1;
            //for (int i = 0; i < towers.size(); i++) { // ищу минимальный пол
            //    List<Long> tower = towers.get(i);
            //    if (tower.get(tower.size() - 1) < minFloor) {
            //        minFloor = tower.get(tower.size() - 1);
            //        minFloorTowerIndex = i;
            //    }
            //}

            long closestToMinFloor = Long.MAX_VALUE;
            int closestTowerIndex = -1;
            for (int i = 0; i < towers.size(); i++) { // ищу минимальный пол
                List<Long> tower = towers.get(i);
                if (tower.get(0) > minFloor && tower.get(0) < closestToMinFloor) {
                    closestToMinFloor = tower.get(0);
                    closestTowerIndex = i;
                }
            }

            towers.combine(0, closestTowerIndex);
            combinesCount++;
        }

        System.out.println(splitsCount + " " + combinesCount);
    }

    static class Towers {
        private final List<List<Long>> towers;

        public Towers(List<List<Long>> towers) {
            this.towers = towers;
        }

        public int size() {
            return towers.size();
        }

        public List<Long> get(int index) {
            return towers.get(index);
        }

        public int split(int index, int elemPos) {
            List<Long> tower = new ArrayList<>(towers.get(index));
            if (tower.size() < elemPos + 1)
                return 0;
            else {
                towers.remove(index);
                if (elemPos > 0)
                    towers.add(tower.subList(0, elemPos));
                towers.add(tower.subList(elemPos, tower.size()));
                return 1;
            }
        }

        public void combine(int index1, int index2) {
            List<Long> tower1 = new ArrayList<>(towers.get(index1));
            List<Long> tower2 = new ArrayList<>(towers.get(index2));
            int cal = Math.min(index1, index2);
            int nal = Math.max(index1, index2);
            towers.remove(nal);
            towers.remove(cal);
            tower1.addAll(tower2);
            towers.add(tower1);
        }

        public int normalize() {
            int splitsCount = 0;
            for (int i = 0; i < towers.size(); i++) {
                for (int j = 0; j < towers.get(i).size() - 1; j++) {
                    if (towers.get(i).get(j) >= towers.get(i).get(j + 1)) {
                        splitsCount += split(i, j + 1);
                        i = Math.min(i, j + 1) - 1;
                        break;
                    }
                }
            }
            return splitsCount;
        }

    }

}