import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

import static java.lang.System.out;

public class K {
    static QuickScanner scn = new QuickScanner();

    public static void main(String[] args) {
        int t = 1;

        while (t > 0) {
            solve();
            t--;
        }

        scn.close();
    }

    static class Node {
        int id;
        Node(int id) {
            this.id = id;
        }
        List<Node> friends = new ArrayList<>();
        int deg() {
            return friends.size();
        }
        void add(Node node) {
            if (node != null) friends.add(node);
        }
    }

    static int n;
    static Node[] nodes;
    static boolean[] visited;
//    static int[][] mat;

    static void printNodes() {
        int counter = 0;
        StringBuilder sb = new StringBuilder();
        for (int i = 1; i <= n; i++) {
            Node node = nodes[i];
            visited[node.id] = true;
            for (Node friend : node.friends) {
                if (!visited[friend.id]) {
                    counter++;
                    sb.append(node.id).append(" ").append(friend.id).append("\n");
                }
            }
        }

        out.println(counter);
        out.print(sb);
    }

    static void solve() {
        n = scn.nextInt();
        int k = scn.nextInt();
//        mat = new int[n+1][n+1];

        visited = new boolean[n+1];

        nodes = new Node[n+1];

        if (n==1) {
            out.println("NO");
        }

        for (int i = 1; i <= n; i++) {
            Node node = new Node(i);
            nodes[i] = node;
//            if (i != 1) {
//                node.add(nodes[i-1]);
//                nodes[i-1].add(node);
//            }
        }

//        if (k==1) {
//            nodes[n].add(nodes[1]);
//            nodes[1].add(nodes[n]);
//            out.println("YES");
//            printNodes();
//            return;
//        }

        nodes[1].add(nodes[2]);
        nodes[2].add(nodes[1]);
        int deg = 0;
        int i = 2;
        while (deg < k - 1 && i <= n) {
            Node node = nodes[i];
            deg++;
            if (i + deg > n) {
                out.println("NO");
                return;
            }
            for (int j = i; j <= i+deg && j <= n; j++) {
                node.add(nodes[j]);
                nodes[j].add(node);
            }
            i += deg;
        }

        if (deg == k - 1) {
            for (int j = i+1; j <= n; j++) {
                nodes[j].add(nodes[j-1]);
                nodes[j-1].add(nodes[j]);
            }
            if (k == 1 && n > 2) {
                nodes[1].add(nodes[n]);
                nodes[n].add(nodes[1]);
            }
            out.println("YES");
            printNodes();
        } else {
            out.println("NO");
        }

//        printNodes();

//        if (deg < k) {
//            out.println("NO");
//        } else {
//            out.println("YES");
//        }
    }

    static class QuickScanner {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer st = new StringTokenizer("");

        String next() {
            while (!st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException ignored) {}
            }
            return st.nextToken();
        }

        int nextInt() { return Integer.parseInt(next()); }

        void close() {
            try {
                br.close();
            } catch (IOException ignored) {}
        }
    }
}