#include <iostream>
#include <string>
#include <algorithm>
#include <map>

using namespace std;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int n;
	cin >> n;
	
	int totalSize = 0;

	constexpr int MAX_SIZE = 1e4;

	int arr[MAX_SIZE];

	int* towerSizes = new int[n];
	int** towers = new int* [n];

	for (int i = 0, j = 0; i < n; i++)
	{
		int size;
		cin >> size;

		totalSize += size;

		towerSizes[i] = size;
		towers[i] = new int[size];

		for (int k = 0; k < size; k++, j++) 
		{
			cin >> arr[j];
			towers[i][k] = arr[j];
		}
	}

	sort(arr, arr + totalSize);
	map<int, int> nexts;

	for (int i = 0; i < totalSize - 1; i++) nexts[arr[i]] = arr[i + 1];

	nexts[arr[totalSize - 1]] = -1;

	int splits = 0;

	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < towerSizes[i] - 1; j++)
		{
			int current = towers[i][j];
			int nextInTower = towers[i][j + 1];

			if (nexts[current] != nextInTower) splits++;
		}
	}

	int combines = n + splits - 1;

	cout << splits << " " << combines << endl;
}